/*
 * Project: DELTA - Guideline Markup Tool / Version: 2.7.3.#452
 * Author: Peter Votruba
 * Date: 29.08.2003
 * Time: 11:22:27
 */
package at.ac.tuwien.asgaard.delta.gui;

//import at.ac.tuwien.asgaard.xmlgrammar.dtd.DTDGrammar;

import at.ac.tuwien.asgaard.delta.gui.actions.EmptyAction;
import at.ac.tuwien.asgaard.delta.gui.actions.SimpleAction;
import at.ac.tuwien.asgaard.delta.gui.actions.xhtml.*;
import at.ac.tuwien.asgaard.delta.gui.actions.xhtml.html.HTMLCreateOverlappingLinksMode;
import at.ac.tuwien.asgaard.delta.gui.actions.xhtml.html.HTMLProvideLinkIDForOtherSideMode;
import at.ac.tuwien.asgaard.delta.gui.actions.xhtml.html.HTMLRemoveLinksAction;
import at.ac.tuwien.asgaard.delta.gui.actions.xhtml.html.HTMLShowInBrowserAction;
import at.ac.tuwien.asgaard.delta.gui.actions.xhtml.xml.*;
import at.ac.tuwien.asgaard.delta.gui.actions.xhtml.xml.view.*;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.delta.gui.misc.DeltaFileChooser;
import at.ac.tuwien.asgaard.delta.gui.misc.DeltaHyperlinkEvent;
import at.ac.tuwien.asgaard.delta.gui.xml.XMLAttributesTableModel;
import at.ac.tuwien.asgaard.delta.gui.xml.XMLTreeNode;
import at.ac.tuwien.asgaard.delta.util.EnvironmentProperties;
import at.ac.tuwien.asgaard.delta.util.GlobalObjects;
import at.ac.tuwien.asgaard.delta.util.Preferences;
import at.ac.tuwien.asgaard.delta.xmlBeans.xmlLanguage.*;
import at.ac.tuwien.asgaard.swing.*;
import at.ac.tuwien.asgaard.swing.plaf.LocalAcceleratorMenuItemUI;
import at.ac.tuwien.asgaard.swing.selectable.RadioButtonAbstractAction;
import at.ac.tuwien.asgaard.swing.selectable.SelectableAction;
import at.ac.tuwien.asgaard.swing.selectable.SelectableRadioButtonMenuItem;
import at.ac.tuwien.asgaard.util.FileUtils;
import at.ac.tuwien.asgaard.util.Log;
import at.ac.tuwien.asgaard.util.MiscUtils;
import at.ac.tuwien.asgaard.util.WLD;
import at.ac.tuwien.asgaard.util.xml.dtd.DTDHelperXML4J;

import net.socialchange.doctype.Doctype;
import org.w3c.dom.Element;
import org.w3c.dom.Node;

import java.awt.*;
import java.awt.event.*;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.text.DecimalFormat;
import java.text.MessageFormat;
import java.util.*;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.undo.*;

/**
 * Class DeltaSideController ... todo
 *
 * @author Peter Votruba
 * @version 2.7.3.#452
 */
public final class DeltaSideController {
// public DTDGrammar dtdGrammar;

	public final String sideName;
	public MainFrame.DeltaSide thisSide, otherSide;
	public DeltaSideController otherSideController;
	public final DTDHelperXML4J dtdHelper;
	int thisSideIndex, otherSideIndex;
	int type;
	private boolean active;
	public boolean sourceViewNeedsUpdateXHTMLSource, sourceViewNeedsUpdateDTDSource, sourceViewNeedsUpdateDTDReport, textViewNeedsUpdateXHTMLSource, textViewNeedsUpdateDTDSource;

	public XHTMLOpenFileAction aOpen;
	public XHTMLReloadFileAction aReload;
	public XHTMLSaveFileAction aSave;
	public XHTMLCloseFileAction aClose;
	Action aReopen, aRevert, aSaveAs, aSynchronizeLinks, aInsertNewDELTALink, aActivateLinks;
	public XMLNewEmptyFileAction aXMLNewEmptyFile;
	public Action aGoBack, aGoForward;
	public XHTMLSwitchToViewerAction aSwitchToViewer;
	public SelectableAction aSwitchToHTMLOutput, aSwitchToTextOutput;
	public SelectableAction aXMLDELTALinksVisualizationDown, aXMLDELTALinksVisualizationUp,
		aXMLShowXPathBar, aXMLShowTreePathBar, aXMLShowAutoXPathBar;
	Action aXMLValidateSubTree, aXMLRemoveNode, aXMLDuplicateNode, aXMLSetRootTreeNode, aXMLAttributeAdd, aXMLAttributeRemove, aXMLChangeTextValue, aXMLAddRequiredContent;
	Action aHTMLRemoveLinks, aXMLGoToElementDefinitionInDTDSource, aHTMLShowInBrowser;
	public XMLJumpToElementDefinitionInDTDReportAction aXMLGoToElementDefinitionInDTDReport;
	public XMLEvaluateXPathExpressionAction aXMLEvaluateXPathExpression;
	XMLCommentElementAction aXMLCommentElement;
	Action aHighlightAllLinks, aHighlightDeadLinks, aHighlightSameLinks, aXMLHighlightXPath, aXMLHighlightXQuery, aXMLTreeApplySummarizeXSL, aXMLTreeExpandAll,
	aXMLTreeCollapseAll, aXMLTreeExpandAllDescendants, aXMLTreeCollapseAllDescendants,
	aXMLTreeExpandAllXPath, aXMLTreeCollapseAllXPath, aXMLTreeShowXPath, aXMLTreeHideXPath, aXMLTreeShowAllTreeNodes;
	SelectableAction aXMLTreeShowDocumentNode, aXMLTreeShowCommentNodes, aXMLTreeShowTextNodes, aXMLTreeShowCDATANodes, aXMLTreeShowPINodes;
	Action aXMLTreeUnloadSummarizeXSL, aXMLXSLTransform, aXMLJumpToLineNumber;
	SelectableAction XML_SHOW_ALL_ACTION, BASE_ICONSET_ACTION;
	SelectableAction aHTMLCreateOverlappingLinksMode, aHTMLProvideLinkIDForOtherSideMode;

	private Action ADD_FILTER_DEF_ACTION, ADD_SUMMARIZE_DEF_ACTION, ADD_HIGHLIGHT_DEF_ACTION, ADD_FOLDING_DEF_ACTION, ADD_STYLESHEET_DEF_ACTION;

	private static Action NEW_XML_LANGUAGE_MENU_ACTION = new SimpleAction("Create new XML Language ...", MainImages.NEW_ICON, 'c',
			"Create a new XML Language") {
		protected void simpleActionPerformed() {
			MainController.aOptionsLanguageShowPropertiesDialog.newXMLLanguage();
		}
	};

	public XmlLanguage currentXMLLanguage;
	private Doctype currentDocType; // should be null if current file is HTML file
	public ExtendedButtonGroup summarizeDefListButtonGroup, summarizeDefListPopupButtonGroup;
	final MouseListener focusChangeMouseListener;
	private final HyperlinkListener gmtViewHyperlinkListener;
	private final ChangeListener gmtViewChangeListener;
	private ActionListener recentFileOpenActionListener;
	private final UndoableEditListener undoHandler;

	Action aShowFormattedSource, aShowPlainSource, aXMLShowFormattedDTDSource, aXMLShowDTDReport, aXMLShowPlainDTDSource;
	Action aXMLTreeGotoParent, aXMLTreeGotoNextSibling, aXMLTreeGotoPreviousSibling;
	Action aMaximzeViewSize, aRestoreViewSize, aSourceToBrowser, aSourceExport;
	public DeltaSideController styleSheetSourceSideController;

	DeltaSideController(final int sideIndex) {
		thisSideIndex = sideIndex;
		otherSideIndex = 1 - thisSideIndex;
		sourceViewNeedsUpdateXHTMLSource = sourceViewNeedsUpdateDTDSource =
				sourceViewNeedsUpdateDTDReport = textViewNeedsUpdateXHTMLSource = textViewNeedsUpdateDTDSource = true;
		dtdHelper = new DTDHelperXML4J(MainController.preferences.getInt(Preferences.KEY_XML_DTD_STATE));

		sideName = GUIConstants.SIDE_NAMES[sideIndex];
		type = GUIConstants.EMPTY;
		setInactive();

		focusChangeMouseListener = new MouseAdapter() {
			public void mousePressed(MouseEvent evt) {
				if (type != GUIConstants.EMPTY)
					if (evt.getSource() instanceof JButton) {
						JButton button = (JButton) evt.getSource();
						if (!(button.getAction() instanceof BothSidesAction))
							MainController.setActiveSideIndex(sideIndex);
					} else
						MainController.setActiveSideIndex(sideIndex);
			}
		};
		gmtViewChangeListener = new DeltaViewChangeListener();
		gmtViewHyperlinkListener = new DeltaViewHyperlinkListener();
		undoHandler = new MainController.UndoHandler(thisSideIndex);
	}

	void init() {
		thisSide = MainController.deltaSides[thisSideIndex];
		otherSide = MainController.deltaSides[otherSideIndex];
		otherSideController = MainController.deltaSideController[otherSideIndex];
		summarizeDefListButtonGroup = new ExtendedButtonGroup();
		summarizeDefListPopupButtonGroup = new ExtendedButtonGroup();

		initActions();
		installKeyboardActions();

		if (MainController.stateProperties.getBoolean(Preferences.KEY_XML_SHOW_XPATH_BAR[thisSideIndex]))
			thisSide.showXPathBar(true);
		if (MainController.stateProperties.getBoolean(Preferences.KEY_XML_SHOW_TREEPATH_BAR[thisSideIndex]))
			thisSide.showTreePathBar(true);
		else if (MainController.stateProperties.getBoolean(Preferences.KEY_XML_SHOW_AUTOXPATH_BAR[thisSideIndex]))
			thisSide.showAutoXPathBar(true);
	}

	void postInit() {
		buildRecentFilesMenus();

		boolean langAvailable = MainController.xmlLanguages.size() > 0;
		thisSide.jMenuNewFromOtherLang.setEnabled(langAvailable);
		if (langAvailable)
			buildNewFromTemplateOrOtherLangMenus();
	}

	private void initActions() {
		aXMLNewEmptyFile = new XMLNewEmptyFileAction(thisSideIndex, null);
		aOpen = new XHTMLOpenFileAction(thisSideIndex);
		aReopen = new EmptyAction("Reopen", MainImages.REOPEN_ICON, 'P', "Reopen File", "List of previously opened files.");
		aReload = new XHTMLReloadFileAction(thisSideIndex);
		aRevert = new XHTMLRevertFileAction(thisSideIndex);
		aSave = new XHTMLSaveFileAction(thisSideIndex);
		aSaveAs = new XHTMLSaveFileAsAction(thisSideIndex);
		aClose = new XHTMLCloseFileAction(thisSideIndex);

		aGoBack = new XHTMLGoBackAction(thisSideIndex);
		aGoForward = new XHTMLGoForwardAction(thisSideIndex);
		aSwitchToViewer = new XHTMLSwitchToViewerAction(this);
		aSwitchToHTMLOutput = new XHTMLViewSwitchToHTMLOutputAction(this);
		aSwitchToTextOutput = new XHTMLViewSwitchToTextOutputAction(this);
		aShowFormattedSource = new XHTMLViewShowFormattedSourceAction(thisSideIndex);
		aShowPlainSource = new XHTMLViewShowPlainSourceAction(thisSideIndex);
		aMaximzeViewSize = new XHTMLMaximizeViewAction(thisSideIndex);
		aRestoreViewSize = new XHTMLRestoreViewSizeAction(thisSideIndex);
		aXMLShowFormattedDTDSource = new XMLViewShowFormattedDTDSourceAction(thisSideIndex);
		aXMLShowDTDReport = new XMLViewShowDTDReportAction(thisSideIndex);
		aXMLShowPlainDTDSource = new XMLViewShowPlainDTDSourceAction(thisSideIndex);

		aXMLXSLTransform = new XMLTransformSubtreeAction(thisSideIndex);
		aSourceToBrowser = new XHTMLShowHTMLSourceInBrowserAction(thisSideIndex);
		aSourceExport = new XHTMLExportHTMLSourceAction(thisSideIndex);
		aInsertNewDELTALink = new XHTMLInsertNewLinkAction(thisSideIndex);
		aSynchronizeLinks = new XHTMLSynchronizeLinksAction(thisSideIndex);
		aActivateLinks = new XHTMLActivateLinksAction(thisSideIndex);
		aXMLTreeShowDocumentNode = new XMLTreeShowDocumentNode(thisSideIndex);
		aXMLTreeShowCommentNodes = new XMLTreeShowCommentNodes(thisSideIndex);
		aXMLTreeShowTextNodes = new XMLTreeShowTextNodes(thisSideIndex);
		aXMLTreeShowCDATANodes = new XMLTreeShowCDATANodes(thisSideIndex);
		aXMLTreeShowPINodes = new XMLTreeShowPINodes(thisSideIndex);
		aXMLTreeShowAllTreeNodes = new XMLTreeShowAllTreeNodes(thisSideIndex);
		aXMLTreeShowXPath = new XMLTreeFilterShowXPath(thisSideIndex);
		aXMLTreeHideXPath = new XMLTreeFilterHideXPath(thisSideIndex);
		aXMLDELTALinksVisualizationUp = new XMLDELTALinksVisualizationUpAction();
		aXMLDELTALinksVisualizationDown = new XMLDELTALinksVisualizationDownAction();
		aXMLAddRequiredContent = new XMLAddRequiredContentAction(thisSideIndex); // is currently not used
		aXMLRemoveNode = new XMLRemoveNodeAction(thisSideIndex);
		aXMLDuplicateNode = new XMLDuplicateNodeAction(thisSideIndex);
		aXMLSetRootTreeNode = new XMLTreeSetRootTreeNodeAction(thisSideIndex);
		aXMLAttributeAdd = new XMLAddAttributeAction(thisSideIndex);
		aXMLAttributeRemove = new XMLRemoveAttributeAction(thisSideIndex);
		aXMLChangeTextValue = new XMLChangeTextValueAction(thisSideIndex);
		aXMLValidateSubTree = new XMLValidateSubTreeAction(thisSideIndex);
		aHTMLRemoveLinks = new HTMLRemoveLinksAction(thisSideIndex);
		aXMLHighlightXPath = new XMLTreeHighlightXPath(thisSideIndex);
		aXMLHighlightXQuery = new XMLTreeHighlightXQuery(thisSideIndex);
		aHighlightAllLinks = new XHTMLHighlightAllLinksAction(thisSideIndex);
		aHighlightDeadLinks = new XHTMLHighlightDeadLinksAction(thisSideIndex);
		aHighlightSameLinks = new XHTMLHighlightSameLinksAction(thisSideIndex);
		aXMLTreeGotoParent = new XMLTreeGotoParent(thisSideIndex);
		aXMLTreeGotoNextSibling = new XMLTreeGotoNextSibling(thisSideIndex);
		aXMLTreeGotoPreviousSibling = new XMLTreeGotoPreviousSibling(thisSideIndex);
		aXMLTreeExpandAll = new XMLTreeFoldingExpandAll(thisSideIndex);
		aXMLTreeCollapseAll = new XMLTreeFoldingCollapseAll(thisSideIndex);
		aXMLTreeExpandAllDescendants = new XMLTreeFoldingExpandAllDescendants(thisSideIndex);
		aXMLTreeCollapseAllDescendants = new XMLTreeFoldingCollapseAllDescendants(thisSideIndex);
		aXMLTreeExpandAllXPath = new XMLTreeFoldingExpandAllXPath(thisSideIndex);
		aXMLTreeCollapseAllXPath = new XMLTreeFoldingCollapseAllXPath(thisSideIndex);
		aXMLTreeApplySummarizeXSL = new XMLTreeSummarizeApplyXSL(thisSideIndex);
		aXMLShowXPathBar = new XMLShowXPathBarAction(thisSideIndex);
		aXMLShowTreePathBar = new XMLShowTreePathBarAction(thisSideIndex);
		aXMLShowAutoXPathBar = new XMLShowAutoXPathBarAction(thisSideIndex);
		aXMLEvaluateXPathExpression = new XMLEvaluateXPathExpressionAction(thisSideIndex);
		aXMLGoToElementDefinitionInDTDReport = new XMLJumpToElementDefinitionInDTDReportAction(thisSideIndex);
		aXMLGoToElementDefinitionInDTDSource = new XMLJumpToElementDefinitionInDTDSourceAction(thisSideIndex);
		aXMLCommentElement = new XMLCommentElementAction(thisSideIndex);
		aXMLJumpToLineNumber = new XMLJumpToElementOnLineNumberAction(thisSideIndex);

		aHTMLShowInBrowser = new HTMLShowInBrowserAction(thisSideIndex);
		aHTMLCreateOverlappingLinksMode = new HTMLCreateOverlappingLinksMode(thisSideIndex);
		aHTMLProvideLinkIDForOtherSideMode = new HTMLProvideLinkIDForOtherSideMode(thisSideIndex);

		XML_SHOW_ALL_ACTION = new RadioButtonAbstractAction("No Filter", MainImages.TREE_VIEW_ICON, 'N', "removes currently set filter") {
			public void stateChanged(ChangeEvent evt) {
				if ((type == GUIConstants.XML) && thisSide.xmlView.isLoaded()) {
					thisSide.xmlView.showAllElementTreeNodes();
					thisSide.visualizeFilterState(true, false);
					aGoBack.setEnabled(false);
					aGoForward.setEnabled(false);
				}
			}
		};
		aXMLTreeUnloadSummarizeXSL = new SimpleAction("Unload XSL-File", MainImages.TREE_VIEW_ICON, 'U') {
			protected void simpleActionPerformed() {
				summarizeDefListButtonGroup.unSelect();
				summarizeDefListPopupButtonGroup.unSelect();
				thisSide.xmlView.unLoadSummarizeXSLFile();
			}
		};
		BASE_ICONSET_ACTION = new RadioButtonAbstractAction("Base Icon-Set", 'B') {
			public void stateChanged(ChangeEvent evt) {
				thisSide.xmlView.getElementIconMap().setIconSet(null);
				thisSide.xmlView.repaint();
			}
		};

		ADD_FILTER_DEF_ACTION = new SimpleAction("Add/Edit Filter-Def. ...", MainImages.ADD_ICON, 'A',
				"Add/Edit Filter definition for current XML-Language") {
			protected void simpleActionPerformed() {
				if (MainController.getXMLLanguageDialog().newFilterDef(currentXMLLanguage)) {
					buildXMLLanguageMenus();
					if (currentXMLLanguage == otherSideController.currentXMLLanguage)
						otherSideController.buildXMLLanguageMenus();
				}
			}
		};
		ADD_SUMMARIZE_DEF_ACTION = new SimpleAction("Add/Edit Extraction-Def. ...", MainImages.ADD_ICON, 'A',
				"Add/Edit Summarize definition for current XML-Language") {
			protected void simpleActionPerformed() {
				if (MainController.getXMLLanguageDialog().newSummarizeDef(currentXMLLanguage)) {
					buildXMLLanguageMenus();
					if (currentXMLLanguage == otherSideController.currentXMLLanguage)
						otherSideController.buildXMLLanguageMenus();
				}
			}
		};
		ADD_HIGHLIGHT_DEF_ACTION = new SimpleAction("Add/Edit Highlight-Def. ...", MainImages.ADD_ICON, 'A',
				"Add/Edit Highlight definition for current XML-Language") {
			protected void simpleActionPerformed() {
				if (MainController.getXMLLanguageDialog().newHighlightDef(currentXMLLanguage)) {
					buildXMLLanguageMenus();
					if (currentXMLLanguage == otherSideController.currentXMLLanguage)
						otherSideController.buildXMLLanguageMenus();
				}
			}
		};
		ADD_FOLDING_DEF_ACTION = new SimpleAction("Add/Edit Folding-Def. ...", MainImages.ADD_ICON, 'A',
				"Add/Edit Folding definition for current XML-Language") {
			protected void simpleActionPerformed() {
				if (MainController.getXMLLanguageDialog().newFoldingDef(currentXMLLanguage)) {
					buildXMLLanguageMenus();  // rebuild all, maybe user changed other things too
					if (currentXMLLanguage == otherSideController.currentXMLLanguage)
						otherSideController.buildXMLLanguageMenus();
				}
			}
		};
		ADD_STYLESHEET_DEF_ACTION = new SimpleAction("Add/Edit Stylesheet-Def. ...", MainImages.ADD_ICON, 'A',
				"Add/Edit Stylesheet definition for current XML-Language") {
			protected void simpleActionPerformed() {
				if (MainController.getXMLLanguageDialog().newStylesheetDef(currentXMLLanguage)) {
					buildXMLLanguageMenus();
					if (currentXMLLanguage == otherSideController.currentXMLLanguage)
						otherSideController.buildXMLLanguageMenus();
				}
			}
		};
	}

	public boolean isTypeXML() {
		return (type == GUIConstants.XML);
	}

	public boolean isTypeHTML() {
		return (type == GUIConstants.HTML);
	}

	public int getType() {
		return type;
	}

	public void setTypeEmpty() { // called from close action
		disableActions(false);
		aSwitchToViewer.setTypeEmpty();
		type = GUIConstants.EMPTY;
		MainController.resetUndoManager(thisSideIndex);
		MainController.setActiveSideIndex(otherSideIndex);
		aXMLValidateSubTree.setEnabled(false);
		MainController.aEditFind.setEnabled(false);
		MainController.aEditFindNext.setEnabled(false);
		MainController.aEditFindPrevious.setEnabled(false);
		MainController.aEditHighlightSearchResults.setEnabled(false);
	}

	public void setTypeXML() {
		if (type != GUIConstants.XML) {
			if (type == GUIConstants.HTML)
				thisSide.deltaView.close();
			Log.trace(sideName + " side type changed to XML ...");
			int oldType = type;
			type = GUIConstants.XML;
			thisSide.switchToXML();
			aSwitchToViewer.setTypeXML();
			aSwitchToViewer.setSelectedState(true);
			aXMLValidateSubTree.setEnabled(true);
			aXMLShowXPathBar.setEnabled(true);
			aXMLShowTreePathBar.setEnabled(true);
			MainController.aEditFind.setEnabled(true);
			MainController.aEditHighlightSearchResults.setEnabled(true);
			if (oldType == GUIConstants.EMPTY)
				MainController.setActiveSideIndex(thisSideIndex);
		}
	}

	public void setTypeHTML() {
		if (type != GUIConstants.HTML) {
			if (type == GUIConstants.XML)
				thisSide.deltaView.close();
			Log.trace(sideName + " side type changed to HTML ...");
			int oldType = type;
			type = GUIConstants.HTML;

			dtdHelper.loadDTDFile(null);
			MainController.mainFrame.macrosView.resetMacroListItems(); // have to refresh MacrosView after setTargetElement()
			unsetCurrentXMLLanguage();

			thisSide.switchToHTML();
			aSwitchToViewer.setTypeHTML();
			aSwitchToViewer.setSelectedState(true);
			aHTMLShowInBrowser.setEnabled(true);
			aXMLValidateSubTree.setEnabled(false);
			aXMLShowXPathBar.setEnabled(false);
			aXMLShowTreePathBar.setEnabled(false);
			aXMLShowAutoXPathBar.setEnabled(false);
			MainController.aEditFind.setEnabled(true);
			MainController.aEditHighlightSearchResults.setEnabled(true);
			if (oldType == GUIConstants.EMPTY)
				MainController.setActiveSideIndex(thisSideIndex);
		}
	}

	void setActive() {
		if (!active) {
			Log.trace(sideName + " side gets active ...");
			active = true;
			thisSide.visualizeActiveState(active);
			MainController.resetMacroInsertModes(dtdHelper);
			MainController.aEditFindNext.setEnabled(thisSide.deltaView.canSearchAgain());
			MainController.aEditFindPrevious.setEnabled(thisSide.deltaView.canSearchAgain());
		}
	}

	void setInactive() {
		if (active) {
			Log.trace(sideName + " side gets inactive ...");
			active = false;
			thisSide.visualizeActiveState(active);
		}
	}

	void storeProperties() {
		thisSide.xmlView.storeProperties();
		thisSide.htmlView.storeProperties();
		MainController.stateProperties.putBoolean(Preferences.KEY_XML_SHOW_XPATH_BAR[thisSideIndex], aXMLShowXPathBar.isSelected());
		MainController.stateProperties.putBoolean(Preferences.KEY_XML_SHOW_TREEPATH_BAR[thisSideIndex], aXMLShowTreePathBar.isSelected());
		MainController.stateProperties.putBoolean(Preferences.KEY_XML_SHOW_AUTOXPATH_BAR[thisSideIndex], aXMLShowAutoXPathBar.isSelected());
	}

	public void enableActions() {
		System.out.println("enable all actions for the " + GUIConstants.SIDE_NAMES[thisSideIndex] + " side...");
		final boolean isLangSet = currentXMLLanguage != null;
		aXMLNewEmptyFile.setEnabled(isLangSet);
		thisSide.jButtonNewFromTemplateOrOtherLang.setEnabled(isLangSet);
		thisSide.jMenuTemplates.setEnabled(isLangSet);
		thisSide.jMenuNewFromOtherLang.setEnabled(MainController.xmlLanguages.size() > (isLangSet ? 1 : 0));

		if (MainController.ADVANCED_MODE) {
			thisSide.subMenuLangFolding.setEnabled(isLangSet);
			thisSide.popupSubMenuLangFolding.setEnabled(isLangSet);
			thisSide.subMenuLangHighlight.setEnabled(isLangSet);
			thisSide.popupSubMenuLangHighlight.setEnabled(isLangSet);
			thisSide.subMenuLangSummarize.setEnabled(isLangSet);
			thisSide.popupSubMenuLangSummarize.setEnabled(isLangSet);
			thisSide.subMenuLangFilter.setEnabled(isLangSet);
			thisSide.popupSubMenuLangFilter.setEnabled(isLangSet);
			thisSide.subMenuLangIconSets.setEnabled(isLangSet);
			thisSide.popupSubMenuLangIconSets.setEnabled(isLangSet);
			thisSide.subMenuLangStylesheet.setEnabled(isLangSet);
			thisSide.popupSubMenuLangStylesheet.setEnabled(isLangSet);
		}

		aOpen.setEnabled(true);
		aReopen.setEnabled(true);
		boolean fileLoaded = thisSide.deltaView.getFile() != null;
		thisSide.deltaView.setEnabled(fileLoaded);
		aReload.setEnabled(fileLoaded);
		aClose.setEnabled(fileLoaded);
		aRevert.setEnabled(FileUtils.backupExists(thisSide.deltaView.getFile()));
		aSave.setEnabled(true); // ToThink: let "Save" be always enabled, to allow saving an unchanged XML file in a formatted style
	//	aSave.setEnabled(thisSide.deltaView.contentHasChanged());
		MainController.aFileSaveAll.setEnabled(thisSide.deltaView.contentHasChanged() || otherSide.deltaView.contentHasChanged());
		MainController.aFileCloseAll.setEnabled(
				thisSide.deltaView.isLoaded() || otherSide.deltaView.isLoaded() || MainController.mainFrame.macrosView.isLoaded());
		aSaveAs.setEnabled(fileLoaded);
		aGoBack.setEnabled(thisSide.deltaView.canGoBack());
		aGoForward.setEnabled(thisSide.deltaView.canGoForward());
		MainController.aEditUndo.setEnabled(MainController.undoManager.canUndo());
		MainController.aEditRedo.setEnabled(MainController.undoManager.canRedo());
		MainController.aEditFind.setEnabled(fileLoaded);
		aInsertNewDELTALink.setEnabled(thisSide.deltaView.acceptsNewDELTALink(true, false) && otherSide.deltaView.acceptsNewDELTALink(true, false) &&
				!((thisSide.deltaView.getCurrentDELTALinkID(true) != LinkIDConstants.NO_LINK)
				&& (otherSide.deltaView.getCurrentDELTALinkID(true) != LinkIDConstants.NO_LINK)));
		aSwitchToViewer.setEnabled(fileLoaded);
		aShowFormattedSource.setEnabled(fileLoaded);
		aShowPlainSource.setEnabled(fileLoaded);
		boolean isXML = (type == GUIConstants.XML);
		aXMLTreeShowDocumentNode.setEnabled(fileLoaded && isXML);
		aXMLTreeShowCommentNodes.setEnabled(fileLoaded && isXML);
		aXMLTreeShowTextNodes.setEnabled(fileLoaded && isXML);
		aXMLTreeShowCDATANodes.setEnabled(fileLoaded && isXML);
		aXMLTreeShowPINodes.setEnabled(fileLoaded && isXML);
		aXMLShowFormattedDTDSource.setEnabled(fileLoaded && isXML);
		aXMLShowDTDReport.setEnabled(fileLoaded && isXML);
		aXMLShowPlainDTDSource.setEnabled(fileLoaded && isXML);
		aXMLDELTALinksVisualizationUp.setEnabled(fileLoaded && isXML);
		aXMLDELTALinksVisualizationDown.setEnabled(fileLoaded && isXML);
		aHighlightAllLinks.setEnabled(fileLoaded);
		aHighlightDeadLinks.setEnabled(fileLoaded);
		aHighlightSameLinks.setEnabled(fileLoaded);
		aXMLHighlightXPath.setEnabled(fileLoaded && isXML);
		aXMLHighlightXQuery.setEnabled(fileLoaded && isXML);
		aXMLTreeExpandAll.setEnabled(fileLoaded && isXML);
		aXMLTreeCollapseAll.setEnabled(fileLoaded && isXML);
		aXMLTreeExpandAllDescendants.setEnabled(fileLoaded && isXML);
		aXMLTreeCollapseAllDescendants.setEnabled(fileLoaded && isXML);
		aXMLTreeExpandAllXPath.setEnabled(fileLoaded && isXML);
		aXMLTreeCollapseAllXPath.setEnabled(fileLoaded && isXML);
		aXMLTreeShowXPath.setEnabled(fileLoaded && isXML);
		aXMLTreeHideXPath.setEnabled(fileLoaded && isXML);
		aXMLTreeShowAllTreeNodes.setEnabled(fileLoaded && isXML);
		aXMLTreeApplySummarizeXSL.setEnabled(fileLoaded && isXML);
		aXMLTreeUnloadSummarizeXSL.setEnabled(fileLoaded && isXML);
		aXMLXSLTransform.setEnabled(fileLoaded && isXML);
		aXMLJumpToLineNumber.setEnabled(fileLoaded && isXML);
		aHTMLRemoveLinks.setEnabled(thisSide.deltaView.getCurrentDELTALinkID(true) != LinkIDConstants.NO_LINK && (type == GUIConstants.HTML));
		aHTMLShowInBrowser.setEnabled(fileLoaded);
		aSourceExport.setEnabled(fileLoaded);
		aSourceToBrowser.setEnabled(fileLoaded);
		aXMLAttributeRemove.setEnabled(thisSide.xmlAttributesTable.isCurrentAttributeRemoveable());
		aXMLShowAutoXPathBar.setEnabled((currentXMLLanguage != null) &&
										(currentXMLLanguage.getAutoXPathDefs() != null) &&
										(currentXMLLanguage.getAutoXPathDefs().getAutoXPathDefList() != null) &&
										!currentXMLLanguage.getAutoXPathDefs().getAutoXPathDefList().isEmpty());
		if (isXML)
			thisSide.xmlView.reselectCurrentTreeNode();
		MainController.aMacroSearchInsertDown.setEnabled(isXML && MainController.mainFrame.macrosView.isMacroSelected());
		MainController.aMacroSearchInsertUp.setEnabled(isXML && MainController.mainFrame.macrosView.isMacroSelected());

		MainController.mainFrame.jMenuProjectProcessTemplates.setEnabled(!MainController.processTemplates.getProcessTemplateList().isEmpty());
		MainController.mainFrame.jMenuProjectSteps.setEnabled(MainController.currentProcess != null);
	}

	public void disableActions(boolean disableAll) {
		System.out.println("disable all actions for the " + GUIConstants.SIDE_NAMES[thisSideIndex] + " side...");
		thisSide.deltaView.setEnabled(false);
		if (disableAll) {
			thisSide.jButtonNewFromTemplateOrOtherLang.setEnabled(false);
			thisSide.jMenuTemplates.setEnabled(false);
			thisSide.jMenuNewFromOtherLang.setEnabled(false);
			aOpen.setEnabled(false);
			aReopen.setEnabled(false);
			aXMLNewEmptyFile.setEnabled(false);
		}

		if (MainController.ADVANCED_MODE) {
			thisSide.subMenuLangFolding.setEnabled(false);
			thisSide.popupSubMenuLangFolding.setEnabled(false);
			thisSide.subMenuLangHighlight.setEnabled(false);
			thisSide.popupSubMenuLangHighlight.setEnabled(false);
			thisSide.subMenuLangSummarize.setEnabled(false);
			thisSide.popupSubMenuLangSummarize.setEnabled(false);
			thisSide.subMenuLangFilter.setEnabled(false);
			thisSide.popupSubMenuLangFilter.setEnabled(false);
			thisSide.subMenuLangIconSets.setEnabled(false);
			thisSide.popupSubMenuLangIconSets.setEnabled(false);
			thisSide.subMenuLangStylesheet.setEnabled(false);
			thisSide.popupSubMenuLangStylesheet.setEnabled(false);
		}

		MainController.aEditUndo.setEnabled(false);
		MainController.aEditRedo.setEnabled(false);
		MainController.aEditFind.setEnabled(false);
		aInsertNewDELTALink.setEnabled(false);
		aHighlightAllLinks.setEnabled(false);
		aHighlightDeadLinks.setEnabled(false);
		aHighlightSameLinks.setEnabled(false);
		aXMLHighlightXPath.setEnabled(false);
		aXMLHighlightXQuery.setEnabled(false);
		aXMLTreeExpandAll.setEnabled(false);
		aXMLTreeCollapseAll.setEnabled(false);
		aXMLTreeExpandAllDescendants.setEnabled(false);
		aXMLTreeCollapseAllDescendants.setEnabled(false);
		aXMLTreeExpandAllXPath.setEnabled(false);
		aXMLTreeCollapseAllXPath.setEnabled(false);
		aXMLTreeShowXPath.setEnabled(false);
		aXMLTreeHideXPath.setEnabled(false);
		aXMLTreeShowAllTreeNodes.setEnabled(false);
		aXMLTreeApplySummarizeXSL.setEnabled(false);
		aXMLTreeUnloadSummarizeXSL.setEnabled(false);
		aReload.setEnabled(false);
		aClose.setEnabled(false);
		aRevert.setEnabled(false);
		aSave.setEnabled(false);
		MainController.aFileSaveAll.setEnabled(false);
		MainController.aFileCloseAll.setEnabled(false);
		aSaveAs.setEnabled(false);
		aGoBack.setEnabled(false);
		aGoForward.setEnabled(false);
		aSwitchToViewer.setEnabled(false);
		aShowFormattedSource.setEnabled(false);
		aShowPlainSource.setEnabled(false);
		aSynchronizeLinks.setEnabled(false);
		aHTMLRemoveLinks.setEnabled(false);
		aHTMLShowInBrowser.setEnabled(false);
		aSourceExport.setEnabled(false);
		aSourceToBrowser.setEnabled(false);
		aXMLShowFormattedDTDSource.setEnabled(false);
		aXMLShowDTDReport.setEnabled(false);
		aXMLShowPlainDTDSource.setEnabled(false);
		aXMLAddRequiredContent.setEnabled(false);
		aXMLRemoveNode.setEnabled(false);
		aXMLAttributeAdd.setEnabled(false);
		aXMLAttributeRemove.setEnabled(false);
		aXMLAttributeRemove.setEnabled(false);
		aXMLTreeShowDocumentNode.setEnabled(false);
		aXMLTreeShowCommentNodes.setEnabled(false);
		aXMLTreeShowTextNodes.setEnabled(false);
		aXMLTreeShowCDATANodes.setEnabled(false);
		aXMLTreeShowPINodes.setEnabled(false);
		aXMLDELTALinksVisualizationUp.setEnabled(false);
		aXMLDELTALinksVisualizationDown.setEnabled(false);
		aXMLXSLTransform.setEnabled(false);
		aXMLGoToElementDefinitionInDTDReport.setEnabled(false);
		aXMLGoToElementDefinitionInDTDSource.setEnabled(false);
		aXMLShowAutoXPathBar.setEnabled(false);
		aXMLCommentElement.setEnabled(false);
		aXMLJumpToLineNumber.setEnabled(false);
		MainController.aMacroInsert.setEnabled(false);
		MainController.aMacroSearchInsertDown.setEnabled(false);
		MainController.aMacroSearchInsertUp.setEnabled(false);

		if (disableAll) {
			MainController.mainFrame.jMenuProjectProcessTemplates.setEnabled(false);
			MainController.mainFrame.jMenuProjectSteps.setEnabled(false);
		}
	}

	void installListeners() {
		thisSide.htmlView.addCaretListener(new HTMLViewCaretListener());
		thisSide.xmlView.addTreeSelectionListener(new XMLViewTreeSelectionListener());
		thisSide.getAutoXPathBar().addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                Node xmlNode = thisSide.getAutoXPathBar().getNode();
                XMLTreeNode xmlTreeNode = thisSide.xmlView.getTreeNode4XMLNode(xmlNode);
                if (xmlTreeNode != null)
                    thisSide.xmlView.centerAndReselectTreeNode(xmlTreeNode);
            }
        });
		thisSide.getTreePathBar().addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				thisSide.xmlView.jumpToTreePath(thisSide.getTreePathBar().getTreePath());
			}
		});

		thisSide.xmlView.addHyperlinkListener(gmtViewHyperlinkListener);
		thisSide.htmlView.addHyperlinkListener(gmtViewHyperlinkListener);
		thisSide.newAttributesComboBox.addActionListener(aXMLAttributeAdd);

		thisSide.xmlAttributesTable.addTableModelListener(new XMLAttributesTableModelListener());
		thisSide.xmlAttributesTable.addSelectionListener(new XMLAttributesTableSelectionListener());

		thisSide.htmlView.addChangeListener(gmtViewChangeListener);
		thisSide.xmlView.addChangeListener(gmtViewChangeListener);

		thisSide.xmlView.addUndoableEditListener(undoHandler);
		thisSide.xmlAttributesTable.addUndoableEditListener(undoHandler);
		thisSide.htmlView.addUndoableEditListener(undoHandler);

		thisSide.jButtonReopen.addMouseListener(new ButtonPopupMenuHandler(thisSide.jButtonReopen, thisSide.jPopupMenuReopen));
		thisSide.jButtonNewFromTemplateOrOtherLang.addMouseListener(new ButtonPopupMenuHandler(thisSide.jButtonNewFromTemplateOrOtherLang, thisSide.jPopupMenuNewFromTemplateOrOtherLang));
		thisSide.langNameLabel.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent evt) {
				if ((currentXMLLanguage != null) && (evt.getClickCount() == 2)) {
					if (MainController.getXMLLanguageDialog().showDialog(currentXMLLanguage)) {
						MainController.deltaSideController[GUIConstants.LEFT].refreshXMLLanguages();
						MainController.deltaSideController[GUIConstants.RIGHT].refreshXMLLanguages();
					}
				}
			}
		});

		if (MainController.ADVANCED_MODE)
			thisSide.filterStateLabel.addMouseListener(new PopupMenuHandler(thisSide.popupSubMenuLangFilter.getPopupMenu()));

		thisSide.htmlOutput.addHyperlinkListener(new HyperlinkListener() {
			public void hyperlinkUpdate(HyperlinkEvent evt) {
				if (evt.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {
					String target = evt.getDescription();
					if (target.charAt(0) == '#')
						thisSide.htmlOutput.scrollToReference(target.substring(1));
					else {
						boolean result = styleSheetSourceSideController.aXMLEvaluateXPathExpression.evaluateAndVisualizeXPathExpression(target);
						if (!result) aSwitchToHTMLOutput.setSelected(true);
					}
				}
			}
		});

		recentFileOpenActionListener = new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				aOpen.doOpenFile(new File(evt.getActionCommand()), false, true, true);
			}
		};
	}

	private void installKeyboardActions() {
// install xmlView KeyboardActions
		ActionMap actionMap = thisSide.xmlView.getActionMap();
		InputMap inputMap = thisSide.xmlView.getInputMap(JComponent.WHEN_FOCUSED); // WHEN_ANCESTOR_OF_FOCUSED_COMPONENT
		SwingUtils.addShortCut(actionMap, inputMap, aXMLNewEmptyFile);
		SwingUtils.addShortCut(actionMap, inputMap, aOpen);
		SwingUtils.addShortCut(actionMap, inputMap, aSave);
		SwingUtils.addShortCut(actionMap, inputMap, aSaveAs);

		SwingUtils.addShortCut(actionMap, inputMap, aXMLJumpToLineNumber);
		SwingUtils.addShortCut(actionMap, inputMap, aXMLRemoveNode);
		actionMap.put("aXMLDuplicateNode", aXMLDuplicateNode);
		inputMap.put((KeyStroke) aXMLDuplicateNode.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY), "aXMLDuplicateNode");

		actionMap.put("validateDocumentAction", aXMLValidateSubTree);
		inputMap.put((KeyStroke) aXMLValidateSubTree.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY), "validateDocumentAction");
		actionMap.put("goBackAction", aGoBack);
		inputMap.put((KeyStroke) aGoBack.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY), "goBackAction");
		actionMap.put("goForwardAction", aGoForward);
		inputMap.put((KeyStroke) aGoForward.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY), "goForwardAction");
		actionMap.put("changeTextValueAction", aXMLChangeTextValue);
		inputMap.put((KeyStroke) aXMLChangeTextValue.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY), "changeTextValueAction");

		SwingUtils.addShortCut(actionMap, inputMap, aXMLAddRequiredContent);

		actionMap.put(TransferHandler.getCutAction().getValue(Action.NAME), MainController.aEditCut);
		actionMap.put(TransferHandler.getCopyAction().getValue(Action.NAME), MainController.aEditCopy);

		actionMap.put("aEditFind", MainController.aEditFind);
		inputMap.put((KeyStroke) MainController.aEditFind.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY), "aEditFind");

		actionMap.put("jumpToNextHighlight", new AbstractAction() {
			public void actionPerformed(ActionEvent evt) {
				thisSide.xmlView.jumpToNextHighlight();		// todo: add to keyboard-HELP, add Action (menu-item)
			}
		});
		inputMap.put(KeyStroke.getKeyStroke(KeyEvent.VK_DOWN, InputEvent.CTRL_MASK | InputEvent.SHIFT_MASK), "jumpToNextHighlight");
		actionMap.put("jumpToPreviousHighlight", new AbstractAction() {
			public void actionPerformed(ActionEvent evt) {
				thisSide.xmlView.jumpToPreviousHighlight(); // todo: add to keyboard-HELP, add Action (menu-item)
			}
		});
		inputMap.put(KeyStroke.getKeyStroke(KeyEvent.VK_UP, InputEvent.CTRL_MASK | InputEvent.SHIFT_MASK), "jumpToPreviousHighlight");

// aEditFindNext should be a global shortcut
//  actionMap.put("aEditFindNext", MainController.aEditFindNext);
//  inputMap.put((KeyStroke) MainController.aEditFindNext.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY), "aEditFindNext");

		actionMap.put("aEditHighlightSearchResults", MainController.aEditHighlightSearchResults);
		inputMap.put((KeyStroke) MainController.aEditHighlightSearchResults.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY),
				"aEditHighlightSearchResults");
		actionMap.put("aEditPasteAfter", MainController.aEditPasteAfter);
		inputMap.put((KeyStroke) MainController.aEditPasteAfter.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY),
				"aEditPasteAfter");
		actionMap.put("aEditPasteBefore", MainController.aEditPasteBefore);
		inputMap.put((KeyStroke) MainController.aEditPasteBefore.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY),
				"aEditPasteBefore");
		actionMap.put("aEditPasteInto", MainController.aEditPasteInto);
		inputMap.put((KeyStroke) MainController.aEditPasteInto.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY),
				"aEditPasteInto");
		actionMap.put("aEditPasteReplace", MainController.aEditPasteReplace);
		inputMap.put((KeyStroke) MainController.aEditPasteReplace.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY),
				"aEditPasteReplace");
		actionMap.put("aEditShowInsertableElementsDialog", MainController.aEditShowInsertableElementsDialog);
		inputMap.put((KeyStroke) MainController.aEditShowInsertableElementsDialog.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY),
				"aEditShowInsertableElementsDialog");
		actionMap.put("aEditShowAllElementsDialog", MainController.aEditShowAllElementsDialog);
		inputMap.put((KeyStroke) MainController.aEditShowAllElementsDialog.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY), "aEditShowAllElementsDialog");
		actionMap.put("maximizeAction", aMaximzeViewSize);
		inputMap.put((KeyStroke) aMaximzeViewSize.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY), "maximizeAction");
		actionMap.put("restoreAction", aRestoreViewSize);
		inputMap.put((KeyStroke) aRestoreViewSize.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY), "restoreAction");

		actionMap.put("aSwitchToViewer", aSwitchToViewer);
		inputMap.put((KeyStroke) aSwitchToViewer.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY), "aSwitchToViewer");
		actionMap.put("aSwitchToHTMLOutput", aSwitchToHTMLOutput);
		inputMap.put((KeyStroke) aSwitchToHTMLOutput.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY), "aSwitchToHTMLOutput");
		actionMap.put("aSwitchToTextOutput", aSwitchToTextOutput);
		inputMap.put((KeyStroke) aSwitchToTextOutput.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY), "aSwitchToTextOutput");
		actionMap.put("aShowFormattedSource", aShowFormattedSource);
		inputMap.put((KeyStroke) aShowFormattedSource.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY), "aShowFormattedSource");
		actionMap.put("aShowPlainSource", aShowPlainSource);
		inputMap.put((KeyStroke) aShowPlainSource.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY), "aShowPlainSource");
		actionMap.put("aXMLShowDTDReport", aXMLShowDTDReport);
		inputMap.put((KeyStroke) aXMLShowDTDReport.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY), "aXMLShowDTDReport");
		actionMap.put("aXMLShowFormattedDTDSource", aXMLShowFormattedDTDSource);
		inputMap.put((KeyStroke) aXMLShowFormattedDTDSource.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY), "aXMLShowFormattedDTDSource");
		actionMap.put("aXMLShowPlainDTDSource", aXMLShowPlainDTDSource);
		inputMap.put((KeyStroke) aXMLShowPlainDTDSource.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY), "aXMLShowPlainDTDSource");

		actionMap.put("changeSideAction", new AbstractAction() {
			public void actionPerformed(ActionEvent evt) {
				MainController.setActiveSideIndex(otherSideIndex);
			}
		});
		inputMap.put(KeyStroke.getKeyStroke(KeyEvent.VK_TAB, 0), "changeSideAction");
		actionMap.put("changeInSideAction", new AbstractAction() {
			public void actionPerformed(ActionEvent evt) {
				thisSide.xmlAttributesTable.requestFocusInWindow();
			}
		});
		inputMap.put(KeyStroke.getKeyStroke(KeyEvent.VK_TAB, InputEvent.CTRL_MASK), "changeInSideAction");
		actionMap.put("enterAction", new AbstractAction() {
			public void actionPerformed(ActionEvent evt) {
				otherSide.sideController.aSwitchToViewer.setSelected(true);
				otherSide.deltaView.jumpToDELTALink(thisSide.xmlView.getCurrentDELTALinkID(true));
				otherSide.sideController.aXMLDELTALinksVisualizationDown.setSelected(false);
				otherSide.sideController.aXMLDELTALinksVisualizationUp.setSelected(false);
			}
		});
		inputMap.put(KeyStroke.getKeyStroke(KeyEvent.VK_ENTER, 0), "enterAction");
		actionMap.put("aXMLShowXPathBar", aXMLShowXPathBar);
		inputMap.put((KeyStroke) aXMLShowXPathBar.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY), "aXMLShowXPathBar");

		SwingUtils.addShortCut(actionMap, inputMap, aXMLShowTreePathBar);
		SwingUtils.addShortCut(actionMap, inputMap, aXMLShowAutoXPathBar);
		SwingUtils.addShortCut(actionMap, inputMap, aXMLSetRootTreeNode);
		SwingUtils.addShortCut(actionMap, inputMap, aXMLHighlightXPath);
		SwingUtils.addShortCut(actionMap, inputMap, aXMLHighlightXQuery);
		SwingUtils.addShortCut(actionMap, inputMap, aXMLCommentElement);
		SwingUtils.addShortCut(actionMap, inputMap, aXMLGoToElementDefinitionInDTDReport);
		SwingUtils.addShortCut(actionMap, inputMap, aXMLGoToElementDefinitionInDTDSource);

// install xmlAttributesTable KeyboardActions
		actionMap = thisSide.xmlAttributesTable.getActionMap();
		inputMap = thisSide.xmlAttributesTable.getInputMap(JComponent.WHEN_FOCUSED);
		SwingUtils.addShortCut(actionMap, inputMap, aXMLNewEmptyFile);
		SwingUtils.addShortCut(actionMap, inputMap, aOpen);
		SwingUtils.addShortCut(actionMap, inputMap, aSave);
		SwingUtils.addShortCut(actionMap, inputMap, aSaveAs);
		SwingUtils.addShortCut(actionMap, inputMap, aXMLAttributeRemove);
		SwingUtils.addShortCut(actionMap, inputMap, aMaximzeViewSize);
		SwingUtils.addShortCut(actionMap, inputMap, aRestoreViewSize);
		actionMap.put("changeSideAction", new AbstractAction() {
			public void actionPerformed(ActionEvent evt) {
				MainController.setActiveSideIndex(otherSideIndex);
			}
		});
		inputMap.put(KeyStroke.getKeyStroke(KeyEvent.VK_TAB, 0), "changeSideAction");
		actionMap.put("changeInSideAction", new AbstractAction() {
			public void actionPerformed(ActionEvent evt) {
				thisSide.xmlView.requestFocusInWindow();
			}
		});
		inputMap.put(KeyStroke.getKeyStroke(KeyEvent.VK_TAB, InputEvent.CTRL_MASK), "changeInSideAction");

// install htmlView KeyboardActions
		actionMap = thisSide.htmlView.getActionMap();
		inputMap = thisSide.htmlView.getInputMap(JComponent.WHEN_FOCUSED);
		actionMap.put("openFileAction", aOpen);
		inputMap.put((KeyStroke) aOpen.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY), "openFileAction");
		actionMap.put("saveFileAction", aSave);
		inputMap.put((KeyStroke) aSave.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY), "saveFileAction");
		actionMap.put("saveFileAsAction", aSaveAs);
		inputMap.put((KeyStroke) aSaveAs.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY), "saveFileAsAction");
		SwingUtils.addShortCut(actionMap, inputMap, aReload);
		actionMap.put("aEditFind", MainController.aEditFind);
		inputMap.put((KeyStroke) MainController.aEditFind.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY), "aEditFind");

		actionMap.put("jumpToNextHighlight", new AbstractAction() {
			public void actionPerformed(ActionEvent evt) {
				thisSide.htmlView.jumpToNextHighlight(); // todo: add to keyboard-HELP, add Action (menu-item)
			}
		});
		inputMap.put(KeyStroke.getKeyStroke(KeyEvent.VK_DOWN, InputEvent.CTRL_MASK | InputEvent.SHIFT_MASK), "jumpToNextHighlight");
		actionMap.put("jumpToPreviousHighlight", new AbstractAction() {
			public void actionPerformed(ActionEvent evt) {
				thisSide.htmlView.jumpToPreviousHighlight(); // todo: add to keyboard-HELP, add Action (menu-item)
			}
		});
		inputMap.put(KeyStroke.getKeyStroke(KeyEvent.VK_UP, InputEvent.CTRL_MASK | InputEvent.SHIFT_MASK), "jumpToPreviousHighlight");


// aEditFindNext should be a global shortcut
//  actionMap.put("aEditFindNext", MainController.aEditFindNext);
//  inputMap.put((KeyStroke) MainController.aEditFindNext.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY), "aEditFindNext");

		actionMap.put("aEditHighlightSearchResults", MainController.aEditHighlightSearchResults);
		inputMap.put((KeyStroke) MainController.aEditHighlightSearchResults.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY),
				"aEditHighlightSearchResults");
		actionMap.put("changeSideAction", new AbstractAction() {
			public void actionPerformed(ActionEvent evt) {
				MainController.setActiveSideIndex(otherSideIndex);
			}
		});
		inputMap.put(KeyStroke.getKeyStroke(KeyEvent.VK_TAB, 0), "changeSideAction");
		actionMap.put("maximizeAction", aMaximzeViewSize);
		inputMap.put((KeyStroke) aMaximzeViewSize.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY),
				"maximizeAction");
		actionMap.put("restoreAction", aRestoreViewSize);
		inputMap.put((KeyStroke) aRestoreViewSize.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY),
				"restoreAction");
		actionMap.put("aSwitchToViewer", aSwitchToViewer);
		inputMap.put((KeyStroke) aSwitchToViewer.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY),
				"aSwitchToViewer");
		actionMap.put("aSwitchToHTMLOutput", aSwitchToHTMLOutput);
		inputMap.put((KeyStroke) aSwitchToHTMLOutput.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY),
				"aSwitchToHTMLOutput");
		actionMap.put("aSwitchToTextOutput", aSwitchToTextOutput);
		inputMap.put((KeyStroke) aSwitchToTextOutput.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY),
				"aSwitchToTextOutput");

// install htmlOutput KeyboardActions
		actionMap = thisSide.htmlOutput.getActionMap();
		inputMap = thisSide.htmlOutput.getInputMap(JComponent.WHEN_FOCUSED);
		actionMap.put("changeSideAction", new AbstractAction() {
			public void actionPerformed(ActionEvent evt) {
				MainController.setActiveSideIndex(otherSideIndex);
			}
		});
		inputMap.put(KeyStroke.getKeyStroke(KeyEvent.VK_TAB, 0), "changeSideAction");
		actionMap.put("maximizeAction", aMaximzeViewSize);
		inputMap.put((KeyStroke) aMaximzeViewSize.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY),
				"maximizeAction");
		actionMap.put("restoreAction", aRestoreViewSize);
		inputMap.put((KeyStroke) aRestoreViewSize.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY),
				"restoreAction");
		actionMap.put("aSwitchToViewer", aSwitchToViewer);
		inputMap.put((KeyStroke) aSwitchToViewer.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY),
				"aSwitchToViewer");
		actionMap.put("aSwitchToHTMLOutput", aSwitchToHTMLOutput);
		inputMap.put((KeyStroke) aSwitchToHTMLOutput.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY),
				"aSwitchToHTMLOutput");
		actionMap.put("aSwitchToTextOutput", aSwitchToTextOutput);
		inputMap.put((KeyStroke) aSwitchToTextOutput.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY),
				"aSwitchToTextOutput");
		actionMap.put("aXMLSwitchToDTDSourceDoc", aXMLShowDTDReport);
		inputMap.put((KeyStroke) aXMLShowDTDReport.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY),
				"aXMLSwitchToDTDSourceDoc");
		actionMap.put("aXMLSwitchToDTDSourceHTML", aXMLShowFormattedDTDSource);
		inputMap.put((KeyStroke) aXMLShowFormattedDTDSource.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY),
				"aXMLSwitchToDTDSourceHTML");
		actionMap.put("aXMLShowPlainDTDSource", aXMLShowPlainDTDSource);
		inputMap.put((KeyStroke) aXMLShowPlainDTDSource.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY),
				"aXMLShowPlainDTDSource");

// install textOutput KeyboardActions
		actionMap = thisSide.textOutput.getActionMap();
		inputMap = thisSide.textOutput.getInputMap(JComponent.WHEN_FOCUSED);
		actionMap.put("changeSideAction", new AbstractAction() {
			public void actionPerformed(ActionEvent evt) {
				MainController.setActiveSideIndex(otherSideIndex);
			}
		});
		inputMap.put(KeyStroke.getKeyStroke(KeyEvent.VK_TAB, 0), "changeSideAction");
		actionMap.put("maximizeAction", aMaximzeViewSize);
		inputMap.put((KeyStroke) aMaximzeViewSize.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY),
				"maximizeAction");
		actionMap.put("restoreAction", aRestoreViewSize);
		inputMap.put((KeyStroke) aRestoreViewSize.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY),
				"restoreAction");
		actionMap.put("aSwitchToViewer", aSwitchToViewer);
		inputMap.put((KeyStroke) aSwitchToViewer.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY),
				"aSwitchToViewer");
		actionMap.put("aSwitchToHTMLOutput", aSwitchToHTMLOutput);
		inputMap.put((KeyStroke) aSwitchToHTMLOutput.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY),
				"aSwitchToHTMLOutput");
		actionMap.put("aSwitchToTextOutput", aSwitchToTextOutput);
		inputMap.put((KeyStroke) aSwitchToTextOutput.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY),
				"aSwitchToTextOutput");
		actionMap.put("aXMLSwitchToDTDSourceDoc", aXMLShowDTDReport);
		inputMap.put((KeyStroke) aXMLShowDTDReport.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY),
				"aXMLSwitchToDTDSourceDoc");
		actionMap.put("aXMLSwitchToDTDSourceHTML", aXMLShowFormattedDTDSource);
		inputMap.put((KeyStroke) aXMLShowFormattedDTDSource.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY),
				"aXMLSwitchToDTDSourceHTML");
		actionMap.put("aXMLShowPlainDTDSource", aXMLShowPlainDTDSource);
		inputMap.put((KeyStroke) aXMLShowPlainDTDSource.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY),
				"aXMLShowPlainDTDSource");
	}

	public void buildRecentFilesMenus() {
		MainController._buildRecentFilesMenus(thisSide.jMenuReopen, thisSide.jPopupMenuReopen,
				MainController.recentXHTMLFiles, recentFileOpenActionListener);
	}

	public void buildRecentDirsMenu() {
		MainController._buildRecentDirsMenus(thisSide.jMenuOpenInDir, recentFileOpenActionListener);
	}

	private void buildNewFromTemplateOrOtherLangMenus() {
		thisSide.jMenuTemplates.removeAll();
		thisSide.jMenuNewFromOtherLang.removeAll();
		thisSide.jPopupMenuNewFromTemplateOrOtherLang.removeAll();
		if (currentXMLLanguage != null) {
			List templates = currentXMLLanguage.getTemplates().getTemplateList();
			if ((templates != null) && !templates.isEmpty()) {
				for (int i = 0, size = templates.size(); i < size; i++) {
					Action action = new XMLNewFileFromTemplateAction(thisSideIndex, currentXMLLanguage, (Template) templates.get(i), i);
					thisSide.jMenuTemplates.add(action);
					thisSide.jPopupMenuNewFromTemplateOrOtherLang.add(action);
				}
				thisSide.jMenuTemplates.addSeparator();
				thisSide.jPopupMenuNewFromTemplateOrOtherLang.addSeparator();
			}
			Action addTemplateAction = new XMLAddTemplateAction(thisSideIndex, currentXMLLanguage);
			thisSide.jMenuTemplates.add(addTemplateAction);
			thisSide.jPopupMenuNewFromTemplateOrOtherLang.add(addTemplateAction);
			MainController.mainFrame.statusBar.attachToMenuElement(thisSide.jMenuTemplates);

			if (MainController.xmlLanguages.size() > 1)
				thisSide.jPopupMenuNewFromTemplateOrOtherLang.addSeparator();
		}

		Action otherLangAction = new EmptyAction("other XML-Languages", MainImages.XML_LANGUAGE_ICON);
		JMenu otherLangM = thisSide.jMenuNewFromOtherLang, otherLangP = new JMenu(otherLangAction);
		thisSide.jPopupMenuNewFromTemplateOrOtherLang.add(otherLangP);
		if (MainController.xmlLanguages.size() > ((currentXMLLanguage != null) ? 1 : 0)) {
			for (int i = 0, j = 0, size = MainController.xmlLanguages.size(); i < size; i++) {
				final XmlLanguage xmlLanguage = MainController.xmlLanguages.get(i);
				if (currentXMLLanguage != xmlLanguage) {
					String xmlLangName = xmlLanguage.getName();

					String xmlLangDescription = xmlLanguage.getDescription();
					String infoText = "XML Language \""+xmlLangName + "\"" + ((xmlLangDescription == null) ? "" : ": "+ xmlLangDescription);
					Action langAction = new EmptyAction("" + (++j) + ' ' + xmlLangName, xmlLanguage.getIcon(), (char)('1' + i), null, infoText);
					JMenu langMenuM = new JMenu(langAction), langMenuP = new JMenu(langAction);
					otherLangM.add(langMenuM);
					otherLangP.add(langMenuP);

					Action newXMLAction = new XMLNewEmptyFileAction(thisSideIndex, xmlLanguage);
					newXMLAction.putValue(XMLNewEmptyFileAction.LOCAL_ACCELERATOR_KEY, null);
					langMenuM.add(newXMLAction);
					langMenuP.add(newXMLAction);
					langMenuM.addSeparator();
					langMenuP.addSeparator();

					List templates = xmlLanguage.getTemplates().getTemplateList();
					if ((templates != null) && !templates.isEmpty()) {
						for (int k = 0, size2 = templates.size(); k < size2; k++) {
							Action action = new XMLNewFileFromTemplateAction(thisSideIndex, xmlLanguage, (Template) templates.get(k), k);
							langMenuM.add(action);
							langMenuP.add(action);
						}
						langMenuM.addSeparator();
						langMenuP.addSeparator();
					}
					Action addTemplateAction = new XMLAddTemplateAction(thisSideIndex, xmlLanguage);
					langMenuM.add(addTemplateAction);
					langMenuP.add(addTemplateAction);

					MainController.mainFrame.statusBar.attachToMenuElement(langMenuM);
					MainController.mainFrame.statusBar.attachToMenuElement(langMenuP);
				}
			}
			otherLangM.addSeparator();
			otherLangP.addSeparator();
		}
		otherLangM.add(NEW_XML_LANGUAGE_MENU_ACTION);
		otherLangP.add(NEW_XML_LANGUAGE_MENU_ACTION);

		MainController.mainFrame.statusBar.attachToMenuElement(otherLangM);
		MainController.mainFrame.statusBar.attachToMenuElement(otherLangP);
		MainController.mainFrame.statusBar.attachToMenuElement(thisSide.jPopupMenuNewFromTemplateOrOtherLang);
	}

	public void setCurrentXMLLanguage(int langNr) {
		setCurrentXMLLanguage(MainController.xmlLanguages.get(langNr), false, false);
	}

	public void setCurrentXMLLanguage(XmlLanguage newXMLLang, boolean refresh, boolean close) {
		System.out.println("Set current XML language to \"" + newXMLLang.getName() + "\" ...\n");
		boolean isNewXMLLanguage = (newXMLLang != currentXMLLanguage);
		if (isNewXMLLanguage) {
			currentXMLLanguage = newXMLLang;
			aXMLNewEmptyFile.setEnabled(true);
			if (close && !thisSide.xmlView.isLoading() && (currentXMLLanguage != null))
				aClose.doCloseFile(false, true);
			XML_SHOW_ALL_ACTION.setSelected(true);
			summarizeDefListButtonGroup.unSelect();
			summarizeDefListPopupButtonGroup.unSelect();

			if ((currentXMLLanguage != null) && (currentXMLLanguage.getExt().equals(".macros")))
				MainController.aMacrosOpenXMLInMacrosView.setEnabled(MainController.mainFrame.macrosView.isLoaded());
			else MainController.aMacrosOpenXMLInMacrosView.setEnabled(false);
		}
		if (refresh || isNewXMLLanguage) {
			thisSide.langNameLabel.setText(currentXMLLanguage.getName());
			thisSide.langNameLabel.setIcon(currentXMLLanguage.getIcon());
			String tooltip = thisSide.langNameLabelDefaultToolTip + ": <b>" + currentXMLLanguage.getName() + "</b>";
			if ((currentXMLLanguage.getDescription() != null) && !currentXMLLanguage.getDescription().equals(""))
				thisSide.langNameLabel.setToolTipText(tooltip + "<br>&nbsp;&nbsp;" + currentXMLLanguage.getDescription());
			else
				thisSide.langNameLabel.setToolTipText(tooltip);
			dtdHelper.loadDTDFile(FileUtils.toAbsoluteFilePath(newXMLLang.getDtd().getNewFileName(), newXMLLang.getFile()));
			thisSide.jMenuTemplates.setEnabled(true);
			thisSide.jButtonNewFromTemplateOrOtherLang.setEnabled(true);
			if (MainController.ADVANCED_MODE) {
				final boolean foldingDefsAvailable = ((currentXMLLanguage.getApplicables().getFoldingDefs() != null) &&
						(currentXMLLanguage.getApplicables().getFoldingDefs().getFoldingDefList() != null));
				thisSide.subMenuLangFolding.setEnabled(foldingDefsAvailable);
				thisSide.popupSubMenuLangFolding.setEnabled(foldingDefsAvailable);
				final boolean highlightDefsAvailable = ((currentXMLLanguage.getApplicables().getHighlightDefs() != null) &&
						(currentXMLLanguage.getApplicables().getHighlightDefs().getHighlightDefList() != null));
				thisSide.subMenuLangHighlight.setEnabled(highlightDefsAvailable);
				thisSide.popupSubMenuLangHighlight.setEnabled(highlightDefsAvailable);
				final boolean filterDefsAvailable = ((currentXMLLanguage.getApplicables().getFilterDefs() != null) &&
						(currentXMLLanguage.getApplicables().getFilterDefs().getFilterDefList() != null));
				thisSide.subMenuLangFilter.setEnabled(filterDefsAvailable);
				thisSide.popupSubMenuLangFilter.setEnabled(filterDefsAvailable);
				final boolean summarizeDefsAvailable = ((currentXMLLanguage.getApplicables().getSummarizeDefs() != null) &&
						(currentXMLLanguage.getApplicables().getSummarizeDefs().getSummarizeDefList() != null));
				thisSide.subMenuLangSummarize.setEnabled(summarizeDefsAvailable);
				thisSide.popupSubMenuLangSummarize.setEnabled(summarizeDefsAvailable);
				final boolean stylesheetDefsAvailable = ((currentXMLLanguage.getApplicables().getStylesheets() != null) &&
						(currentXMLLanguage.getApplicables().getStylesheets().getStylesheetList() != null));
				thisSide.subMenuLangStylesheet.setEnabled(stylesheetDefsAvailable);
				thisSide.popupSubMenuLangStylesheet.setEnabled(stylesheetDefsAvailable);
			}

			thisSide.xmlView.getElementIconMap().setIconBaseDir(currentXMLLanguage.getFile().getParent());
			buildXMLLanguageMenus();

			DeltaFileChooser.FILE_VIEW.getExtensionToLanguagesMap().clear();
			for (XmlLanguage xmlLanguage : MainController.xmlLanguages)
				DeltaFileChooser.FILE_VIEW.getExtensionToLanguagesMap().add(xmlLanguage.getExt(), xmlLanguage);
		}
	}

	public void buildXMLLanguageMenus() {
		buildNewFromTemplateOrOtherLangMenus();
		if (MainController.ADVANCED_MODE) {
			buildFoldingMenus();
			buildHighlightMenus();
			buildSummarizeMenus();
			buildFilterMenus(null);
			buildIconSetsMenus();
			buildStylesheetsMenus();
		}
	}

	private void buildIconSetsMenus() {
		thisSide.subMenuLangIconSets.removeAll();
		thisSide.popupSubMenuLangIconSets.removeAll();
		if (currentXMLLanguage != null) {
			ButtonGroup buttonGroup1 = new ButtonGroup(), buttonGroup2 = new ButtonGroup();
			buttonGroup1.add(thisSide.subMenuLangIconSets.add(new SelectableRadioButtonMenuItem(BASE_ICONSET_ACTION)));
			buttonGroup2.add(thisSide.popupSubMenuLangIconSets.add(new SelectableRadioButtonMenuItem(BASE_ICONSET_ACTION)));
			BASE_ICONSET_ACTION.setSelected(true);
			File[] dirs = MainController.getIconDirs(thisSide.xmlView.getElementIconMap().getIconBaseDir());
			if (dirs.length > 0) {
				thisSide.subMenuLangIconSets.addSeparator();
				thisSide.popupSubMenuLangIconSets.addSeparator();
				for (int i = 0; i < dirs.length; i++) {
					final File dir = dirs[i];
					SelectableAction action = new RadioButtonAbstractAction("" + (i + 1) + ' ' + dir.getName(), (char) ('1' + i)) {
						public void stateChanged(ChangeEvent evt) {
							thisSide.xmlView.getElementIconMap().setIconSet(dir);
							thisSide.xmlView.repaint();
						}
					};
					buttonGroup1.add(thisSide.subMenuLangIconSets.add(new SelectableRadioButtonMenuItem(action)));
					buttonGroup2.add(thisSide.popupSubMenuLangIconSets.add(new SelectableRadioButtonMenuItem(action)));
				}
			}
			MainController.mainFrame.statusBar.attachToMenuElement(thisSide.subMenuLangIconSets);
		} else {
			thisSide.subMenuLangIconSets.setEnabled(false);
			thisSide.popupSubMenuLangIconSets.setEnabled(false);
		}
	}

	public void buildFilterMenus(String info) {
		thisSide.subMenuLangFilter.removeAll();
		thisSide.popupSubMenuLangFilter.removeAll();
		if (currentXMLLanguage != null) {
			ButtonGroup buttonGroup1 = new ButtonGroup(), buttonGroup2 = new ButtonGroup();
			if (currentXMLLanguage.getApplicables().getFilterDefs() != null) {
				List filterDefs = currentXMLLanguage.getApplicables().getFilterDefs().getFilterDefList();
				if ((filterDefs != null) && !filterDefs.isEmpty()) {
					for (int i = 0, size = filterDefs.size(); i < size; i++) {
						SelectableAction action = new XMLTreeFilterApplyPredefined(thisSideIndex,
								(FilterDef) filterDefs.get(i), i);
						buttonGroup1.add(thisSide.subMenuLangFilter.add(new SelectableRadioButtonMenuItem(action)));
						buttonGroup2.add(thisSide.popupSubMenuLangFilter.add(new SelectableRadioButtonMenuItem(action)));
					}
					thisSide.subMenuLangFilter.addSeparator();
					thisSide.popupSubMenuLangFilter.addSeparator();
				}
			}
			if (info != null) {
				SelectableAction customFilterMenuAction = new RadioButtonAbstractAction("Custom Filter", MainImages.FILTER_ICON, 'C', info, true) {
					public void stateChanged(ChangeEvent evt) { }
					protected void deselected() {
						SwingUtilities.invokeLater(new Runnable() {
			            	public void run() {
								buildFilterMenus(null);
							}
						});
					}
				};
				buttonGroup1.add(thisSide.subMenuLangFilter.add(new SelectableRadioButtonMenuItem(customFilterMenuAction)));
				buttonGroup2.add(thisSide.popupSubMenuLangFilter.add(new SelectableRadioButtonMenuItem(customFilterMenuAction)));
				thisSide.subMenuLangFilter.addSeparator();
				thisSide.popupSubMenuLangFilter.addSeparator();
			} else
				XML_SHOW_ALL_ACTION.setSelectedState(true);
			buttonGroup1.add(thisSide.subMenuLangFilter.add(new SelectableRadioButtonMenuItem(XML_SHOW_ALL_ACTION)));
			buttonGroup2.add(thisSide.popupSubMenuLangFilter.add(new SelectableRadioButtonMenuItem(XML_SHOW_ALL_ACTION)));
			thisSide.subMenuLangFilter.addSeparator();
			thisSide.popupSubMenuLangFilter.addSeparator();

			thisSide.subMenuLangFilter.add(ADD_FILTER_DEF_ACTION).setBorder(MainFrame.INTENTED_BORDER);
			thisSide.popupSubMenuLangFilter.add(ADD_FILTER_DEF_ACTION).setBorder(MainFrame.INTENTED_BORDER);
			MainController.mainFrame.statusBar.attachToMenuElement(thisSide.subMenuLangFilter);
			MainController.mainFrame.statusBar.attachToMenuElement(thisSide.popupSubMenuLangFilter);
		}
	}

	private void buildSummarizeMenus() {
		thisSide.subMenuLangSummarize.removeAll();
		thisSide.popupSubMenuLangSummarize.removeAll();
		if (currentXMLLanguage != null) {
			summarizeDefListButtonGroup.removeAll();
			summarizeDefListPopupButtonGroup.removeAll();
			if (currentXMLLanguage.getApplicables().getSummarizeDefs() != null) {
				List infoSummarizeDefs = currentXMLLanguage.getApplicables().getSummarizeDefs().getSummarizeDefList();
				if ((infoSummarizeDefs != null) && !infoSummarizeDefs.isEmpty()) {
					for (int i = 0, size = infoSummarizeDefs.size(); i < size; i++) {
						SelectableAction action = new XMLTreeSummarizeApplyPredefinedAction(thisSideIndex,
																							(SummarizeDef) infoSummarizeDefs.get(i), i);
						summarizeDefListButtonGroup.add(thisSide.subMenuLangSummarize.add(new SelectableRadioButtonMenuItem(action)));
						summarizeDefListPopupButtonGroup.add(thisSide.popupSubMenuLangSummarize.add(new SelectableRadioButtonMenuItem(action)));
					}
					thisSide.subMenuLangSummarize.addSeparator();
					thisSide.popupSubMenuLangSummarize.addSeparator();
				}
			}
			thisSide.subMenuLangSummarize.add(ADD_SUMMARIZE_DEF_ACTION).setBorder(MainFrame.INTENTED_BORDER);
			thisSide.popupSubMenuLangSummarize.add(ADD_SUMMARIZE_DEF_ACTION).setBorder(MainFrame.INTENTED_BORDER);
			MainController.mainFrame.statusBar.attachToMenuElement(thisSide.subMenuLangSummarize);
			MainController.mainFrame.statusBar.attachToMenuElement(thisSide.popupSubMenuLangSummarize);
		}
	}

	private void buildHighlightMenus() {
		thisSide.subMenuLangHighlight.removeAll();
		thisSide.popupSubMenuLangHighlight.removeAll();
		if (currentXMLLanguage != null) {
			if (currentXMLLanguage.getApplicables().getHighlightDefs() != null) {
				List highlightDefs = currentXMLLanguage.getApplicables().getHighlightDefs().getHighlightDefList();
				if ((highlightDefs != null) && !highlightDefs.isEmpty()) {
					for (int i = 0, size = highlightDefs.size(); i < size; i++) {
						Action action = new XMLTreeHighlightApplyPredefined(thisSideIndex,
								(HighlightDef) highlightDefs.get(i), i);
						thisSide.subMenuLangHighlight.add(action);
						thisSide.popupSubMenuLangHighlight.add(action);
					}
					thisSide.subMenuLangHighlight.addSeparator();
					thisSide.popupSubMenuLangHighlight.addSeparator();
				}
			}
			thisSide.subMenuLangHighlight.add(ADD_HIGHLIGHT_DEF_ACTION);
			thisSide.popupSubMenuLangHighlight.add(ADD_HIGHLIGHT_DEF_ACTION);
			MainController.mainFrame.statusBar.attachToMenuElement(thisSide.subMenuLangHighlight);
			MainController.mainFrame.statusBar.attachToMenuElement(thisSide.popupSubMenuLangHighlight);
		}
	}

	private void buildFoldingMenus() {
		thisSide.subMenuLangFolding.removeAll();
		thisSide.popupSubMenuLangFolding.removeAll();
		if (currentXMLLanguage != null) {
			if (currentXMLLanguage.getApplicables().getFoldingDefs() != null) {
				List foldingDefs = currentXMLLanguage.getApplicables().getFoldingDefs().getFoldingDefList();
				if ((foldingDefs != null) && !foldingDefs.isEmpty()) {
					for (int i = 0, size = foldingDefs.size(); i < size; i++) {
						Action action = new XMLTreeFoldingApplyPredefined(thisSideIndex, (FoldingDef) foldingDefs.get(i), i);
						thisSide.subMenuLangFolding.add(action);
						thisSide.popupSubMenuLangFolding.add(action);
					}
					thisSide.subMenuLangFolding.addSeparator();
					thisSide.popupSubMenuLangFolding.addSeparator();
				}
			}
			thisSide.subMenuLangFolding.add(ADD_FOLDING_DEF_ACTION);
			thisSide.popupSubMenuLangFolding.add(ADD_FOLDING_DEF_ACTION);
			MainController.mainFrame.statusBar.attachToMenuElement(thisSide.subMenuLangFolding);
			MainController.mainFrame.statusBar.attachToMenuElement(thisSide.popupSubMenuLangFolding);
		}
	}

	private void buildStylesheetsMenus() {
		thisSide.subMenuLangStylesheet.removeAll();
		thisSide.popupSubMenuLangStylesheet.removeAll();
		if (currentXMLLanguage != null) {
			if (currentXMLLanguage.getApplicables().getStylesheets() != null) {
				List stylesheetDefs = currentXMLLanguage.getApplicables().getStylesheets().getStylesheetList();
				if ((stylesheetDefs != null) && !stylesheetDefs.isEmpty()) {
					for (int i = 0, size = stylesheetDefs.size(); i < size; i++) {
						Action action = new XMLApplyPredefinedStylesheet(thisSideIndex, (Stylesheet) stylesheetDefs.get(i), i);
						thisSide.subMenuLangStylesheet.add(action);
						thisSide.popupSubMenuLangStylesheet.add(action);
					}
					thisSide.subMenuLangStylesheet.addSeparator();
					thisSide.popupSubMenuLangStylesheet.addSeparator();
				}
			}
			thisSide.subMenuLangStylesheet.add(ADD_STYLESHEET_DEF_ACTION);
			thisSide.popupSubMenuLangStylesheet.add(ADD_STYLESHEET_DEF_ACTION);
			MainController.mainFrame.statusBar.attachToMenuElement(thisSide.subMenuLangStylesheet);
			MainController.mainFrame.statusBar.attachToMenuElement(thisSide.popupSubMenuLangStylesheet);
		}
	}

	public void refreshXMLLanguages() {
		buildXMLLanguageMenus();
		if (currentXMLLanguage == null) {
			if (thisSide.deltaView.isLoaded())
				setCurrentXMLLanguageFromDocType(currentDocType, thisSide.deltaView.getFile());
		} else {
			if (MainController.xmlLanguages.indexOf(currentXMLLanguage) == -1) {
				if (!setCurrentXMLLanguageFromDocType(currentDocType, thisSide.deltaView.getFile())) {
					unsetCurrentXMLLanguage();
					aClose.doCloseFile(false, true);
				}
			} else
				setCurrentXMLLanguage(currentXMLLanguage, true, true);
		}
	}

	private CombinedURLFileChooserDialog dtdDialog;

	private static XmlLanguage searchForXMLLanguageExactMatch(String systemId, String rootElement, File xmlFile) {
		String absolutePathToDTD = FileUtils.toAbsoluteFilePath(systemId, xmlFile);
		String fileExt = FileUtils.getFileExt(xmlFile);

		for (XmlLanguage xmlLanguage : MainController.xmlLanguages) {
			Dtd dtd = xmlLanguage.getDtd();
			if (dtd == null) continue;

			if ((absolutePathToDTD.equals(FileUtils.toAbsoluteFilePath(dtd.getNewFileName(), xmlLanguage.getFile())) ||
					absolutePathToDTD.equals(FileUtils.toAbsoluteFilePath(dtd.getOldFileName(), xmlLanguage.getFile())))
					&& rootElement.equals(dtd.getRootElement()) && fileExt.equals(xmlLanguage.getExt()))
				return xmlLanguage;
		}
		return null;
	}

	private static XmlLanguage[] searchForXMLLanguagesInexactMatch(String systemId, String rootElement) {
		Collection<XmlLanguage> result = new TreeSet<XmlLanguage>(MainController.XML_LANGUAGE_COMPARATOR);
		String dtdFileName = FileUtils.getFileNameExt(systemId);

		for (XmlLanguage xmlLanguage : MainController.xmlLanguages) {
			Dtd dtd = xmlLanguage.getDtd();
			if (dtd == null) continue;

			if ((dtdFileName.equalsIgnoreCase(FileUtils.getFileNameExt(dtd.getNewFileName())) ||
					dtdFileName.equalsIgnoreCase(FileUtils.getFileNameExt(dtd.getOldFileName())))
					&& rootElement.equals(dtd.getRootElement()))
				result.add(xmlLanguage);
		}

		return (result.isEmpty() ? null : result.toArray(new XmlLanguage[result.size()]));
	}

	private static XmlLanguage[] searchForXMLLanguagesSimilarMatch(String systemId, String rootElement) {
		Collection<XmlLanguage> result = new TreeSet<XmlLanguage>(MainController.XML_LANGUAGE_COMPARATOR);
		String dtdFileName = FileUtils.getFileNameExt(systemId);

		for (XmlLanguage xmlLanguage : MainController.xmlLanguages) {
			Dtd dtd = xmlLanguage.getDtd();
			if (dtd == null) continue;

			if ((WLD.defaultMatch(dtdFileName, FileUtils.getFileNameExt(dtd.getNewFileName())) ||
					WLD.defaultMatch(dtdFileName, FileUtils.getFileNameExt(dtd.getOldFileName())))
					&& rootElement.equals(dtd.getRootElement()))
				result.add(xmlLanguage);
		}

		return (result.isEmpty() ? null : result.toArray(new XmlLanguage[result.size()]));
	}

	public boolean setCurrentXMLLanguageFromDocType(Doctype dt, File xmlFile) {
		return setCurrentXMLLanguageFromDocType(dt, xmlFile, false);
	}

	public boolean setCurrentXMLLanguageFromDocType(Doctype dt, File xmlFile, boolean askForDTDIfNotFound) {
		if (dt == null) {
			if (DeltaFileChooser.HTML_FILE_FILTER.accept(xmlFile)) {
				thisSide.langNameLabel.setText("HTML");
				thisSide.langNameLabel.setIcon(MainImages.HTML_ICON);
				thisSide.langNameLabel.setToolTipText(thisSide.langNameLabelDefaultToolTip);
			} else {
				Log.trace("DocType not specified or not found in \"" + xmlFile + "\"!");
				thisSide.langNameLabel.setText("");
				thisSide.langNameLabel.setIcon(null);
				thisSide.langNameLabel.setToolTipText(thisSide.langNameLabelDefaultToolTip + ": <b>none</b>");
			}
			unsetCurrentXMLLanguage();
			return false;
		}
		String systemId = dt.getSystemId();
//  String dtdFileName = FileUtils.getFileNameExt(systemId).toLowerCase();
//  if ((currentXMLLanguage != null) && dtdFileName.equals(currentXMLLanguage.getDtd().getNewFileName().toLowerCase()))
//  return false;  // same XML language again

		currentDocType = dt;
		boolean found = false;

		System.out.println("\nTry to determine XML language of \n    " + xmlFile+"\n    "+ systemId);
		XmlLanguage xmlLang = searchForXMLLanguageExactMatch(systemId, dt.getRootElement(), xmlFile);
		if (xmlLang == null) {
			XmlLanguage[] languages = searchForXMLLanguagesInexactMatch(systemId, dt.getRootElement());
			if (languages == null)
				languages = searchForXMLLanguagesSimilarMatch(systemId, dt.getRootElement());
			if (languages != null) {
				if (languages.length == 1)
					xmlLang = languages[0];
				else
					xmlLang = (XmlLanguage) JOptionPane.showInputDialog(MainController.mainFrame, "Choose appropriate XML language for\n\"" + xmlFile + "\" ...",
									"XML language selection", JOptionPane.QUESTION_MESSAGE, null, languages, languages[0]);
			}
		}
		if (xmlLang != null) {
			String oldSysId = systemId;
			String newSysId = xmlLang.getDtd().getNewFileName();
			if (!FileUtils.isURL(newSysId)) {
				newSysId = FileUtils.toRelativeFile(new File(xmlLang.getFile().getParent(), newSysId), xmlFile);
				if (EnvironmentProperties.OS_WINDOWS) oldSysId = oldSysId.replaceAll("/", "\\\\"); // since Java running on Windows can handle also / as file-separator
			}
			if (!oldSysId.equalsIgnoreCase(newSysId))
                switch (MainController.changeDocType) {
                    case Preferences.CHANGE_DOCTYPE_ASK:
                        if (JOptionPane.showConfirmDialog(MainController.mainFrame, "Change DocType entry of XML-File \"" + xmlFile +
                                "\"\n    from \"" + systemId + "\"\n    to \"" + newSysId + "\"?", "Change DocType", JOptionPane.YES_NO_OPTION) == JOptionPane.NO_OPTION)
                            break;
                    case Preferences.CHANGE_DOCTYPE_YES:
                        System.out.println("Change DocType entry of XML-File: " + xmlFile);
                        System.out.println("  from: " + systemId);
                        dt.setSystemId(newSysId);
                        System.out.println("  to: " + dt.getSystemId());
                }
			setCurrentXMLLanguage(xmlLang, false, false);
		} else {
			unsetCurrentXMLLanguage();
			thisSide.langNameLabel.setText("?");
			thisSide.langNameLabel.setIcon(null);
			thisSide.langNameLabel.setToolTipText(thisSide.langNameLabelDefaultToolTip + ": <b>unknown</b>");

			if (askForDTDIfNotFound) {
				String msg = null;
				try {
					URL dtdURL = FileUtils.toURL(systemId, xmlFile);
					if (dtdURL == null)
						msg = '\"' + systemId + "\" is not a valid Filename or URL!";
					else {
						InputStream in = dtdURL.openStream();
						if (in.read() == -1) msg = '\"' + systemId + "\" is an empty File!";
						in.close();
					}
				} catch (IOException exc) {
					msg = exc.getMessage();
				}
				if (msg != null) {
					JOptionPane.showMessageDialog(thisSide, msg + "\n\nPlease choose a valid DTD...", "Could not open DTD",
							JOptionPane.ERROR_MESSAGE);
					if (dtdDialog == null) {
						dtdDialog = new CombinedURLFileChooserDialog(thisSide, DeltaFileChooser.DTD_FILE_FILTER);
						dtdDialog.setFileView(DeltaFileChooser.FILE_VIEW);
					}
					dtdDialog.setCurrentDirectory(xmlFile.getParentFile());
					if (dtdDialog.showDialog()) {
						if (dtdDialog.hasFileResult())
							systemId = FileUtils.toRelativeFile(dtdDialog.getFile(), xmlFile);
						else
							systemId = dtdDialog.getURL().toString();
						dt.setSystemId(systemId);
						return setCurrentXMLLanguageFromDocType(dt, xmlFile, false);
					} //else throw new RuntimeException("Could not read from \"" + systemId + "\"!");
				}
			}
		}
		return found;
	}

	public void unsetCurrentXMLLanguage() {
		if (currentXMLLanguage != null) {
			currentXMLLanguage = null;
			thisSide.jMenuTemplates.setEnabled(false);
			thisSide.jButtonNewFromTemplateOrOtherLang.setEnabled(false);
			if (MainController.ADVANCED_MODE) {
				thisSide.subMenuLangFolding.setEnabled(false);
				thisSide.popupSubMenuLangFolding.setEnabled(false);
				thisSide.subMenuLangHighlight.setEnabled(false);
				thisSide.popupSubMenuLangHighlight.setEnabled(false);
				thisSide.subMenuLangSummarize.setEnabled(false);
				thisSide.popupSubMenuLangSummarize.setEnabled(false);
				thisSide.subMenuLangFilter.setEnabled(false);
				thisSide.popupSubMenuLangFilter.setEnabled(false);
				thisSide.subMenuLangIconSets.setEnabled(false);
				thisSide.popupSubMenuLangIconSets.setEnabled(false);
				thisSide.subMenuLangStylesheet.setEnabled(false);
				thisSide.popupSubMenuLangStylesheet.setEnabled(false);
			}

			thisSide.fileChooser.setCurrentDirectory(FileUtils.currentDirFile);
			aXMLNewEmptyFile.setEnabled(false);
		}
		if (((currentXMLLanguage != null) || thisSide.jMenuNewFromOtherLang.getItemCount() == 0))
			buildNewFromTemplateOrOtherLangMenus();
	}

	public boolean saveIfChanged(boolean cancelButton) {
		if (thisSide.deltaView.contentHasChanged()) {
			int autoSaveType = MainController.preferences.getInt(Preferences.KEY_AUTO_SAVE);
			if (MainController.currentProcess != null)
				autoSaveType = GUIConstants.AUTO_SAVE_YES;
			switch (autoSaveType) {
				case GUIConstants.AUTO_SAVE_ASK:
					switch (JOptionPane.showConfirmDialog(MainController.mainFrame,
														  "The content of the " + sideName + " file \"" + thisSide.deltaView.getFilePath() +
														  "\" has been changed.\n\nDo you want to save it ?",
														  "Save", (cancelButton ? JOptionPane.YES_NO_CANCEL_OPTION : JOptionPane.YES_NO_OPTION),
														  JOptionPane.QUESTION_MESSAGE)) {
						case JOptionPane.YES_OPTION:
							aSave.doSaveFileInSameThread();
							break;
						case JOptionPane.NO_OPTION:
							break;
						case JOptionPane.CANCEL_OPTION:
							return false;
					}
					break;
				case GUIConstants.AUTO_SAVE_YES:
					aSave.doSaveFileInSameThread();
			}
		}
		return true;
	}

	public void resetXMLTreeActions() {
		aXMLTreeShowCommentNodes.setSelectedState(true);
		aXMLTreeShowTextNodes.setSelectedState(true);
		aXMLTreeShowDocumentNode.setSelectedState(true);
		aXMLTreeShowCDATANodes.setSelectedState(true);
		aXMLTreeShowPINodes.setSelectedState(true);
		XML_SHOW_ALL_ACTION.setSelectedState(true);
		summarizeDefListButtonGroup.unSelect();
		summarizeDefListPopupButtonGroup.unSelect();
		thisSide.visualizeFilterState(isTypeXML(), false);
	}

	public void fireDirectUndoableEditHappened(UndoableEdit undoableEdit) {
		undoHandler.undoableEditHappened(new UndoableEditEvent(this, undoableEdit));
	}

	private class HTMLViewCaretListener implements CaretListener {
// the type of the corresponding DeltaSide object is 'HTML'
// this means that thisSide.deltaView == thisSide.htmlView == evt.getSource()
		public void caretUpdate(CaretEvent evt) {
			int thisLinkID = thisSide.htmlView.getCurrentDELTALinkID(true);
			int otherLinkID = otherSide.deltaView.getCurrentDELTALinkID(true);

			if (thisLinkID == LinkIDConstants.NO_LINK)
				otherSide.deltaView.removeHighlights();

			boolean linksOnBothSidesSelected = ((thisLinkID >= LinkIDConstants.FIRST_ID) && (otherLinkID >= LinkIDConstants.FIRST_ID));
			MainController.aMacroInsert.setEnabled(otherSideController.isTypeXML()
					// && MainController.mainFrame.macrosView.isMacroLink()
					&& thisSide.htmlView.acceptsNewDELTALink(false, false) && !linksOnBothSidesSelected
					&& otherSideController.dtdHelper.isMacroInsertable(MainController.mainFrame.macrosView.getMacroXMLElement()));

			aInsertNewDELTALink.setEnabled(thisSide.deltaView.acceptsNewDELTALink(true, false) && otherSide.deltaView.acceptsNewDELTALink(false,
																																   false)
					&& !linksOnBothSidesSelected);
			otherSideController.aInsertNewDELTALink.setEnabled(thisSide.deltaView.acceptsNewDELTALink(false, false) && otherSide.deltaView.acceptsNewDELTALink(true,
																																							   false)
					&& !linksOnBothSidesSelected);

			aHTMLRemoveLinks.setEnabled((thisLinkID >= LinkIDConstants.FIRST_ID) || (thisLinkID == LinkIDConstants.BAD_LINK));
			aSynchronizeLinks.setEnabled(
					(otherLinkID >= LinkIDConstants.FIRST_ID) &&
					(((thisLinkID >= LinkIDConstants.FIRST_ID) && (otherLinkID != thisLinkID)) || (thisLinkID == LinkIDConstants.BAD_LINK)));
			otherSideController.aSynchronizeLinks.setEnabled(
					(otherLinkID >= LinkIDConstants.FIRST_ID) && (thisLinkID >= LinkIDConstants.FIRST_ID) && (otherLinkID != thisLinkID));
			aActivateLinks.setEnabled((thisLinkID >= LinkIDConstants.FIRST_ID) || (thisLinkID == LinkIDConstants.BAD_LINK));
			aHighlightSameLinks.setEnabled(thisLinkID != LinkIDConstants.NO_LINK);
		}
	}

	private class XMLViewTreeSelectionListener implements TreeSelectionListener {
		// the type of the corresponding DeltaSide object is 'XML'
		// this means that thisSide.deltaView == thisSide.xmlView == evt.getSource()
		public void valueChanged(TreeSelectionEvent evt) {
			MainController.setActiveSideIndex(thisSideIndex, false); // at first set the new active side, but do not refresh

			if (evt.getPath() != null) { // is something selected?
				aGoForward.setEnabled(false);

				aGoBack.setEnabled(thisSide.xmlView.canGoBack());
				otherSide.deltaView.removeHighlights();

				XMLTreeNode xmlTreeNode = (XMLTreeNode) evt.getPath().getLastPathComponent();
				Node xmlNode = xmlTreeNode.getXMLNode();

				if (aXMLShowXPathBar.isSelected())
					thisSide.setXPathText(xmlTreeNode.getXPath());
				if (aXMLShowTreePathBar.isSelected())
					thisSide.getTreePathBar().setTreePath(xmlTreeNode.getTreePath());
				else if (aXMLShowAutoXPathBar.isSelected() && (currentXMLLanguage != null))
					thisSide.getAutoXPathBar().refresh(currentXMLLanguage.getAutoXPathDefs(), xmlNode);

				thisSide.xmlNodeLabel.setText(xmlTreeNode.getShortDescription());
				int lineNumberOfNode = thisSide.xmlView.getLineNumber();
				thisSide.xmlNodeLabel.setToolTipText((lineNumberOfNode != -1) ? "line #" + lineNumberOfNode : "");

				final short nodeType = xmlNode.getNodeType();

				aXMLTreeGotoParent.setEnabled(xmlTreeNode.getParent() != null);
				aXMLTreeGotoNextSibling.setEnabled(xmlTreeNode.hasPreviousSiblings());
				aXMLTreeGotoPreviousSibling.setEnabled(xmlTreeNode.hasNextSiblings());

				dtdHelper.setTargetElement(xmlNode);
				rebuildChangeAttributesPopupMenu();

				MainController.aEditCopy.setEnabled((xmlNode.getNodeType() != Node.DOCUMENT_NODE)
						&& (xmlNode.getNodeType() != Node.DOCUMENT_TYPE_NODE));
				MainController.aEditCut.setEnabled(dtdHelper.isNodeRemoveable());

				MainController.resetPasteActions();

				if (MainController.mainFrame.macrosView.isLoaded()) {
					if (!MainController.mainFrame.macrosView.setDTDHelper(dtdHelper))
						MainController.mainFrame.macrosView.resetMacroListItems(); // have to refresh MacrosView after setTargetElement()
					MainController.resetMacroInsertModes(dtdHelper); // may also call macrosView.resetMacroListItems()
					MainController.mainFrame.macroInfoTree.repaint();
					MainController.mainFrame.jLabelMacroPreview.setIcon(MainController.mainFrame.macrosView.getCurrentItemIcon());
				}

				if ((MainController.insertableElementsDialog != null) && MainController.insertableElementsDialog.isVisible()) {
					MainController.insertableElementsDialog.refreshLists(dtdHelper);
					thisSide.deltaView.requestFocusInWindow();
				}
				if ((MainController.allElementsDialog != null) && MainController.allElementsDialog.isVisible())
					MainController.allElementsDialog.targetElementChanged(dtdHelper);

				aXMLRemoveNode.setEnabled(dtdHelper.isNodeRemoveable());
				aXMLDuplicateNode.setEnabled(dtdHelper.isNodeDuplicatable());
				aActivateLinks.setEnabled(xmlTreeNode.hasDELTALinkDescendant());
				aXMLCommentElement.setEnabled(xmlTreeNode);

				if (nodeType == Node.ELEMENT_NODE) {

//  ElementInfo elementInfo = dtdGrammar.getElementInfo(new DOMElementWrapper((Element) xmlNode));

//  System.out.println("getAllowedNextSiblings: "+elementInfo.getAllowedNextSiblings());
//  System.out.println("getAllowedPreviousSiblings: "+elementInfo.getAllowedPreviousSiblings());
//  System.out.println("canRemoveElement: "+elementInfo.canRemoveElement());

					aXMLSetRootTreeNode.setEnabled(true);
					aXMLGoToElementDefinitionInDTDReport.setEnabled(true);
					aXMLGoToElementDefinitionInDTDSource.setEnabled(true);

					aXMLAddRequiredContent.setEnabled(!xmlNode.hasChildNodes());  // todo: ignore comment nodes
					thisSide.xmlAttributesTable.setXMLTreeNode(xmlTreeNode);
					thisSide.xmlInfoPanel.switchToCard(MainFrame.CARD_XML_ATTRS);

					int thisLinkID = xmlTreeNode.getDELTALinkID();
					int otherLinkID = otherSide.deltaView.getCurrentDELTALinkID(true);

					boolean linksOnBothSidesSelected = ((thisLinkID >= LinkIDConstants.FIRST_ID) && (otherLinkID >= LinkIDConstants.FIRST_ID));
					MainController.aMacroInsert.setEnabled((!MainController.mainFrame.macrosView.isMacroLink()
							|| (otherSide.deltaView.acceptsNewDELTALink(false, false) && !linksOnBothSidesSelected))
							&& MainController.mainFrame.macrosView.isMacroInsertable());

					aSynchronizeLinks.setEnabled(
							(thisLinkID >= LinkIDConstants.FIRST_ID) && (otherLinkID >= LinkIDConstants.FIRST_ID) && (otherLinkID != thisLinkID));
					otherSideController.aSynchronizeLinks.setEnabled(
							(thisLinkID >= LinkIDConstants.FIRST_ID) &&
							(((otherLinkID >= LinkIDConstants.FIRST_ID) && (otherLinkID != thisLinkID)) || (otherLinkID == LinkIDConstants.BAD_LINK)));

					aInsertNewDELTALink.setEnabled(thisSide.deltaView.acceptsNewDELTALink(true, false) && otherSide.deltaView.acceptsNewDELTALink(false,
																																				  false)
							&& !linksOnBothSidesSelected);
					otherSideController.aInsertNewDELTALink.setEnabled(thisSide.deltaView.acceptsNewDELTALink(false, false) && otherSide.deltaView.acceptsNewDELTALink(true,
																																									   false)
							&& !linksOnBothSidesSelected);
					aHighlightSameLinks.setEnabled(thisLinkID != LinkIDConstants.NO_LINK);

					aXMLAttributeAdd.setEnabled(false);
					if (xmlTreeNode.isDELTALinkElement()) {
// show only "comment" attribute
						thisSide.newAttributesComboBoxModel.clear();
						if (!((Element) xmlNode).hasAttribute("comment"))
							thisSide.newAttributesComboBoxModel.addElement("comment");
					} else
						thisSide.newAttributesComboBoxModel.init(dtdHelper.getNewAttributes());
					boolean xmlAttributeInsertEnabled = thisSide.newAttributesComboBoxModel.getSize() != 0;

					aXMLAttributeAdd.setEnabled(xmlAttributeInsertEnabled);
					thisSide.newAttributesComboBox.setEnabled(xmlAttributeInsertEnabled);
					aXMLChangeTextValue.setEnabled(false);
					thisSide.popupMenuXMLNodeTextArea.setEnabled(false);
					return;
				}
				thisSide.xmlNodeInfoText.setText(xmlTreeNode.getInfoText());
				thisSide.xmlNodeInfoText.setCaretPosition(0);
				boolean changeNodeValueEnabled = (nodeType == Node.COMMENT_NODE) || (nodeType == Node.TEXT_NODE);
				aXMLChangeTextValue.setEnabled(changeNodeValueEnabled);
				thisSide.popupMenuXMLNodeTextArea.setEnabled(changeNodeValueEnabled);
			} else {
				MainController.resetPasteActions();
				aXMLRemoveNode.setEnabled(false);
				aXMLDuplicateNode.setEnabled(false);
				thisSide.popupMenuXMLNodeTextArea.setEnabled(false);
				aXMLChangeTextValue.setEnabled(false);
				MainController.aEditCopy.setEnabled(false);
				MainController.aEditCut.setEnabled(false);
				thisSide.xmlNodeInfoText.setText(null);
				aGoBack.setEnabled(false);
				aActivateLinks.setEnabled(false);
				aXMLChangeTextValue.setEnabled(false);
				aXMLCommentElement.setEnabled(false);
				thisSide.popupMenuXMLNodeTextArea.setEnabled(false);
				dtdHelper.setTargetElement(null);
				thisSide.menuXMLAttributeChangeTo.setEnabled(false);
				MainController.mainFrame.macrosView.resetMacroListItems(); // have to refresh MacrosView after setTargetElement()
				if (MainController.mainFrame.macrosView.isLoaded()) {
					MainController.mainFrame.macroInfoTree.repaint();
					MainController.mainFrame.jLabelMacroPreview.setIcon(MainController.mainFrame.macrosView.getCurrentItemIcon());
				}
			}
			MainController.aMacroInsert.setEnabled(false);
			thisSide.xmlAttributesTable.setXMLTreeNode(null);
			thisSide.xmlInfoPanel.switchToCard(MainFrame.CARD_XML_INFO);
			aInsertNewDELTALink.setEnabled(false);
			aXMLAddRequiredContent.setEnabled(false);
			aXMLAttributeAdd.setEnabled(false);
			aXMLGoToElementDefinitionInDTDReport.setEnabled(false);
			aXMLGoToElementDefinitionInDTDSource.setEnabled(false);
			thisSide.newAttributesComboBoxModel.clear();
			thisSide.newAttributesComboBox.setEnabled(false);
			aHighlightSameLinks.setEnabled(false);
			aXMLSetRootTreeNode.setEnabled(false);
			aSynchronizeLinks.setEnabled(false);
			otherSideController.aSynchronizeLinks.setEnabled(false);
		}
	}

	private static final Pattern PATTERN_NUMBERED_FILENAME = Pattern.compile("([0-9]*[1-9])");

	private class DeltaViewHyperlinkListener implements HyperlinkListener {
		private final MessageFormat LINK_MSG_FORMAT = new MessageFormat(
				"{0} " + ((thisSideIndex == GUIConstants.LEFT) ? "->" : "<-") + " {1} link, id #{2}{3,choice,-1#|0<, {3} link endpoint(s)}");

		public void hyperlinkUpdate(HyperlinkEvent evt) {
			if (evt.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {
				if (evt instanceof DeltaHyperlinkEvent) {
					DeltaHyperlinkEvent deltaEvent = (DeltaHyperlinkEvent) evt;
					if ((deltaEvent.gmtLinkPrefix > 0) && otherSide.deltaView.isLoaded()) {
						File oldFile = otherSide.deltaView.getFile();
						String oldFileName = oldFile.getName();
						Matcher matcher = PATTERN_NUMBERED_FILENAME.matcher(oldFileName);
						if (matcher.find()) {
							String pattern = matcher.group();
							int index1 = matcher.start();
							int index2 = matcher.end();
							pattern = pattern.replaceAll(".", "0");
							pattern = new DecimalFormat(pattern).format(deltaEvent.gmtLinkPrefix);
							String newFileName = MiscUtils.replace(oldFileName, index1, index2 - 1, pattern);
							if (!oldFileName.equals(newFileName)) {
								File newFile = new File(oldFile.getParent(), newFileName);
								if (!newFile.exists())
									JOptionPane.showMessageDialog(otherSide, "File \"" + newFileName + "\" doesn not exist!", "Load File", JOptionPane.WARNING_MESSAGE);
								else
									try {
										otherSide.deltaView.load(newFile);
										otherSide.setFileNameLabel(newFile);
									} catch (Exception e) {
										e.printStackTrace();
										JOptionPane.showMessageDialog(otherSide, "Could not load " + newFileName, "Load File", JOptionPane.ERROR_MESSAGE);
										try {
											otherSide.deltaView.load(oldFile);
										} catch (Exception e1) { }
									}
							}
						}
					}
					otherSideController.aSwitchToViewer.setSelected(true);
					int deltaLinkID = deltaEvent.deltaLinkID;
					if (deltaEvent.deltaLinkIDs != null) {
						otherSide.deltaView.removeDELTALinksFromCollection(deltaEvent.deltaLinkIDs, false);
						if (deltaEvent.deltaLinkIDs.isEmpty()) return;
						if (deltaEvent.deltaLinkIDs.size() == 1) deltaLinkID = deltaEvent.deltaLinkIDs.first().intValue();
					}
					if (deltaLinkID == -1) {
						JPopupMenu popupMenu = new JPopupMenu();
						popupMenu.add(new MainFrame.MenuLabel("DELT/A-Links:", 6));
						popupMenu.addSeparator();
						Iterator iter = deltaEvent.deltaLinkIDs.iterator();
						for (int i = 0, size = deltaEvent.deltaLinkIDs.size(); i < size; i++) {
							final int id = ((Integer) iter.next()).intValue();
							popupMenu.add(new SimpleAction("Link id #" + id,
									"Jump to link id #" + id + "\n... " + otherSide.deltaView.getDELTALinkContext(id),
									"Link id #" + id + " - " + otherSide.deltaView.getDELTALinkCount(id) + " link endpoint(s)") {
								protected void simpleActionPerformed() {
									otherSide.deltaView.jumpToDELTALink(id);
									otherSideController.aXMLDELTALinksVisualizationDown.setSelected(false);
									otherSideController.aXMLDELTALinksVisualizationUp.setSelected(false);
									otherSideController.aGoBack.setEnabled(true);
									otherSideController.aGoForward.setEnabled(false);
								}
							});
						}
						MainController.mainFrame.statusBar.attachToMenuElement(popupMenu);
						Point p = PopupMenuHandler.getSuitableLocation(deltaEvent.clickedLocation, popupMenu.getPreferredSize(), (Component) thisSide.deltaView);
						// Log.trace("before show");
						popupMenu.show((Component) thisSide.deltaView, p.x, p.y);
						// Log.trace("after show");

						/*int selectedLinkID = letUserChooseLink(deltaEventnt.deltaLinkIDs, deltaEventnt.clickedLocation);
						if (selectedLinkID > -1) {
							otherSide.deltaView.jumpToDELTALink(selectedLinkID);
							otherSideController.aXMLDELTALinksVisualizationDown.setSelected(false);
							otherSideController.aXMLDELTALinksVisualizationUp.setSelected(false);
							otherSideController.aGoBack.setEnabled(true);
							otherSideController.aGoForward.setEnabled(false);
						}*/

					} else {
						otherSide.deltaView.jumpToDELTALink(deltaLinkID);
						otherSideController.aXMLDELTALinksVisualizationDown.setSelected(false);
						otherSideController.aXMLDELTALinksVisualizationUp.setSelected(false);
						otherSideController.aGoBack.setEnabled(true);
						otherSideController.aGoForward.setEnabled(false);
						SwingUtilities.invokeLater(new Runnable() {
							public void run() {
								MainController.setActiveSideIndex(otherSideController.thisSideIndex);
							}
						});
					}
				} else if (evt.getDescription() != null) {
					aGoBack.setEnabled(true);
					aGoForward.setEnabled(false);
					String file = evt.getURL().getFile();
					thisSide.setFileNameLabel(file.substring(file.lastIndexOf('/') + 1), file);//fileNameLabel.setText(file.substring(file.lastIndexOf('/') + 1));
				//	thisSide.fileNameLabel.setToolTipText(file);
				}
			} else if (evt.getEventType() == HyperlinkEvent.EventType.ENTERED)
				if (evt instanceof DeltaHyperlinkEvent) {
					DeltaHyperlinkEvent deltaEvent = (DeltaHyperlinkEvent) evt;
					String gmtLinkStr = null;
					boolean foundInOtherSide;
					int gmtLinkCount = -1;
					int gmtLinkID = deltaEvent.deltaLinkID;
					if (deltaEvent.deltaLinkIDs != null) {
						gmtLinkStr = deltaEvent.deltaLinkIDs.toString();
						otherSide.deltaView.removeDELTALinksFromCollection(deltaEvent.deltaLinkIDs, false);
						if (!deltaEvent.deltaLinkIDs.isEmpty()) {
							gmtLinkStr = deltaEvent.deltaLinkIDs.toString();
							if (deltaEvent.deltaLinkIDs.size() == 1)
								gmtLinkID = deltaEvent.deltaLinkIDs.first().intValue();
						}
					}
					if (gmtLinkID == -1) {
						foundInOtherSide = ((deltaEvent.deltaLinkIDs != null) && !deltaEvent.deltaLinkIDs.isEmpty());
						if (foundInOtherSide) gmtLinkStr = deltaEvent.deltaLinkIDs.toString();
					} else {
						gmtLinkCount = otherSide.deltaView.getDELTALinkCount(gmtLinkID);
						foundInOtherSide = (gmtLinkCount > 0); //otherSide.deltaView.containsDELTALink(deltaEvent.deltaLinkID);
						gmtLinkStr = String.valueOf(gmtLinkID);
					}
					if (foundInOtherSide) {
						if (type == GUIConstants.XML)
							thisSide.xmlView.setCursor(GlobalObjects.DELTA_LINK_CURSOR);
						MainController.mainFrame.statusBar.setMessage(LINK_MSG_FORMAT.format(new Object[]{
							GUIConstants.TYPE_NAMES[MainController.deltaSideController[GUIConstants.LEFT].type],
							GUIConstants.TYPE_NAMES[MainController.deltaSideController[GUIConstants.RIGHT].type],
							gmtLinkStr,
							new Integer(gmtLinkCount)}));
					} else {
						if (type == GUIConstants.XML)
							thisSide.xmlView.setCursor(GlobalObjects.XML_LINK_ERROR_CURSOR);
						else
							thisSide.htmlView.setLinkCursor(GlobalObjects.XML_LINK_ERROR_CURSOR);
						if (otherSideController.type == GUIConstants.EMPTY)
							MainController.mainFrame.statusBar.setMessage("Opposite side is empty.");
						else
							MainController.mainFrame.statusBar.setMessage("DELT/A-Link id " + gmtLinkStr + " not found in opposite file!");
					}
				} else if (evt.getDescription() == null)
					MainController.mainFrame.statusBar.setMessage("URL not viewable: " + evt.getURL());
				else
					MainController.mainFrame.statusBar.setMessage("Link to \"" + evt.getDescription() + '\"');
			else if (evt.getEventType() == HyperlinkEvent.EventType.EXITED) {
				if (type == GUIConstants.XML) thisSide.xmlView.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
				MainController.mainFrame.statusBar.popMessage();
			}
		}
	}

	/*private int letUserChooseLink(Collection deltaLinkIDs, Point clickedLocation) { // todo letUserChooseLink
		final JPopupMenu popupMenu = new JPopupMenu();
		popupMenu.add(new MainFrame.MenuLabel("DELT/A-Links:", 6));
		popupMenu.addSeparator();
		Iterator iter = deltaLinkIDs.iterator();

		final int selectedLinkID[] = new int[] {0};
		class AWTInvocationLock { }
		final Object lock = new AWTInvocationLock();

		for (int i = 0, size = deltaLinkIDs.size(); i < size; i++) {
			final int id = ((Integer) iter.next()).intValue();
			popupMenu.add(new SimpleAction("Link id #" + id,
										   "Jump to link id #" + id + "\n... " + otherSide.deltaViewewewew.getDELTALinkContext(id),
										   "Link id #" + id + " - " + otherSide.deltaViewewewew.getDELTALinkCount(id) + " link endpoint(s)") {
				protected void simpleActionPerformed() {
					Log.trace("clicked");
					synchronized (lock) {
						selectedLinkID[0] = id;
						lock.notifyAll();
					}
				}
			});
		}
		popupMenu.addPopupMenuListener(new PopupMenuListener() {
			public void popupMenuWillBecomeVisible(PopupMenuEvent e) {
				Log.trace("popupMenuWillBecomeVisible");
			}
			public void popupMenuWillBecomeInvisible(PopupMenuEvent e) {
				Log.trace("popupMenuWillBecomeInvisible");
			}
			public void popupMenuCanceled(PopupMenuEvent e) {
				Log.trace("popupMenuCanceled");
				synchronized (lock) {
					selectedLinkID[0] = -1;
					lock.notifyAll();
				}
			}
		});
		MainController.mainFrame.statusBar.attachToPopupMenu(popupMenu);
		final Point point = PopupMenuHandler.getSuitableLocation(clickedLocation, popupMenu.getPreferredSize(),
													   (Component) thisSide.deltaViewewewew);

		synchronized (lock) {
			Log.trace("vor show");
			popupMenu.show((Component) thisSide.deltaViewewewew, point.x, point.y);
			Log.trace("nach show");
			try {
				lock.wait();
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
			Log.trace("nach wait");
		}

	// while (selectedLinkID[0] == 0) ;

		return selectedLinkID[0];
	}
*/
	private void rebuildChangeAttributesPopupMenu() {
		Set newAttributes = dtdHelper.getNewAttributes();
		thisSide.menuXMLAttributeChangeTo.removeAll();
		if (newAttributes.isEmpty())
			thisSide.menuXMLAttributeChangeTo.setEnabled(false);
		else {
			thisSide.menuXMLAttributeChangeTo.setEnabled(true);
			Iterator iterator = newAttributes.iterator();
			for (int i = 0, size = newAttributes.size(); i < size; i++) {
				final String attributeName = (String) iterator.next();
				thisSide.menuXMLAttributeChangeTo.add(new SimpleAction("" + (i + 1) + ' ' + "Change to '" + attributeName + "'", (char) ('1' + i)) {
					protected void simpleActionPerformed() {
						if (thisSide.xmlAttributesTable.changeCurrentAttribute(attributeName)) {
							rebuildChangeAttributesPopupMenu();
							aXMLAttributeAdd.setEnabled(false);
							thisSide.newAttributesComboBoxModel.init(dtdHelper.getNewAttributes());
							aXMLAttributeAdd.setEnabled(true);
							boolean xmlAttributeInsertEnabled = thisSide.newAttributesComboBoxModel.getSize() != 0;
							aXMLAttributeAdd.setEnabled(xmlAttributeInsertEnabled);
							thisSide.newAttributesComboBox.setEnabled(xmlAttributeInsertEnabled);
						}
					}
				});
			}
		}
	}

	private class XMLAttributesTableSelectionListener implements ListSelectionListener {
		public void valueChanged(ListSelectionEvent evt) {
			boolean currentAttributeRemoveable = thisSide.xmlAttributesTable.isCurrentAttributeRemoveable();
			aXMLAttributeRemove.setEnabled(currentAttributeRemoveable);
			thisSide.menuXMLAttributeChangeTo.setEnabled(currentAttributeRemoveable
					&& (thisSide.menuXMLAttributeChangeTo.getMenuComponentCount() > 0));
		}
	}

	private class XMLAttributesTableModelListener implements TableModelListener {
		public void tableChanged(TableModelEvent evt) {
			if (evt.getColumn() == 0) return;  // tree node selection changed?
			XMLTreeNode xmlTreeNode = thisSide.xmlAttributesTable.getXMLTreeNode();
			if (xmlTreeNode == null) return;
			if (evt.getType() != TableModelEvent.UPDATE) {
				thisSide.xmlView.xmlTreeNodeChanged(xmlTreeNode);
				if (evt.getType() == TableModelEvent.DELETE) {
					String removedAttributeName = ((XMLAttributesTableModel) evt.getSource()).getLastChangedAttributeName();
					if (removedAttributeName != null) {
						aXMLAttributeAdd.setEnabled(false);
						thisSide.newAttributesComboBoxModel.insertElementAt(removedAttributeName, 0);
						aXMLAttributeAdd.setEnabled(true);
						thisSide.newAttributesComboBox.setEnabled(true);
						if (thisSide.xmlAttributesTable.getRowCount() == 0)
							aXMLAttributeRemove.setEnabled(false);
					}
				} else {   // TableModelEvent.INSERT
					aXMLAttributeAdd.setEnabled(false);
					String addedAttributeName = ((XMLAttributesTableModel) evt.getSource()).getLastChangedAttributeName();
					thisSide.newAttributesComboBoxModel.removeElement(addedAttributeName);
					boolean addAttrEnable = (thisSide.newAttributesComboBoxModel.getSize() > 0);
					aXMLAttributeAdd.setEnabled(addAttrEnable);
					thisSide.newAttributesComboBox.setEnabled(addAttrEnable);
				}
				rebuildChangeAttributesPopupMenu();
			} else  // TableModelEvent.UPDATE
				thisSide.xmlView.xmlTreeNodeChanged(xmlTreeNode);
		}
	}

	private class DeltaViewChangeListener implements ChangeListener {
		public void stateChanged(ChangeEvent evt) {
			if (thisSide.deltaView.contentHasChanged()) {
				thisSide.fileNameLabel.setFont(MainFrame.UNSAVED_FILENAME_FONT);
				aSave.setEnabled(true);
				MainController.aFileSaveAll.setEnabled(true);
				aRevert.setEnabled(FileUtils.backupExists(thisSide.deltaView.getFile()));
				sourceViewNeedsUpdateXHTMLSource = textViewNeedsUpdateXHTMLSource = true;
			} else
				thisSide.fileNameLabel.setFont(MainFrame.SAVED_FILENAME_FONT);
			thisSide.fileNameLabel.getParent().validate();
		}
	}
}
