/*
 * Project: DELTA - Guideline Markup Tool / Version: 2.7.3.#452
 * User: peter
 * Date: 30.04.2003
 * Time: 12:15:04
 */
package at.ac.tuwien.asgaard.delta.gui;

import org.w3c.dom.Node;

import java.awt.*;
import java.util.Collection;
import java.util.Set;

import javax.swing.event.*;

/**
 * Class DeltaSideView ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.4.0
 */
public interface DeltaSideView extends DeltaView {
	public String getSourceHTML();

	public String getSourcePlain();


	public int getMaxDELTALinkID();

	public void setExternalMaxDELTALinkID(int externalMaxDELTALinkID);

	public void insertNewDELTALink(int newDELTALinkID);

	public boolean acceptsNewDELTALink(boolean activeSide, boolean includeHTMLView);

	public int getDELTALinkCount(int gmtLinkID);
	public String getDELTALinkContext(int gmtLinkID);
	public Set getAllLinkIDs();

	public boolean containsDELTALink(int gmtLinkID);

	public void jumpToDELTALink(int gmtLinkID);

	public void removeDELTALinksFromCollection(Collection<Integer> deltaLinks, boolean contained);

	public void highlightAllDELTALinks();
	public void highlightSameDELTALinks();
	public void highlightDeadDELTALinks(Collection<Integer> linksOfOtherSide);

	public void removeDELTALinks(Set<Integer> gmtLinks);

	public boolean removeDELTALink(int gmtLinkID);

	public int getCurrentDELTALinkID(boolean useCache);


	public void addHyperlinkListener(HyperlinkListener listener);

	public void removeHyperlinkListener(HyperlinkListener listener);


	public boolean contentHasChanged();
	public void contentHasChanged(boolean hasChanged);

	/**
	 * Adds a change listener for notification of any changes.
	 *
	 * @param listener the change listener
	 */
	public void addChangeListener(ChangeListener listener);

	/**
	 * Removes a change listener.
	 *
	 * @param listener the change listener
	 */
	public void removeChangeListener(ChangeListener listener);

	public void removeHighlights();

	public String getDTDURLString();

	public String getSelectedText();
	public Node getSelectedNode();

	public void setEnabled(boolean enabled);

	/**
	 * Adds an undo listener for notification of any changes.
	 *
	 * @param listener the <code>UndoableEditListener</code> to add
	 * @see #removeUndoableEditListener
	 */
	public void addUndoableEditListener(UndoableEditListener listener);

	/**
	 * Removes an undo listener.
	 *
	 * @param listener the <code>UndoableEditListener</code> to remove
	 * @see #addUndoableEditListener
	 */
	public void removeUndoableEditListener(UndoableEditListener listener);

	public void findNext();
	public void findPrevious();
	public boolean canSearchAgain();

	public boolean requestFocusInWindow();
	public void setBackground(Color bg);


	public Set<Integer> getSelectedLinkIDs();
	public void highlightDELTALinks(Collection<Integer> selectedLinkIDs);

	public Set<Integer> synchronizeSelectedDELTALinks(int newLinkID);

	public void setLinkMode(boolean linkMode);
	public boolean getLinkMode();

	void jumpToNextHighlight();

	void jumpToPreviousHighlight();

	void repaint();
}
