package at.ac.tuwien.asgaard.delta.gui;

import java.io.File;
import java.io.IOException;
import java.util.Set;

public interface DeltaView {
	public void load(File file) throws Exception;
	public void reload() throws Exception;
	public void save() throws IOException;
	public void saveAs(File newXMLFile) throws IOException;
    public void close();
	public boolean print();

    public boolean isLoaded();
    public boolean isLoading();
	public File getFile();
	public String getFilePath();

	public boolean goBack();
	public boolean goForward();
	public boolean canGoBack();
	public boolean canGoForward();

	public void refetchProperties(Set<String> changedProperties);
	public void storeProperties();

	/**
	 * Returns <code>true</code> if this <code>Component</code> is the
	 *    focus owner.
	 *
	 * @return <code>true</code> if this <code>Component</code> is the
	 *     focus owner; <code>false</code> otherwise
	 * @since 1.4
	 */
	public boolean isFocusOwner();
}
