/*
 * Project: DELTA - Guideline Markup Tool / Version: 2.7.3.#452
 * User: peter
 * Date: 06.05.2003
 * Time: 17:34:51
 */
package at.ac.tuwien.asgaard.delta.gui.actions;

import at.ac.tuwien.asgaard.swing.StatusBar;

import javax.swing.*;
import java.awt.event.ActionEvent;

/**
 * Class EmptyAction ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.3.0
 */
public class EmptyAction extends AbstractAction {
	public EmptyAction(String name, Icon icon) {
		super(name, icon);
	}
	public EmptyAction(String name, Icon icon, char mnemonicKey) {
		this(name, icon, mnemonicKey, true);
	}
	public EmptyAction(String name, Icon icon, char mnemonicKey, boolean enabled) {
		super(name, icon);
		putValue(MNEMONIC_KEY, new Integer(mnemonicKey));
		this.enabled = enabled;
	}
	public EmptyAction(String name, Icon icon, char mnemonicKey, String toolTip) {
		this(name, icon, mnemonicKey, toolTip, toolTip);
	}
	public EmptyAction(String name, Icon icon, char mnemonicKey, String toolTip, String msgHover) {
		this(name, icon, mnemonicKey);
		putValue(StatusBar.TOOL_TIP, toolTip); // when mouse over
		putValue(StatusBar.DESCRIPTION_HOVER, msgHover); // when mouse over - statusbar
	}
	public EmptyAction(String name, Icon icon, char mnemonicKey, String toolTip, boolean enabled) {
		this(name, icon, mnemonicKey, toolTip, toolTip);
		this.enabled = enabled;
	}
	public EmptyAction(String name, Icon icon, char mnemonicKey, String toolTip, String msgHover, boolean enabled) {
		this(name, icon, mnemonicKey, toolTip, msgHover);
		this.enabled = enabled;
	}
	public EmptyAction(String name, String toolTip, boolean enabled) {
		super(name);
		putValue(StatusBar.TOOL_TIP, toolTip); // when mouse over
		putValue(StatusBar.DESCRIPTION_HOVER, toolTip); // when mouse over - statusbar
		this.enabled = enabled;
	}
	public EmptyAction(String name, String toolTip, String msgHover, boolean enabled) {
		super(name);
		putValue(StatusBar.TOOL_TIP, toolTip); // when mouse over
		putValue(StatusBar.DESCRIPTION_HOVER, msgHover); // when mouse over - statusbar
		this.enabled = enabled;
	}
	public EmptyAction(String name, Icon icon, char mnemonicKey, String toolTip, String msgHover, String msgActive, boolean enabled) {
		this(name, icon, mnemonicKey);
		putValue(StatusBar.TOOL_TIP, toolTip); // when mouse over
		putValue(StatusBar.DESCRIPTION_HOVER, msgHover); // when mouse over - statusbar
		putValue(StatusBar.DESCRIPTION_ACTIVE, msgActive);  // when clicked
		this.enabled = enabled;
	}
	public EmptyAction(Icon icon, String toolTip) {
		putValue(Action.SMALL_ICON, icon);
		putValue(StatusBar.TOOL_TIP, toolTip); // when mouse over
	}

	public void actionPerformed(ActionEvent evt) {}
}
