/*
 * Project: DELTA - Guideline Markup Tool / Version: 2.7.3.#452
 * User: peter
 * Date: 30.04.2003
 * Time: 11:26:35
 */
package at.ac.tuwien.asgaard.delta.gui.actions.edit;

import at.ac.tuwien.asgaard.delta.gui.MainController;
import at.ac.tuwien.asgaard.delta.gui.MainFrame;
import at.ac.tuwien.asgaard.delta.gui.actions.SimpleAction;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.delta.gui.xml.XMLView;
import at.ac.tuwien.asgaard.swing.StatusBar;

import java.awt.event.*;

import javax.swing.*;

/**
 * Class FileSaveAllAction ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.3.0
 */
public final class EditCutAction extends SimpleAction {
	public EditCutAction() {
		super("Cut (XML)", MainImages.CUT_ICON, 'T');

		putValue(LOCAL_ACCELERATOR_KEY, KeyStroke.getKeyStroke(KeyEvent.VK_X, InputEvent.CTRL_MASK));
		putValue(SHORT_DESCRIPTION, "Cut XML node to clipboard"); // when mouse over
		putValue(StatusBar.DESCRIPTION_HOVER, "Cut current XML node to (internal) clipboard."); // when mouse over - statusbar
		putValue(StatusBar.DESCRIPTION_ACTIVE, "Cutting to clipboard ...");  // when clicked
		this.enabled = false;
	}
    protected void simpleActionPerformed() {
        int activeSideIndex = MainController.getActiveSideIndex();
		XMLView xmlView = MainController.deltaSides[activeSideIndex].xmlView;
		if (MainController.xmlClipBoard != null)
			MainController.xmlClipBoard.treeNode.setClipBoardMode(null);
		MainController.xmlClipBoard = new MainController.XMLClipBoard(xmlView.getSelectedTreeNode(),
                activeSideIndex, MainController.XMLClipBoard.ClipBoardMode.CUT);
		xmlView.nodeChanged(MainController.xmlClipBoard.treeNode);
		xmlView.revalidate();
		xmlView.repaint();
		mainFrame.pasteSubMenuAction.setEnabled(true);
        MainController.mainFrame.clipBoardLabel.setText("CUT");
        MainController.mainFrame.clipBoardLabel.setToolTipText(MainFrame.CLIPBOARD_LABEL_TOOLTIP + "<br>Clipboard content: Element \"" + MainController.xmlClipBoard.xmlNode.getNodeName() + '\"');

		MainController.resetPasteActions();
	}
}
