/*
 * Project: DELTA - Guideline Markup Tool / Version: 2.7.3.#452
 * User: peter
 * Date: 30.04.2003
 * Time: 11:26:35
 */
package at.ac.tuwien.asgaard.delta.gui.actions.edit;

import at.ac.tuwien.asgaard.delta.gui.DeltaSideController;
import at.ac.tuwien.asgaard.delta.gui.MainController;
import at.ac.tuwien.asgaard.delta.gui.actions.SimpleAction;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.delta.gui.xml.XMLView;
import at.ac.tuwien.asgaard.delta.util.Preferences;
import at.ac.tuwien.asgaard.swing.StatusBar;
import at.ac.tuwien.asgaard.swing.autoComplete.AutoCompleteComboBoxEditDialog;

import java.awt.event.InputEvent;
import java.awt.event.KeyEvent;

import javax.swing.*;

/**
 * Class FileSaveAllAction ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.4.0
 */
public final class EditFindAction extends SimpleAction {
	public EditFindAction() {
		super("Find", MainImages.SEARCH_ICON, 'F');

		putValue(LOCAL_ACCELERATOR_KEY, KeyStroke.getKeyStroke(KeyEvent.VK_F, InputEvent.CTRL_MASK));
		putValue(SHORT_DESCRIPTION, "Find a keyword in active file"); // when mouse over
		putValue(StatusBar.DESCRIPTION_HOVER, "Find a keyword in active file."); // when mouse over - statusbar
		putValue(StatusBar.DESCRIPTION_ACTIVE, "Finding a keyword in active file ...");  // when clicked
		enabled = false;
	}

	// keep disabled since it is not finished yet
	// public void setEnabled(boolean newValue) { }

	private AutoCompleteComboBoxEditDialog dialog;
    protected void simpleActionPerformed() {
		if (dialog == null)
			dialog = new AutoCompleteComboBoxEditDialog(MainController.mainFrame, "Find... -- WORK IN PROGRESS",
														"Keyword: ", MainController.stateProperties.getStringList(Preferences.KEY_COMBOBOX_FIND));

		DeltaSideController activeSideController = MainController.getActiveSideController();
		String searchText = dialog.showEditDialog(null); //JOptionPane.showInputDialog(MainController.mainFrame, "searchText: ");
		if (searchText == null) return;
		if (activeSideController.isTypeXML()) {
			// TODO: set all find options using special dialog
			activeSideController.thisSide.xmlView.search(searchText, XMLView.SEARCH_ELEMENT_NAME | XMLView.SEARCH_ATTRIBUTE_NAME | XMLView.SEARCH_ATTRIBUTE_VALUE | XMLView.SEARCH_COMMENT, false, true, false,
														 false, false);
		} else {
			// todo: set all find options using special dialog
			activeSideController.thisSide.htmlView.search(searchText, false, false, false, false, true);
		}
		MainController.aEditFindNext.setEnabled(true);
		MainController.aEditFindPrevious.setEnabled(true);
	}
}
