/*
 * Project: DELTA - Guideline Markup Tool / Version: 2.7.3.#452
 * User: peter
 * Date: 30.04.2003
 * Time: 11:26:35
 */
package at.ac.tuwien.asgaard.delta.gui.actions.edit;

import at.ac.tuwien.asgaard.delta.gui.*;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.swing.StatusBar;

import javax.swing.*;
import java.awt.event.InputEvent;
import java.awt.event.KeyEvent;
import java.util.Set;

/**
 * Class FileSaveAllAction ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.3.0
 */
public final class EditPasteReplaceAction extends EditPasteIntoAction {
	public EditPasteReplaceAction() {
		super("Replace", MainImages.XML_INSERT_REPLACE_ICON, 'R');

		putValue(LOCAL_ACCELERATOR_KEY, KeyStroke.getKeyStroke(KeyEvent.VK_V, InputEvent.ALT_MASK | InputEvent.SHIFT_MASK));
		putValue(SHORT_DESCRIPTION, "Paste clipboard content instead current element"); // when mouse over
		putValue(StatusBar.DESCRIPTION_HOVER, "Paste clipboard content instead current element."); // when mouse over - statusbar
		putValue(StatusBar.DESCRIPTION_ACTIVE, "Pasting from clipboard ...");  // when clicked
	}

    protected void paste(int activeSideIndex) {
		DeltaSideController otherSideController = MainController.deltaSideController[1 - activeSideIndex];
		MainFrame.DeltaSide thisSide = MainController.deltaSides[activeSideIndex],
							otherSide = otherSideController.thisSide;
		
		Set gmtLinks = thisSide.xmlView.insertNodeReplace(MainController.xmlClipBoard.xmlNode.cloneNode(true));
		// todo: undo
		if ((gmtLinks == null) || !otherSide.deltaView.isLoaded()) return;

		thisSide.deltaView.removeDELTALinksFromCollection(gmtLinks, true);   // remove links from gmtLinks which are in the XML view
		otherSide.deltaView.removeDELTALinksFromCollection(gmtLinks, false);  // remove links from gmtLinks which are not in the HTML view

		if (gmtLinks.isEmpty()) return;
		
		switch (MainController.removeDeadLinks) {
			case REMOVE_LINKS_ASK:
				if (JOptionPane.showConfirmDialog(mainFrame, "Do you want to remove " + gmtLinks.size()
															 + " corresponding dead link(s) "
															 + ((gmtLinks.size() > 10)
																? "" : "(IDs=" + gmtLinks.toString() + ") ")
															 + "in the opposite file?",
						"Remove dead links", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE)
					== JOptionPane.NO_OPTION)
					break;
			case REMOVE_LINKS_YES:
				otherSideController.disableActions(true);
				otherSide.deltaView.setEnabled(false);
				otherSide.deltaView.removeDELTALinks(gmtLinks);
				otherSide.deltaView.setEnabled(true);
				otherSideController.enableActions();
				break;
		}
    }
}
