/*
 * Project: DELTA - Guideline Markup Tool / Version: 2.7.3.#452
 * User: peter
 * Date: 30.04.2003
 * Time: 11:26:35
 */
package at.ac.tuwien.asgaard.delta.gui.actions.edit;

import at.ac.tuwien.asgaard.delta.gui.MainController;
import at.ac.tuwien.asgaard.delta.gui.actions.SimpleAction;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.swing.StatusBar;

import javax.swing.*;
import java.awt.event.InputEvent;
import java.awt.event.KeyEvent;

/**
 * Class FileSaveAllAction ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.3.0
 */
public final class EditRedoAction extends SimpleAction {
	public EditRedoAction() {
		super("Redo", MainImages.REDO_ICON, 'R');

		putValue(ACCELERATOR_KEY, KeyStroke.getKeyStroke(KeyEvent.VK_Z, InputEvent.CTRL_MASK | InputEvent.SHIFT_MASK));
		putValue(SHORT_DESCRIPTION, "Redo last undone action"); // when mouse over
		putValue(StatusBar.DESCRIPTION_HOVER, "Redo last undone action."); // when mouse over - statusbar
		putValue(StatusBar.DESCRIPTION_ACTIVE, "Redoing last undone action ...");  // when clicked
		enabled = false;
	}

    public void updateAction() {
        if (MainController.undoManager.canRedo()) {
            setEnabled(true);
            putValue(NAME, MainController.undoManager.getRedoPresentationName());
        } else {
            setEnabled(false);
            putValue(NAME, "Redo");
        }
    }

    protected void simpleActionPerformed() {
        try {
            MainController.undoManager.redo();
        } catch (Exception exc) {
            System.err.println("Unable to redo: " + exc);
            exc.printStackTrace();
            JOptionPane.showMessageDialog(mainFrame, "Unable to redo last action: " + exc.getMessage(), "Strange Error", JOptionPane.ERROR_MESSAGE);
        } finally {
            updateAction();
            MainController.aEditUndo.updateAction();
            if (MainController.undoManager.canUndo(LEFT))
                MainController.deltaSides[LEFT].deltaView.contentHasChanged(true);
            if (MainController.undoManager.canUndo(RIGHT))
                MainController.deltaSides[RIGHT].deltaView.contentHasChanged(true);
        }
    }
}
