package at.ac.tuwien.asgaard.delta.gui.actions.edit;

import at.ac.tuwien.asgaard.delta.gui.actions.SimpleAction;
import at.ac.tuwien.asgaard.delta.gui.MainController;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.delta.gui.misc.InsertableXMLNodesDialog;
import at.ac.tuwien.asgaard.swing.StatusBar;

import javax.swing.*;
import java.awt.event.KeyEvent;
import java.awt.event.InputEvent;

public class EditShowInsertableElementsDialogAction extends SimpleAction {
    public EditShowInsertableElementsDialogAction() {
        super("Show Insertable Nodes", MainImages.XML_ICON, 'I');

        putValue(LOCAL_ACCELERATOR_KEY, KeyStroke.getKeyStroke(KeyEvent.VK_I, InputEvent.CTRL_MASK));
        putValue(StatusBar.TOOL_TIP, "Show insertable nodes"); // when mouse over - tool-tip
        putValue(StatusBar.DESCRIPTION_HOVER, "Show insertable nodes for insert Into/Before/After/Replace/Convert/Wrap."); // when mouse over - statusbar
        enabled = false;
    }

    protected void simpleActionPerformed() {
        if (MainController.insertableElementsDialog == null) 
            MainController.insertableElementsDialog = new InsertableXMLNodesDialog(MainController.preferences);

        MainController.insertableElementsDialog.showDialog(MainController.getActiveSideController().dtdHelper);
    }
}
