/*
 * Project: DELTA - Guideline Markup Tool / Version: 2.7.3.#452
 * User: peter
 * Date: 30.04.2003
 * Time: 11:26:35
 */
package at.ac.tuwien.asgaard.delta.gui.actions.edit;

import at.ac.tuwien.asgaard.delta.gui.MainController;
import at.ac.tuwien.asgaard.delta.gui.actions.SimpleAction;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.swing.StatusBar;

import javax.swing.*;
import java.awt.event.InputEvent;
import java.awt.event.KeyEvent;

/**
 * Class FileSaveAllAction ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 */
public final class EditUndoAction extends SimpleAction {
	public EditUndoAction() {
		super("Undo", MainImages.UNDO_ICON, 'U');

		putValue(ACCELERATOR_KEY, KeyStroke.getKeyStroke(KeyEvent.VK_Z, InputEvent.CTRL_MASK));
		putValue(SHORT_DESCRIPTION, "Undo last action"); // when mouse over
		putValue(StatusBar.DESCRIPTION_HOVER, "Undo last action."); // when mouse over - statusbar
		putValue(StatusBar.DESCRIPTION_ACTIVE, "Undoing last action ...");  // when clicked
		enabled = false;
	}

    public void updateAction() {
        if (MainController.undoManager.canUndo()) {
            setEnabled(true);
            putValue(NAME, MainController.undoManager.getUndoPresentationName());
        } else {
            setEnabled(false);
            putValue(NAME, "Undo");
        }
    }

    protected void simpleActionPerformed() {
        try {
            MainController.undoManager.undo();
        } catch (Exception exc) {
            System.err.println("Unable to undo last action: " + exc); // todo
            exc.printStackTrace();
			JOptionPane.showMessageDialog(mainFrame, "Unable to undo last action: " + exc.getMessage(), "Strange Error", JOptionPane.ERROR_MESSAGE);
        } finally {
            updateAction();
            MainController.aEditRedo.updateAction();
            if (!MainController.undoManager.canUndo(LEFT))
                MainController.deltaSides[LEFT].deltaView.contentHasChanged(false);
            if (!MainController.undoManager.canUndo(RIGHT))
                MainController.deltaSides[RIGHT].deltaView.contentHasChanged(false);
        }
	}
}
