/*
 * Project: DELTA - Guideline Markup Tool / Version: 2.7.3.#452
 * User: peter
 * Date: 30.04.2003
 * Time: 11:26:35
 */
package at.ac.tuwien.asgaard.delta.gui.actions.file;

import at.ac.tuwien.asgaard.delta.gui.GUIConstants;
import at.ac.tuwien.asgaard.delta.gui.MainController;
import at.ac.tuwien.asgaard.delta.gui.actions.SimpleAction;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.swing.StatusBar;

import java.awt.event.*;

import javax.swing.*;

/**
 * Class FileSaveAllAction ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.3.0
 */
public final class FileCloseAllAction extends SimpleAction {
	public FileCloseAllAction() {
		super("Close all...", MainImages.PROJECT_CLOSE_ICON, 'C');

		putValue(ACCELERATOR_KEY, KeyStroke.getKeyStroke(KeyEvent.VK_C, InputEvent.CTRL_MASK | InputEvent.ALT_MASK | InputEvent.SHIFT_MASK));
		putValue(SHORT_DESCRIPTION, "Close all files"); // when mouse over
		putValue(StatusBar.DESCRIPTION_HOVER, "Close all files."); // when mouse over - statusbar
		putValue(StatusBar.DESCRIPTION_ACTIVE, "Closing all files ...");  // when clicked
		enabled = false;
	}
	public void simpleActionPerformed() {
        if (MainController.deltaSideController[GUIConstants.LEFT].aClose.isEnabled())
			MainController.deltaSideController[GUIConstants.LEFT].aClose.actionPerformed(null);
        if (MainController.deltaSideController[GUIConstants.RIGHT].aClose.isEnabled())
			MainController.deltaSideController[GUIConstants.RIGHT].aClose.actionPerformed(null);
		if (MainController.aMacrosClose.isEnabled())
			MainController.aMacrosClose.actionPerformed(null);
	}
}
