/*
 * Project: DELTA - Guideline Markup Tool / Version: 2.7.3.#452
 * Author: Peter Votruba
 * Date: 19.05.2003
 * Time: 15:27:56
 */
package at.ac.tuwien.asgaard.delta.gui.actions.file;

import at.ac.tuwien.asgaard.delta.gui.MainController;
import at.ac.tuwien.asgaard.delta.gui.actions.SimpleAction;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;

import java.awt.event.*;

import javax.swing.*;

/**
 * Class FileExitAction ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.3.0
 */
public class FileExitAction extends SimpleAction {
	public FileExitAction() {
		super("Exit", MainImages.EXIT_ICON, 'X', "Quit the application",
			  "Close all open files and quit the application.", "Closing the application ...");

		putValue(ACCELERATOR_KEY, KeyStroke.getKeyStroke(KeyEvent.VK_Q, InputEvent.CTRL_MASK));
	}

	protected void simpleActionPerformed() {
		quit();
	}

	public void quit() {
		if (MainController.saveChangedFiles(true))
			savePreferencesAndQuit();
	}

	public void savePreferencesAndQuit() {
		MainController.savePreferences();
		System.exit(0);
	}
}
