/*
 * Project: DELTA - Guideline Markup Tool / Version: 2.7.3.#452
 * User: peter
 * Date: 30.04.2003
 * Time: 11:26:35
 */
package at.ac.tuwien.asgaard.delta.gui.actions.file;

import at.ac.tuwien.asgaard.delta.gui.GUIConstants;
import at.ac.tuwien.asgaard.delta.gui.MainController;
import at.ac.tuwien.asgaard.delta.gui.actions.SimpleAction;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.swing.StatusBar;

import java.awt.event.InputEvent;
import java.awt.event.KeyEvent;

import javax.swing.*;

/**
 * Class FileSaveAllAction ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.3.0
 */
public final class FileSaveAllAction extends SimpleAction {
	public FileSaveAllAction() {
		super("Save all...", MainImages.SAVE_ALL_ICON, 'A');

		putValue(ACCELERATOR_KEY, KeyStroke.getKeyStroke(KeyEvent.VK_A, InputEvent.CTRL_MASK | InputEvent.SHIFT_MASK));
		putValue(SHORT_DESCRIPTION, "Save unsaved files"); // when mouse over
		putValue(StatusBar.DESCRIPTION_HOVER, "Save unsaved files and preferences."); // when mouse over - statusbar
		putValue(StatusBar.DESCRIPTION_ACTIVE, "Saving unsaved files and preferences ...");  // when clicked
		enabled = false;
	}
	public void simpleActionPerformed() {
        new at.ac.tuwien.asgaard.swing.SwingWorker() {
			public Object construct() {
				if (MainController.deltaSideController[GUIConstants.LEFT].aSave.isEnabled())
					MainController.deltaSideController[GUIConstants.LEFT].aSave.doSaveFileInSameThread();
				if (MainController.deltaSideController[GUIConstants.RIGHT].aSave.isEnabled())
					MainController.deltaSideController[GUIConstants.RIGHT].aSave.doSaveFileInSameThread();
				MainController.savePreferences();
				return null;
			}
			public void finished() { }
		}.start();
	}
}
