/*
 * Project: DELTA - Guideline Markup Tool / Version: 2.7.3.#452
 * User: peter
 * Date: 30.04.2003
 * Time: 11:26:35
 */
package at.ac.tuwien.asgaard.delta.gui.actions.file;

import at.ac.tuwien.asgaard.delta.gui.*;
import at.ac.tuwien.asgaard.delta.gui.actions.SimpleAction;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.swing.StatusBar;

import javax.swing.KeyStroke;
import java.awt.event.InputEvent;
import java.awt.event.KeyEvent;

/**
 * Class FileSaveAllAction ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.3.0
 */
public final class FileSwapSidesAction extends SimpleAction {
	public FileSwapSidesAction() {
		super("Swap sides", MainImages.SYNCHRONIZE_LINKS_ICON, 'S');

		putValue(ACCELERATOR_KEY, KeyStroke.getKeyStroke(KeyEvent.VK_S, InputEvent.CTRL_MASK | InputEvent.ALT_MASK | InputEvent.SHIFT_MASK));
		putValue(SHORT_DESCRIPTION, "Swap sides"); // when mouse over
		putValue(StatusBar.DESCRIPTION_HOVER, "Swap sides."); // when mouse over - statusbar
		putValue(StatusBar.DESCRIPTION_ACTIVE, "Swap sides ...");  // when clicked
		enabled = false;
	}
	public void simpleActionPerformed() {
		int activeSideIndex = MainController.getActiveSideIndex();
		if (activeSideIndex == EMPTY) return;

		MainController.deltaSideController[GUIConstants.LEFT].disableActions(true);
		MainController.deltaSideController[GUIConstants.RIGHT].disableActions(true);

		MainController.swapSides();
		mainFrame.swapSides();

		MainController.deltaSideController[GUIConstants.LEFT].enableActions();
		MainController.deltaSideController[GUIConstants.RIGHT].enableActions();

		MainController.setActiveSideIndex(1 - activeSideIndex);
	}
}
