package at.ac.tuwien.asgaard.delta.gui.actions.help;

import at.ac.tuwien.asgaard.delta.gui.actions.SimpleAction;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.swing.StatusBar;
import at.ac.tuwien.asgaard.util.BrowserControl;

import javax.swing.JOptionPane;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.URL;

public final class HelpCheckVersionAction extends SimpleAction {
    public HelpCheckVersionAction() {
        super("Check for new DELT/A Version", MainImages.CHECK_FOR_NEW_VERSION_ICON, 'C');

        putValue(StatusBar.TOOL_TIP, "Check for new Version of the DELT/A"); // when mouse over - tool-tip
        putValue(StatusBar.DESCRIPTION_HOVER, "Check for new Version of the Document Exploration and Linking Tool (with Addons)."); // when mouse over - statusbar
        putValue(StatusBar.DESCRIPTION_ACTIVE, "Checking for new Version of the Document Exploration and Linking Tool (with Addons) ...");  // when clicked
    }

    public void simpleActionPerformed() {
        try {
            BufferedReader in = new BufferedReader(new InputStreamReader(new URL("http://www.asgaard.tuwien.ac.at/~peter/DELTA/delta.version").openStream()));
            String latestVersionStr = in.readLine();
			System.out.println("Latest available version:  " + latestVersionStr);
            in.close();
            String currentVersionStr = "2.7.3.#452";
            if (currentVersionStr.equals(latestVersionStr))
                JOptionPane.showMessageDialog(mainFrame, "<html>Current version: <i>" + currentVersionStr
                                                    + "</i><br>Latest available version: <i>" + latestVersionStr
                                                    + "</i><hr>"
                                                    + "You are currently using the most recent version.", "Check Version",
                        JOptionPane.INFORMATION_MESSAGE);
            else
				if (JOptionPane.showConfirmDialog(mainFrame, "<html>Current version: <i>" + currentVersionStr
															 + "</i><br>Latest available version: <i>" + latestVersionStr
															 + "</i><hr>New version available!<p>Would you like to go to the <b><i>DELT/A</i> download page</b>?",
												  "Check Version", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE)
						== JOptionPane.YES_OPTION)
                BrowserControl.displayURL("http://www.asgaard.tuwien.ac.at/~peter/DELTA/download/");
        } catch (Throwable t) {
            System.err.println("Couldn't check version:");
            t.printStackTrace(System.err);
            JOptionPane.showMessageDialog(mainFrame, "Couldn't retrieve latest available version from \"http://www.asgaard.tuwien.ac.at/~peter/DELTA/\"!",
                    "Check Version", JOptionPane.ERROR_MESSAGE);
        }
    }
}
