package at.ac.tuwien.asgaard.delta.gui.actions.help;

import at.ac.tuwien.asgaard.delta.gui.MainController;
import at.ac.tuwien.asgaard.delta.gui.actions.SimpleAction;
import at.ac.tuwien.asgaard.delta.gui.misc.SplashWindow;
import at.ac.tuwien.asgaard.delta.gui.images.LazyResourceLoader;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.swing.AbstractInputDialog;
import at.ac.tuwien.asgaard.swing.StatusBar;

import javax.swing.*;
import java.awt.*;

public final class HelpShowAboutAction extends SimpleAction {
	private AboutDialog aboutDialog;
	public HelpShowAboutAction() {
		super("About", MainImages.ABOUT_ICON, 'A');

		putValue(StatusBar.TOOL_TIP, "About DELT/A"); // when mouse over - tool-tip
		putValue(StatusBar.DESCRIPTION_HOVER, "Shows information about Document Exploration and Linking Tool (with Addons)."); // when mouse over - statusbar
		putValue(StatusBar.DESCRIPTION_ACTIVE, "Information about Document Exploration and Linking Tool (with Addons) ...");  // when clicked
	}

	public void simpleActionPerformed() {
//		JOptionPane.showMessageDialog(mainFrame,
//									  "<html><big>Document Exploration and Linking Tool (with Addons)</big><br>Version <i>2.7.3</i> / Build <i>#452</i> from <i>27.04.2006</i><br>"
//									  + "by <i>Peter Votruba</i><br>www: <i>http://www.asgaard.tuwien.ac.at/~peter/DELTA/</i><br>email: <i>peter@asgaard.tuwien.ac.at</i>", "About DELT/A",
//																												JOptionPane.INFORMATION_MESSAGE, LazyResourceLoader.getIcon(LazyResourceLoader.APP_LOGO));
		if (aboutDialog == null)
			aboutDialog = new AboutDialog();
		aboutDialog.showDialog();
	}

	private static class AboutDialog extends AbstractInputDialog {
		private int xLine1 = -1, xLine2 = -1, xLine3 = -1, xLine4 = -1;
		public AboutDialog() {
			super(MainController.mainFrame, "About DELT/A", false, false, false, 380, 330, 380, 330, 380, 330, "Close");
		}

		protected Component createMainComponent() {
			JPanel comp = new JPanel();
			comp.setLayout(new BoxLayout(comp, BoxLayout.Y_AXIS));
			JLabel logo = new JLabel(LazyResourceLoader.getIcon(LazyResourceLoader.APP_LOGO)) {
				public void paint(Graphics g) {
					//	g.drawImage(splashImage, 0, 0, this);
					super.paint(g);

					((Graphics2D) g).setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING, RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
					Font defaultFont = g.getFont();
					if (xLine1 == -1)
						xLine1 = (int) ((380 - g.getFontMetrics().getStringBounds(SplashWindow.LINE1, g).getWidth()) / 2);
					g.drawString(SplashWindow.LINE1, xLine1, 18);

					g.setFont(defaultFont.deriveFont(Font.BOLD));
					if (xLine2 == -1)
						xLine2 = (int) ((380 - g.getFontMetrics().getStringBounds(SplashWindow.LINE2, g).getWidth()) / 2);
					g.drawString(SplashWindow.LINE2, xLine2, 162);

					g.setFont(defaultFont.deriveFont(Font.ITALIC));
					if (xLine3 == -1)
						xLine3 = (int) ((380 - g.getFontMetrics().getStringBounds(SplashWindow.LINE3, g).getWidth()) / 2);
					g.drawString(SplashWindow.LINE3, xLine3, 178);

					g.setFont(defaultFont);
					if (xLine4 == -1)
						xLine4 = (int) ((380 - g.getFontMetrics().getStringBounds(SplashWindow.LINE4, g).getWidth()) / 2);
					g.drawString(SplashWindow.LINE4, xLine4, 198);
				}
			};
	//		logo.setBorder(LineBorder.createBlackLineBorder());
			logo.setToolTipText("Logo created by Klaus H.");
			comp.add(logo);
			JLabel text = new JLabel("<html>by <i>Peter Votruba</i><br>www: <i>http://www.asgaard.tuwien.ac.at/~peter/DELTA/</i><br>email: <i>peter@asgaard.tuwien.ac.at</i>");
			comp.add(text);
		//	text.setBorder(new CompoundBorder(new CompoundBorder(new EmptyBorder(5, 0, 1, 0), new MatteBorder(0, 0, 1, 0, Color.GRAY)), new EmptyBorder(0, 0, 5, 0)));
			return comp;
		}
	}
}
