package at.ac.tuwien.asgaard.delta.gui.actions.help;

import at.ac.tuwien.asgaard.delta.gui.actions.SimpleAction;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.delta.util.EnvironmentProperties;
import at.ac.tuwien.asgaard.swing.StatusBar;
import at.ac.tuwien.asgaard.util.JHelpUtils;

import javax.swing.KeyStroke;
import javax.swing.JOptionPane;
import java.awt.event.KeyEvent;

public final class HelpShowHelpAction extends SimpleAction {
    public HelpShowHelpAction() {
        super("Help", MainImages.HELP_ICON, 'H');

		putValue(ACCELERATOR_KEY, KeyStroke.getKeyStroke(KeyEvent.VK_F1, 0));
        putValue(StatusBar.TOOL_TIP, "Help Topics"); // when mouse over - tool-tip
        putValue(StatusBar.DESCRIPTION_HOVER, "Show the DELT/A-Manual in default browser."); // when mouse over - statusbar
        putValue(StatusBar.DESCRIPTION_ACTIVE, "Showing the DELT/A-Manual ...");  // when clicked
    }
    public void simpleActionPerformed() {
		if (!EnvironmentProperties.isIsJhelpAvailable())
			JOptionPane.showMessageDialog(mainFrame, "jhelp.jar is missing!\n\nDownload DELT/A-Help package or use user manual instead.", "DELT/A Help",
										  JOptionPane.INFORMATION_MESSAGE);
		else if (JHelpUtils.getHelpBroker() == null)
			JOptionPane.showMessageDialog(mainFrame, "delta-help.jar is missing!\n\nDownload DELT/A-Help package or use user manual instead.", "DELT/A Help",
										  JOptionPane.INFORMATION_MESSAGE);
		else
			JHelpUtils.showHelpHome();
    }
}
