/*
 * Project: DELTA - Guideline Markup Tool / Version: 2.7.3.#452
 * Author: Peter Votruba
 * Date: 19.05.2003
 * Time: 16:13:34
 */
package at.ac.tuwien.asgaard.delta.gui.actions.macros;

import at.ac.tuwien.asgaard.delta.gui.actions.SimpleAction;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.delta.gui.macros.editor.MacroEditor;
import at.ac.tuwien.asgaard.delta.gui.MainController;
import at.ac.tuwien.asgaard.delta.util.GlobalConstants;

import javax.swing.JOptionPane;
import javax.swing.event.ChangeListener;
import javax.swing.event.ChangeEvent;
import java.io.File;

/**
 * Class MacroShowEditorAction ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.4.0
 */
public class MacroShowEditorAction extends SimpleAction {
	private File editedFile;

	public MacroShowEditorAction() {
		super("Edit Macro File...", MainImages.MACRO_EDITOR_ICON, 'E',
				"Show Macro-Editor", "Show Macro-Editor for the current macro file.",
				"Editing current macro file ...", false);
	}

	private boolean firstTime = true;
	public void simpleActionPerformed() {
		try {
			if (firstTime)
				MacroEditor.addChangeListener(new ChangeListener() {
					public void stateChanged(ChangeEvent evt) {
						try {
							System.out.println("Macros file has been changed. Reloading it.");
							if (editedFile == mainFrame.macrosView.getFile()) // if still the same file is opened
								MainController.aMacrosReload.actionPerformed(null);
							//	mainFrame.macrosView.reload();
						} catch (Exception e) {
							e.printStackTrace();
							JOptionPane.showMessageDialog(mainFrame, "Couldn't reload Macros file",
									"File Error!", JOptionPane.ERROR_MESSAGE);
						}
					}
				});
			/*boolean macrosFileChanged = */
			editedFile = mainFrame.macrosView.getFile();
			MacroEditor.showDialog(this.editedFile, mainFrame, MainController.xmlLanguages);
			/*if (macrosFileChanged)
				try {
					System.out.println("Macros file has been changed. Reloading it.");
					mainFrame.macrosView.reload();
				} catch (Exception e) {
					e.printStackTrace();
					JOptionPane.showMessageDialog(mainFrame, "Couldn't reload Macros file",
												  "File Error!", JOptionPane.ERROR_MESSAGE);
				}*/
		} catch (NoClassDefFoundError e) {
			if (GlobalConstants.DEBUG)
				e.printStackTrace();
			JOptionPane.showMessageDialog(mainFrame, "Macro-Editor not found. Download Macro-Editor add-on\nfrom DELT/A download site and place it in './lib' directory.",
										  "Extension package missing!", JOptionPane.INFORMATION_MESSAGE);
		} catch (Exception exc) {
			if (GlobalConstants.DEBUG)
				exc.printStackTrace();
			JOptionPane.showMessageDialog(mainFrame, "Exception occured in Macro-Editor: "+exc, "Exception in Macro-Editor!", JOptionPane.ERROR_MESSAGE);
		}
	}
}
