/*
 * Project: DELTA - Guideline Markup Tool / Version: 2.7.3.#452
 * Author: Peter Votruba
 * Date: 01.09.2003
 * Time: 11:30:37
 */
package at.ac.tuwien.asgaard.delta.gui.actions.macros;

import at.ac.tuwien.asgaard.swing.selectable.RadioButtonAbstractAction;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.delta.gui.MainController;
import at.ac.tuwien.asgaard.util.xml.dtd.DTDHelper;

import javax.swing.event.ChangeEvent;
import javax.swing.*;
import java.awt.event.KeyEvent;
import java.awt.event.InputEvent;

/**
 * Class MacroSwitchToInsertModeBeforeAction ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.3.0
 */
public class MacroSwitchToInsertModeBeforeAction extends RadioButtonAbstractAction {
    public MacroSwitchToInsertModeBeforeAction() {
        super("Insert Before", MainImages.XML_INSERT_BEFORE_ICON, 'B',
                "\"Insert Macro\"-Action will insert current macro before selected Element");
        putValue(ACCELERATOR_KEY, KeyStroke.getKeyStroke(KeyEvent.VK_M, InputEvent.CTRL_MASK | InputEvent.ALT_MASK));
		enabled = false;
    }

    public void stateChanged(ChangeEvent evt) {
		MainController.getActiveSideController().dtdHelper.setInsertMode(DTDHelper.INSERT_MODE_BEFORE);
        MainController.mainFrame.macroInsertModeComboBox.setSelectedIndex(3);
    }
}
