/*
 * Project: DELTA - Guideline Markup Tool / Version: 2.7.3.#452
 * Author: Peter Votruba
 * Date: 01.09.2003
 * Time: 11:25:33
 */
package at.ac.tuwien.asgaard.delta.gui.actions.macros;

import at.ac.tuwien.asgaard.swing.selectable.RadioButtonAbstractAction;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.delta.gui.MainController;
import at.ac.tuwien.asgaard.util.xml.dtd.DTDHelper;

import javax.swing.event.ChangeEvent;
import javax.swing.*;
import java.awt.event.KeyEvent;
import java.awt.event.InputEvent;

/**
 * Class MacroSwitchToInsertModeIntoAction ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.4.0
 */
public class MacroSwitchToInsertModeIntoAction extends RadioButtonAbstractAction {
    public MacroSwitchToInsertModeIntoAction() {
        super("Insert Into", MainImages.XML_INSERT_INTO_ICON, 'I', "\"Insert Macro\"-Action will insert current macro as child of selected Element");
        putValue(ACCELERATOR_KEY, KeyStroke.getKeyStroke(KeyEvent.VK_M, InputEvent.CTRL_MASK | InputEvent.SHIFT_MASK));
        selected = true;
		enabled = false;
    }
    
    public void stateChanged(ChangeEvent evt) {
		MainController.getActiveSideController().dtdHelper.setInsertMode(DTDHelper.INSERT_MODE_INTO);
        MainController.mainFrame.macroInsertModeComboBox.setSelectedIndex(0);
    }
}
