/*
 * Project: DELTA - Guideline Markup Tool / Version: 2.7.3.#452
 * Author: Peter Votruba
 * Date: 19.05.2003
 * Time: 16:09:33
 */
package at.ac.tuwien.asgaard.delta.gui.actions.macros;

import at.ac.tuwien.asgaard.delta.gui.MainController;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.swing.StatusBar;
import at.ac.tuwien.asgaard.swing.selectable.RadioButtonAbstractAction;

import javax.swing.event.ChangeEvent;

/**
 * Class MacroSwitchToSourceViewAction ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.3.0
 */
public class MacroSwitchToSourceViewAction extends RadioButtonAbstractAction {
	public MacroSwitchToSourceViewAction() {
		super("\"HTML\" Source", MainImages.SOURCE_VIEW_ICON);

		putValue(MNEMONIC_KEY, new Integer('S'));
		putValue(SHORT_DESCRIPTION, "Switch to \"HTML\" source view"); // when mouse over
		putValue(StatusBar.DESCRIPTION_HOVER, "Switch to syntax-highlighted source view."); // when mouse over - statusbar
		putValue(StatusBar.DESCRIPTION_ACTIVE, "Switching source view ...");  // when clicked
		this.enabled = false;
	}
	public void stateChanged(ChangeEvent evt) {
		MainController.mainFrame.switchToMacroSourceView();
		MainController.mainFrame.statusBar.popMessage();
	}
}
