/*
 * Project: DELTA - Guideline Markup Tool / Version: 2.7.3.#452
 * Author: Peter Votruba
 * Date: 19.05.2003
 * Time: 16:10:30
 */
package at.ac.tuwien.asgaard.delta.gui.actions.macros;

import at.ac.tuwien.asgaard.delta.gui.MainController;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.swing.StatusBar;
import at.ac.tuwien.asgaard.swing.selectable.RadioButtonAbstractAction;

import javax.swing.event.ChangeEvent;

/**
 * Class MacroSwitchToTextViewAction ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.3.0
 */
public class MacroSwitchToTextViewAction extends RadioButtonAbstractAction {
	public MacroSwitchToTextViewAction() {
		super("Plain Source", MainImages.TEXT_VIEW_ICON);

		putValue(MNEMONIC_KEY, new Integer('T'));
		putValue(SHORT_DESCRIPTION, "Switch to plain source view"); // when mouse over
		putValue(StatusBar.DESCRIPTION_HOVER, "Switch to plain-text source view."); // when mouse over - statusbar
		putValue(StatusBar.DESCRIPTION_ACTIVE, "Switching to plain-text source view ...");  // when clicked
		this.enabled = false;
	}
	public void stateChanged(ChangeEvent evt) {
		MainController.mainFrame.switchToMacroTextView();
		MainController.mainFrame.statusBar.popMessage();
	}
}
