/*
 * Project: DELTA - Guideline Markup Tool / Version: 2.7.3.#452
 * Author: Peter Votruba
 * Date: 19.05.2003
 * Time: 16:08:24
 */
package at.ac.tuwien.asgaard.delta.gui.actions.macros;

import at.ac.tuwien.asgaard.delta.gui.MainController;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.swing.StatusBar;
import at.ac.tuwien.asgaard.swing.selectable.RadioButtonAbstractAction;

import javax.swing.event.ChangeEvent;

/**
 * Class MacroSwitchToTreeViewAction ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.3.0
 */
public class MacroSwitchToTreeViewAction extends RadioButtonAbstractAction {
	public MacroSwitchToTreeViewAction() {
		super("Tree View", MainImages.TREE_VIEW_ICON);

		putValue(MNEMONIC_KEY, new Integer('T'));
		putValue(SHORT_DESCRIPTION, "Switch to tree view"); // when mouse over
		putValue(StatusBar.DESCRIPTION_HOVER, "Switch to tree view."); // when mouse over - statusbar
		putValue(StatusBar.DESCRIPTION_ACTIVE, "Switching to tree view ...");  // when clicked
		this.enabled    = false;
		this.selected   = true;
	}
	public void stateChanged(ChangeEvent evt) {
		MainController.mainFrame.switchToMacroTreeView();
		MainController.mainFrame.statusBar.popMessage();
	}
}
