/*
 * Project: DELTA - Guideline Markup Tool / Version: 2.7.3.#452
 * Author: Peter Votruba
 * Date: 19.05.2003
 * Time: 15:46:07
 */
package at.ac.tuwien.asgaard.delta.gui.actions.macros;

import at.ac.tuwien.asgaard.delta.gui.actions.SimpleAction;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.delta.gui.MainController;
import at.ac.tuwien.asgaard.swing.StatusBar;
import at.ac.tuwien.asgaard.util.Log;

import java.io.File;

/**
 * Class MacrosReloadAction ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.3.0
 */
public class MacrosCloseAction extends SimpleAction {
	public MacrosCloseAction() {
		super("Close", MainImages.CLOSE_ICON);

		putValue(MNEMONIC_KEY, new Integer('C'));
		putValue(SHORT_DESCRIPTION, "Close Macros file"); // when mouse over - tool-tip
		putValue(StatusBar.DESCRIPTION_HOVER, "Close the currently open Macros file."); // when mouse over - statusbar
		putValue(StatusBar.DESCRIPTION_ACTIVE, "Closing Macros file ...");  // when clicked
		this.enabled = false;
	}

	protected void simpleActionPerformed() {
		doCloseFile(true);
	}

	public void doCloseFile(boolean notifyController) {
		mainFrame.hideMacrosPart();

		if (!mainFrame.macrosView.isLoaded()) return;

		Log.trace("enter: MacrosCloseAction.doCloseFile()");

		File file = mainFrame.macrosView.getFile();
		MainController.addRecentFile(MainController.recentMacrosFiles, file);
		MainController.buildRecentMacrosFilesMenus();
		if (MainController.addRecentFile(MainController.recentDirs, file.getParentFile()))
			MainController.buildRecentDirsMenus();

		MainController.aMacrosSwitchToStructureView.setSelected(true);
		mainFrame.macrosView.close();
		mainFrame.jLabelMacrosFileName.setText(null);
		mainFrame.jLabelMacrosFileName.setToolTipText(null);
	//	mainFrame.jLabelMacrosFileName.setBorder(null);
		MainController.aMacrosReload.setEnabled(false);
		MainController.aMacrosOpenAsXML.setEnabled(false);
		MainController.aMacrosShowEditor.setEnabled(false);
		MainController.aMacrosSwitchToSearchView.setEnabled(false);
		MainController.aMacrosSwitchToStructureView.setEnabled(false);
		MainController.aMacrosSwitchToInsertableView.setEnabled(false);
		MainController.aFileCloseAll.setEnabled(MainController.deltaSides[LEFT].deltaView.isLoaded() ||
												MainController.deltaSides[RIGHT].deltaView.isLoaded() ||
												MainController.mainFrame.macrosView.isLoaded());
		if (notifyController)
			MainController.fileChanged(MACROS);
		Log.trace("exit:  MacrosCloseAction.doCloseFile()");
	}
}
