/*
 * Project: DELTA - Guideline Markup Tool / Version: 2.7.3.#452
 * Author: Peter Votruba
 * Date: 19.05.2003
 * Time: 15:46:07
 */
package at.ac.tuwien.asgaard.delta.gui.actions.macros;

import at.ac.tuwien.asgaard.delta.gui.MainController;
import at.ac.tuwien.asgaard.delta.gui.actions.BaseAction;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.swing.StatusBar;

import java.awt.event.ActionEvent;

import javax.swing.*;

/**
 * Class MacrosReloadAction ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.3.0
 */
public class MacrosReloadAction extends BaseAction {
	public MacrosReloadAction() {
		super("Reload", MainImages.RELOAD_ICON);

		putValue(MNEMONIC_KEY, new Integer('R'));
		putValue(SHORT_DESCRIPTION, "Reload Macros file"); // when mouse over - tool-tip
		putValue(StatusBar.DESCRIPTION_HOVER, "Reload the currently open Macros file."); // when mouse over - statusbar
		putValue(StatusBar.DESCRIPTION_ACTIVE, "Reloading Macros file ...");  // when clicked
		this.enabled = false;
	}
	public void setEnabled(boolean newValue) {
		super.setEnabled(newValue);
		MainController.aMacrosSwitchToStructureView.setEnabled(newValue);
		MainController.aMacrosSwitchToSearchView.setEnabled(newValue);
		MainController.aMacrosSwitchToInsertableView.setEnabled(newValue);
	}
	public void actionPerformed(ActionEvent evt) {
		mainFrame.setStatusBarActiveMessage(this, true);
		MainController.aMacrosSwitchToStructureView.setSelected(true);
		MainController.aMacroSwitchToTreeView.setSelected(true);
		MainController.disableMacrosActions();

		new at.ac.tuwien.asgaard.swing.SwingWorker() {
			public Object construct() {
				try {
					mainFrame.macrosView.reload();
				} catch (Throwable exc) {
					System.err.println("Couldn't reload macros file: ");
					exc.printStackTrace(System.err);
					return "Couldn't reload macros file:\n\n"+exc.getMessage();
				}
				return null;
			}
			public void finished() {
				Object errorMsg = get();
				if (errorMsg == null) {
					mainFrame.macrosView.invalidate();
					mainFrame.macrosView.validate();
					mainFrame.macrosView.repaint();
				} else
					JOptionPane.showMessageDialog(mainFrame, errorMsg.toString(),
					                              "Error", JOptionPane.ERROR_MESSAGE);
				MainController.enableMacrosActions();
				mainFrame.setStatusBarActiveMessage(MacrosReloadAction.this, false);
			}
		}.start();
	}
}
