/*
 * Project: DELTA - Guideline Markup Tool / Version: 2.7.3.#452
 * Author: Peter Votruba
 */
package at.ac.tuwien.asgaard.delta.gui.actions.macros;

import at.ac.tuwien.asgaard.delta.gui.MainController;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.swing.StatusBar;
import at.ac.tuwien.asgaard.swing.selectable.RadioButtonAbstractAction;

import javax.swing.event.ChangeEvent;

/**
 * Class MacrosSwitchToSearchInsertableAction ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.3.0
 */
public class MacrosSwitchToSearchInsertableAction extends RadioButtonAbstractAction {
	public MacrosSwitchToSearchInsertableAction() {
		super("Insertable View", MainImages.MACROS_INSERTABLE_VIEW_ICON);

		putValue(MNEMONIC_KEY, new Integer('I'));
		putValue(SHORT_DESCRIPTION, "Switch to insertable view"); // when mouse over
		putValue(StatusBar.DESCRIPTION_HOVER, "Switch to insertable view."); // when mouse over - statusbar
		putValue(StatusBar.DESCRIPTION_ACTIVE, "Switching to insertable view ...");  // when clicked
		this.enabled = false;
	}
	public void stateChanged(ChangeEvent evt) {
		MainController.mainFrame.switchToMacrosInsertableView();
	}
}
