/*
 * Project: DELTA - Guideline Markup Tool / Version: 2.7.3.#452
 * Author: Peter Votruba
 * Date: 19.05.2003
 * Time: 15:03:51
 */
package at.ac.tuwien.asgaard.delta.gui.actions.options;

import at.ac.tuwien.asgaard.delta.gui.MainController;
import at.ac.tuwien.asgaard.delta.gui.actions.SimpleAction;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.delta.gui.misc.XMLLanguageDialog;

import java.awt.event.*;

import javax.swing.*;

/**
 * Class OptionsLanguageShowPropertiesDialogAction ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.3.0
 */
public class OptionsLanguageShowPropertiesDialogAction extends SimpleAction {
	public OptionsLanguageShowPropertiesDialogAction() {
		super("XML Language Definitions...", MainImages.XML_LANGUAGE_ICON, 'D',
			  "Language Properties", "Configure XML language properties.", "Configure language properties ...");

		putValue(ACCELERATOR_KEY, KeyStroke.getKeyStroke(KeyEvent.VK_L, InputEvent.CTRL_MASK));
	}

	protected void simpleActionPerformed() {
        if (MainController.getXMLLanguageDialog().showDialog()) {
        // todo: if currentXMLLanguage==null but a file is already opened that has the old DTD of a newly created lang ... ???
		    MainController.deltaSideController[LEFT].refreshXMLLanguages();
		    MainController.deltaSideController[RIGHT].refreshXMLLanguages();
        }
	}

	public void newXMLLanguage() {
		XMLLanguageDialog dialog = MainController.getXMLLanguageDialog();
		int langNr = dialog.createNewXMLLanguage();
        if (langNr != -1) {
		    MainController.getActiveSideController().setCurrentXMLLanguage(langNr);
		    MainController.getInactiveSideController().refreshXMLLanguages();
        }
	}
}
