/*
 * Project: DELTA - Guideline Markup Tool / Version: 2.7.3.#452
 * Author: Peter Votruba
 * Date: 19.05.2003
 * Time: 15:18:09
 */
package at.ac.tuwien.asgaard.delta.gui.actions.options;

import at.ac.tuwien.asgaard.delta.gui.MainController;
import at.ac.tuwien.asgaard.delta.gui.actions.SimpleAction;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.delta.gui.misc.PreferencesDialog;

import java.awt.event.*;
import java.util.Set;

import javax.swing.*;

/**
 * Class OptionsPreferencesShowDialogAction ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.4.0
 */
public class OptionsPreferencesShowDialogAction extends SimpleAction {
	private PreferencesDialog dialog;

	public OptionsPreferencesShowDialogAction() {
		super("Preferences...", MainImages.PREFERENCES_ICON, 'P',
			  "DELT/A Preferences", "Configure DELT/A preferences.", "Configure DELT/A preferences ...");

		putValue(ACCELERATOR_KEY, KeyStroke.getKeyStroke(KeyEvent.VK_P, InputEvent.SHIFT_MASK | InputEvent.CTRL_MASK));
	}

	protected void simpleActionPerformed() {
		if (dialog == null)
			dialog = new PreferencesDialog(mainFrame, preferences);
		dialog.showDialog();
		Set<String> changedProperties = dialog.getChangedProperties();
		MainController.preferencesChanged(changedProperties);
	}
}
