/*
 * Project "Asbru Interpreter".
 * 
 * $Id$
 */
package at.ac.tuwien.asgaard.delta.gui.actions.project;

import at.ac.tuwien.asgaard.delta.gui.MainController;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.delta.xmlBeans.processTemplates.ProcessTemplate;
import at.ac.tuwien.asgaard.swing.StatusBar;
import at.ac.tuwien.asgaard.swing.selectable.RadioButtonAbstractAction;

import javax.swing.*;
import javax.swing.event.*;

/**
 * Class ProjectNewProcessBasedOnTemplateAction - todo javadoc.
 *
 * @author Peter Votruba
 * @version $Revision$
 */
public class ProjectChangeProcessStepAction extends RadioButtonAbstractAction {
	private final int processStepIndex;

	public ProjectChangeProcessStepAction(int processStepIndex,
										  at.ac.tuwien.asgaard.delta.xmlBeans.processProject.Process process,
										  ProcessTemplate processTemplate,
										  boolean createNewStep) { // true, if this action should result in creating a new step
		this.processStepIndex = processStepIndex;

		String label;
		if (createNewStep) {
			String sourceLanguage, targetLanguage;
			if (processStepIndex == 1)
				sourceLanguage = processTemplate.getSourceLanguage();
			else
				sourceLanguage = processTemplate.getStepTemplate(processStepIndex-2).getTargetLanguage();
			targetLanguage = processTemplate.getStepTemplate(processStepIndex - 1).getTargetLanguage();
			label = sourceLanguage + " -> " + targetLanguage;
			putValue(NAME, "<html>" + processStepIndex + " <i>" + label + "</i>");
		} else {
			label = process.getSteps().getStep(processStepIndex - 1).getName();
			putValue(NAME, "" + processStepIndex + ' ' + label);
		}
		String actionText = createNewStep ? "Create " : "Change to ";
		putValue(StatusBar.DESCRIPTION_ACTIVE, actionText + processStepIndex+". process step '" + label + "' ...");  // when clicked
		putValue(Action.SMALL_ICON, MainImages.TEMPLATE_ICON);
		putValue(Action.MNEMONIC_KEY, new Integer('0' + processStepIndex));
		String statusBarText = actionText + processStepIndex+". process step \"" + label + '\"';
		putValue(StatusBar.DESCRIPTION_HOVER, statusBarText); // when mouse over - statusbar
		String description = createNewStep ? processTemplate.getStepTemplate(processStepIndex - 1).getDescription() :
							 process.getSteps().getStep(processStepIndex - 1).getDescription();
		if ((description == null) || (description.trim().length() == 0))
			putValue(Action.SHORT_DESCRIPTION, statusBarText);
		else
			putValue(Action.SHORT_DESCRIPTION, statusBarText + ":\n  " + description); // when mouse over - tool-tip
	}

	public void stateChanged(ChangeEvent e) {
		System.out.println("change to process step: "+ processStepIndex);
		MainController.setDELTAProcessStep(processStepIndex);
	}
}
