/*
 * Project "Asbru Interpreter".
 * 
 * $Id$
 */
package at.ac.tuwien.asgaard.delta.gui.actions.project;

import at.ac.tuwien.asgaard.delta.gui.MainController;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.delta.xmlBeans.processTemplates.View;
import at.ac.tuwien.asgaard.swing.StatusBar;
import at.ac.tuwien.asgaard.swing.selectable.RadioButtonAbstractAction;

import javax.swing.*;
import javax.swing.event.*;

/**
 * Class ProjectNewProcessBasedOnTemplateAction - todo javadoc.
 *
 * @author Peter Votruba
 * @version $Revision$
 */
public class ProjectChangeProcessViewAction extends RadioButtonAbstractAction {
	private final View view;

	public ProjectChangeProcessViewAction(View view) {
		this.view = view;

		String label = view.getName();
		putValue(NAME, label);
		putValue(StatusBar.DESCRIPTION_ACTIVE, "Switch to view '" + label + "' ...");  // when clicked
		putValue(Action.SMALL_ICON, MainImages.VIEW_ICON);
	//	putValue(Action.MNEMONIC_KEY, new Integer('0' + viewIndex));
		String statusBarText = "Switch to view \"" + label + '\"';
		putValue(StatusBar.DESCRIPTION_HOVER, statusBarText); // when mouse over - statusbar
		String description = view.getDescription();
		if ((description == null) || (description.trim().length() == 0))
			putValue(Action.SHORT_DESCRIPTION, statusBarText);
		else
			putValue(Action.SHORT_DESCRIPTION, statusBarText + ":\n  " + description); // when mouse over - tool-tip
	}

	public void stateChanged(ChangeEvent e) {
		MainController.setDELTAProcessView(view);
	}
}
