/*
 * Project: DELTA - Guideline Markup Tool / Version: 2.7.3.#452
 * User: peter
 * Date: 30.04.2003
 * Time: 11:26:35
 */
package at.ac.tuwien.asgaard.delta.gui.actions.project;

import at.ac.tuwien.asgaard.delta.gui.GUIConstants;
import at.ac.tuwien.asgaard.delta.gui.MainController;
import at.ac.tuwien.asgaard.delta.gui.actions.SimpleAction;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.delta.gui.misc.ProjectPropertiesDialog;
import at.ac.tuwien.asgaard.delta.xmlBeans.Project;
import at.ac.tuwien.asgaard.swing.StatusBar;
import at.ac.tuwien.asgaard.util.FileUtils;

import java.awt.event.*;
import java.io.File;

import javax.swing.*;

/**
 * Class FileProjectSaveAction ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.3.0
 */
public final class ProjectNewAction extends SimpleAction {
// private JFileChooser fileChooser;

	public ProjectNewAction() {
		super("New...", MainImages.NEW_ICON, 'N');
		putValue(ACCELERATOR_KEY, KeyStroke.getKeyStroke(KeyEvent.VK_N, InputEvent.CTRL_MASK | InputEvent.SHIFT_MASK));
		putValue(StatusBar.TOOL_TIP, "Create new Project"); // when mouse over - tool-tip
		putValue(StatusBar.DESCRIPTION_HOVER, "Create new project using currently opened files."); // when mouse over - statusbar
		putValue(StatusBar.DESCRIPTION_ACTIVE, "Creating new project...");  // when clicked
	}
	public void simpleActionPerformed() {
		/*if (fileChooser == null) {
			fileChooser = new DeltaFileChooser(FileUtils.currentDirFile, "Create new Project File as ...");
			fileChooser.setFileFilter(DeltaFileChooser.PROJECT_FILE_FILTER);
		}*/
//  if (fileChooser.showSaveDialog(MainController.mainFrame) == JFileChooser.APPROVE_OPTION) {
			File newProjectFile = FileUtils.getTemporaryFile(FileUtils.currentDir, "newProject", ".project"); //fileChooser.getSelectedFile();
			Project project = new Project(newProjectFile, FileUtils.getFileName(newProjectFile),
												   MainController.deltaSides[GUIConstants.LEFT].deltaView.getFile(),
												   MainController.deltaSides[GUIConstants.RIGHT].deltaView.getFile(),
												   MainController.mainFrame.macrosView.getFile());

			ProjectPropertiesDialog dialog = ProjectPropertiesDialog.getSharedInstance();
			dialog.setDELTAProject(project);
			if (dialog.showDialog())
				MainController.setDELTAProject(project, true, false);
//  }
	}
}
