/*
 * Project: DELTA - Guideline Markup Tool / Version: 2.7.3.#452
 * Author: Peter Votruba
 * Date: 19.05.2003
 * Time: 14:59:44
 */
package at.ac.tuwien.asgaard.delta.gui.actions.project;

import at.ac.tuwien.asgaard.delta.gui.MainController;
import at.ac.tuwien.asgaard.delta.gui.actions.SimpleAction;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.delta.gui.misc.ProcessPropertiesDialog;
import at.ac.tuwien.asgaard.delta.gui.misc.ProjectPropertiesDialog;
import at.ac.tuwien.asgaard.swing.StatusBar;

import java.awt.event.*;

import javax.swing.*;

/**
 * Class ProjectShowPropertiesDialogAction ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.3.0
 */
public final class ProjectShowPropertiesDialogAction extends SimpleAction {
	public ProjectShowPropertiesDialogAction() {
		super("Project/Process Properties...", MainImages.PROJECT_PROPERTIES_ICON, 'P');

		putValue(StatusBar.TOOL_TIP, "Show Project/Process Properties"); // when mouse over - tool-tip
		putValue(StatusBar.DESCRIPTION_HOVER, "Show current project/process properties."); // when mouse over - statusbar
		putValue(StatusBar.DESCRIPTION_ACTIVE, "Showing current project/process properties ...");  // when clicked
        putValue(ACCELERATOR_KEY, KeyStroke.getKeyStroke(KeyEvent.VK_P, InputEvent.ALT_MASK | InputEvent.CTRL_MASK));
		enabled = false;
	}
    
    protected void simpleActionPerformed() {
		if (MainController.currentProject != null) {
			ProjectPropertiesDialog dialog = ProjectPropertiesDialog.getSharedInstance();
			dialog.setDELTAProject(MainController.currentProject);
			if (dialog.showDialog())
				MainController.setDELTAProject(MainController.currentProject, true, false);
		} else if (MainController.currentProcess != null) {
			ProcessPropertiesDialog dialog = ProcessPropertiesDialog.getSharedInstance();
			dialog.setDeltaProcess(MainController.currentProcess);
			if (dialog.showDialog())
				MainController.setDELTAProcess(MainController.currentProcess, true);
		}
	}
}
