/*
 * Project: DELTA - Guideline Markup Tool / Version: 2.7.3.#452
 * User: peter
 * Date: 30.04.2003
 * Time: 11:18:49
 */
package at.ac.tuwien.asgaard.delta.gui.actions.xhtml;

import at.ac.tuwien.asgaard.delta.gui.*;
import at.ac.tuwien.asgaard.delta.gui.actions.BaseAction;
import at.ac.tuwien.asgaard.swing.StatusBar;

import javax.swing.Action;
import javax.swing.Icon;
import java.awt.event.*;


/**
 * Class BothSidesAction ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.3.0
 */
public abstract class BothSidesAction extends BaseAction {
    protected final MainFrame.DeltaSide thisSide, otherSide;
	protected final DeltaSideController thisSideController, otherSideController;
	protected final int thisSideIndex, otherSideIndex;

    protected BothSidesAction(int thisSideIndex) {
        super();
		this.thisSideIndex = thisSideIndex;
		otherSideIndex = 1 - thisSideIndex;
        thisSide = MainController.deltaSides[thisSideIndex];
        otherSide = MainController.deltaSides[otherSideIndex];
		thisSideController = MainController.deltaSideController[thisSideIndex];
		otherSideController = MainController.deltaSideController[otherSideIndex];
    }

	protected BothSidesAction(int sideIndex, String name, Icon icon) {
		this(sideIndex);
		putValue(Action.NAME, name);
		putValue(Action.SMALL_ICON, icon);
	}
	protected BothSidesAction(int sideIndex, Icon icon, String toolTip) {
		this(sideIndex, icon, toolTip, toolTip);
	}
	protected BothSidesAction(int sideIndex, Icon icon, String toolTip, String msgHover) {
		this(sideIndex);
		putValue(Action.SMALL_ICON, icon);
		putValue(StatusBar.TOOL_TIP, toolTip); // when mouse over
		putValue(StatusBar.DESCRIPTION_HOVER, msgHover); // when mouse over

	}

	protected BothSidesAction(int sideIndex, String name, Icon icon, char mnemonicKey, String toolTip) {
		this(sideIndex, name, icon, mnemonicKey, toolTip, toolTip);
	}

	protected BothSidesAction(int sideIndex, String name, Icon icon, char mnemonicKey, String toolTip, String msgHover) {
		this(sideIndex, name, icon);
		putValue(MNEMONIC_KEY, new Integer(mnemonicKey));
		putValue(StatusBar.TOOL_TIP, toolTip); // when mouse over
		putValue(StatusBar.DESCRIPTION_HOVER, msgHover); // when mouse over - statusbar
	}

	public final void actionPerformed(ActionEvent evt) {
		if (enabled) {
			MainController.setActiveSideIndex(thisSideIndex);
			actionPerformed();
		}
	}
	
	protected abstract void actionPerformed();
}
