/*
 * Project: DELTA - Guideline Markup Tool / Version: 2.7.3.#452
 * Author: Peter Votruba
 * Date: 02.10.2003
 * Time: 11:21:11
 */
package at.ac.tuwien.asgaard.delta.gui.actions.xhtml;

import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.delta.gui.MainController;
import at.ac.tuwien.asgaard.swing.StatusBar;

import java.util.Set;

/**
 * Class XHTMLActivateLinksAction ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.3.0
 */
public class XHTMLActivateLinksAction extends BothSidesAction {
	public XHTMLActivateLinksAction(int sideIndex) {
		super(sideIndex, "Activate Links", MainImages.ACTIVATE_LINKS_ICON);

		putValue(MNEMONIC_KEY, new Integer('A'));
//  putValue(LOCAL_ACCELERATOR_KEY, KeyStroke.getKeyStroke(KeyEvent.VK_O, InputEvent.CTRL_MASK));
		putValue(StatusBar.TOOL_TIP, "Activate selected links"); // when mouse over - tool-tip
		putValue(StatusBar.DESCRIPTION_HOVER, "Activate all links in selection."); // when mouse over - statusbar
		enabled = false;
	}

	protected void actionPerformed() {
		Set selectedLinkIDs = thisSide.deltaView.getSelectedLinkIDs();
		otherSide.deltaView.highlightDELTALinks(selectedLinkIDs);
		MainController.setActiveSideIndex(thisSideIndex);
	}
}
