/*
 * Project: Asgaard - Guideline Markup Tool
 * Class: XHTMLReloadFileAction
 * User: Peter
 * Date: 26.05.2003
 * Time: 03:26:08
 */

package at.ac.tuwien.asgaard.delta.gui.actions.xhtml;

import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.delta.gui.MainController;
import at.ac.tuwien.asgaard.swing.StatusBar;
import at.ac.tuwien.asgaard.util.Log;


/**
 * Class XHTMLReloadFileAction ... todo
 */
public class XHTMLCloseFileAction extends BothSidesAction {
	public XHTMLCloseFileAction(int thisSideIndex) {
		super(thisSideIndex, "Close", MainImages.CLOSE_ICON);

		putValue(MNEMONIC_KEY, new Integer('C'));
		putValue(SHORT_DESCRIPTION, "Close file"); // when mouse over - tool-tip
		putValue(StatusBar.DESCRIPTION_HOVER, "Close the currently open file."); // when mouse over - statusbar
		putValue(StatusBar.DESCRIPTION_ACTIVE, "Closing file ...");  // when clicked
		enabled = false;
	}

	protected void actionPerformed() {
		doCloseFile(true, true);
	}

	public void doCloseFile(boolean allowCancel, boolean notifyController) {
		Log.trace("enter: XHTMLCloseFileAction.doCloseFile()");
	// thisSide.hideSide();
		mainFrame.setStatusBarActiveMessage(this, true);
		if (thisSideController.saveIfChanged(allowCancel)) {
			thisSide.deltaView.close();
			thisSide.clearViews();
			thisSide.setFileNameLabel(null, null);
			thisSideController.setTypeEmpty();
			MainController.aFileCloseAll.setEnabled(otherSide.deltaView.isLoaded() || MainController.mainFrame.macrosView.isLoaded());
			if (notifyController)
				MainController.fileChanged(thisSideIndex);
		}
		mainFrame.setStatusBarActiveMessage(this, false);
		Log.trace("exit:  XHTMLCloseFileAction.doCloseFile()");
	}
}
