/*
 * Project: DELTA - Guideline Markup Tool / Version: 2.7.3.#452
 * Author: Peter Votruba
 * Date: 14.08.2003
 * Time: 14:46:28
 */
package at.ac.tuwien.asgaard.delta.gui.actions.xhtml;

import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.delta.gui.misc.DeltaFileChooser;
import at.ac.tuwien.asgaard.swing.StatusBar;
import at.ac.tuwien.asgaard.util.Log;

import javax.swing.*;
import java.io.*;

/**
 * Class XHTMLSaveHTMLSourceAction ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.3.0
 */
public class XHTMLExportHTMLSourceAction extends SimpleBothSidesAction {
	private JFileChooser fileChooser;
	public XHTMLExportHTMLSourceAction(int thisSideIndex) {
		super(thisSideIndex, "Export HTML source to File...", MainImages.SAVE_AS_ICON);
		putValue(MNEMONIC_KEY, new Integer('E'));
		putValue(StatusBar.TOOL_TIP, "Export HTML source content to file"); // when mouse over
		putValue(StatusBar.DESCRIPTION_HOVER, "Export content of HTML source view to file."); // when mouse over - statusbar
		enabled = false;
	}

	protected void simpleActionPerformed() {
		if (fileChooser == null) {
			fileChooser = new DeltaFileChooser("Save HTML source...");
			fileChooser.setFileFilter(DeltaFileChooser.HTML_FILE_FILTER);
		}
		if (fileChooser.showSaveDialog(thisSide) == JFileChooser.APPROVE_OPTION) {
				File selectedFile = fileChooser.getSelectedFile();
				try {
					Writer writer = new BufferedWriter(new FileWriter(selectedFile));
					thisSide.htmlOutput.write(writer);
					writer.flush();
					writer.close();
				} catch (IOException exc) {
					Log.error("Couldn't save HTML source to \"" + selectedFile +"\": " + exc.toString());
					JOptionPane.showMessageDialog(thisSide, "Couldn't save HTML source to \"" + selectedFile +"\": " + exc.toString(), "I/O Error", JOptionPane.ERROR_MESSAGE);
				}
		}
	}
}
