/*
 * Project: Asgaard - Guideline Markup Tool
 * Class: XHTMLReloadFileAction
 * User: Peter
 * Date: 26.05.2003
 * Time: 03:26:08
 */

package at.ac.tuwien.asgaard.delta.gui.actions.xhtml;

import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.swing.StatusBar;

import javax.swing.*;
import java.awt.event.*;

/**
 * Class XHTMLReloadFileAction ... todo
 */
public class XHTMLGoForwardAction extends BothSidesAction {
	public XHTMLGoForwardAction(int thisSideIndex) {
		super(thisSideIndex, "Go Forward", MainImages.FORWARD_ICON);

		putValue(LOCAL_ACCELERATOR_KEY, KeyStroke.getKeyStroke(KeyEvent.VK_RIGHT, InputEvent.CTRL_MASK | InputEvent.ALT_MASK));
		putValue(MNEMONIC_KEY, new Integer('F'));
		putValue(StatusBar.TOOL_TIP, "Go forward"); // when mouse over
		putValue(StatusBar.DESCRIPTION_HOVER, "Go forward to the next treenode."); // when mouse over - statusbar
		enabled = false;
	}

	protected void actionPerformed() {
		if (thisSideController.aSwitchToViewer.isSelected()) {
			thisSideController.aSwitchToViewer.setSelected(true);
			setEnabled(thisSide.deltaView.goForward());
		} else
			setEnabled(thisSide.htmlOutput.goForward()); // todo test it - go forward in source code
		thisSideController.aGoBack.setEnabled(true);
	}
}
