/*
 * Project: Asgaard - Guideline Markup Tool
 * Class: XHTMLReloadFileAction
 * User: Peter
 * Date: 26.05.2003
 * Time: 03:26:08
 */

package at.ac.tuwien.asgaard.delta.gui.actions.xhtml;

import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.delta.util.Preferences;
import at.ac.tuwien.asgaard.swing.StatusBar;
import at.ac.tuwien.asgaard.util.FileUtils;

import javax.swing.JOptionPane;
import java.io.File;

/**
 * Class XHTMLReloadFileAction ... todo
 */
public class XHTMLRevertFileAction extends BothSidesAction {
	public XHTMLRevertFileAction(int thisSideIndex) {
		super(thisSideIndex);

		putValue(NAME, "Revert");
		putValue(SMALL_ICON, MainImages.REVERT_ICON);
		putValue(MNEMONIC_KEY, new Integer('T'));
		putValue(StatusBar.TOOL_TIP, "Revert to backup"); // when mouse over
		putValue(StatusBar.DESCRIPTION_HOVER, "Replace the current file with the previously saved backup."); // when mouse over - statusbar
		putValue(StatusBar.DESCRIPTION_ACTIVE, "Replaceing the current file with the previously saved backup ...");  // when clicked
		this.enabled = false;
	}

	protected void actionPerformed() {
		mainFrame.setStatusBarActiveMessage(this, true);
		File file = thisSide.deltaView.getFile();
		if (thisSide.deltaView.contentHasChanged()
				&& (preferences.getInt(Preferences.KEY_AUTO_SAVE) != AUTO_SAVE_NO))
			if (JOptionPane.showConfirmDialog(mainFrame, "The content of \"" + file.getName()
															  + "\" has been changed.\nThe changes will be lost if you revert to the backup now!\n\nDo you really want to continue?",
											  "Revert", JOptionPane.YES_NO_OPTION, JOptionPane.WARNING_MESSAGE)
					== JOptionPane.NO_OPTION)
				return;
		if (FileUtils.revertToBackup(file))
			thisSideController.aReload.doReload(false);
		else
			JOptionPane.showMessageDialog(mainFrame, "Couldn't revert to backup of XML file!",
										  "Error", JOptionPane.ERROR_MESSAGE);
		mainFrame.setStatusBarActiveMessage(this, false);
	}
}
