/*
 * Project: DELTA - Guideline Markup Tool / Version: 2.7.3.#452
 * Author: Peter Votruba
 * Date: 14.08.2003
 * Time: 14:50:27
 */
package at.ac.tuwien.asgaard.delta.gui.actions.xhtml;

import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.swing.StatusBar;
import at.ac.tuwien.asgaard.util.*;

import javax.swing.*;
import java.io.*;

/**
 * Class XHTMLOpenHTMLSourceInBrowserAction ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.3.0
 */
public class XHTMLShowHTMLSourceInBrowserAction extends SimpleBothSidesAction {
	public XHTMLShowHTMLSourceInBrowserAction(int thisSideIndex) {
		super(thisSideIndex, "Show in Browser", MainImages.WWW_ICON);
		putValue(MNEMONIC_KEY, new Integer('B'));
		putValue(StatusBar.TOOL_TIP, "Show source in browser"); // when mouse over
		putValue(StatusBar.DESCRIPTION_HOVER, "Show in system-default browser."); // when mouse over - statusbar
		enabled = false;
	}

	protected void simpleActionPerformed() {
		try {
			File tempFile = File.createTempFile("temp", ".html", FileUtils.currentDirFile);
			Writer writer = new BufferedWriter(new FileWriter(tempFile));
			thisSide.htmlOutput.write(writer);
			writer.flush();
			writer.close();
			BrowserControl.displayURL(tempFile.getAbsolutePath());
			tempFile.deleteOnExit();
		} catch (IOException exc) {
			Log.error("Couldn't open temp file in Browser: "+exc.toString());
			JOptionPane.showMessageDialog(thisSide, "Couldn't open temp file in Browser: " + exc.toString(), "I/O Error", JOptionPane.ERROR_MESSAGE);
		}
	}
}