/*
 * Project: DELTA - Guideline Markup Tool / Version: 2.7.3.#452
 * Author: Peter Votruba
 * Date: 19.05.2003
 * Time: 16:08:24
 */
package at.ac.tuwien.asgaard.delta.gui.actions.xhtml;

import at.ac.tuwien.asgaard.delta.gui.*;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.swing.StatusBar;
import at.ac.tuwien.asgaard.swing.selectable.RadioButtonAbstractAction;

import javax.swing.event.ChangeEvent;
import javax.swing.*;
import java.awt.event.KeyEvent;

/**
 * Class MacroSwitchToTreeViewAction ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.3.0
 */
public class XHTMLSwitchToViewerAction extends RadioButtonAbstractAction implements GUIConstants {
	protected final DeltaSideController thisSideController;
	public XHTMLSwitchToViewerAction(DeltaSideController thisSideController) {
		super("Main View", MainImages.VIEW_ICON);

		this.thisSideController = thisSideController;

		putValue(MNEMONIC_KEY, new Integer('V'));
		putValue(LOCAL_ACCELERATOR_KEY, KeyStroke.getKeyStroke(KeyEvent.VK_F5, 0));
		putValue(StatusBar.TOOL_TIP, "Switch to main view"); // when mouse over
		putValue(StatusBar.DESCRIPTION_HOVER, "Switch to main view."); // when mouse over - statusbar

		selected = true;
	}

	public void stateChanged(ChangeEvent evt) {
		thisSideController.aGoBack.setEnabled(true);
		thisSideController.aGoForward.setEnabled(true);
		thisSideController.thisSide.switchToViewer();
		MainController.mainFrame.statusBar.popMessage();
	}

	public void setTypeXML() {
		putValue(NAME, "XML Editor");
		putValue(SMALL_ICON, MainImages.TREE_VIEW_ICON);
		putValue(MNEMONIC_KEY, new Integer('X'));
		putValue(StatusBar.TOOL_TIP, "Switch to tree view"); // when mouse over
		putValue(StatusBar.DESCRIPTION_HOVER, "Switch to tree view."); // when mouse over - statusbar
		putValue(StatusBar.DESCRIPTION_ACTIVE, "Switching to tree view ...");  // when clicked
	}
	public void setTypeHTML() {
		putValue(NAME, "HTML Browser");
		putValue(SMALL_ICON, MainImages.HTML_VIEW_ICON);
		putValue(MNEMONIC_KEY, new Integer('H'));
		putValue(StatusBar.TOOL_TIP,            "Switch to browser view"); // when mouse over
		putValue(StatusBar.DESCRIPTION_HOVER,   "Switch to HTML browser view."); // when mouse over - statusbar
		putValue(StatusBar.DESCRIPTION_ACTIVE,  "Switching to HTML browser view ...");  // when clicked
	}
	public void setTypeEmpty() {
		putValue(NAME, "Main View");
		putValue(SMALL_ICON, MainImages.VIEW_ICON);
		putValue(MNEMONIC_KEY, new Integer('V'));
		putValue(StatusBar.TOOL_TIP, "Switch to main view"); // when mouse over
		putValue(StatusBar.DESCRIPTION_HOVER, "Switch to main view."); // when mouse over - statusbar
	}
}
