/*
 * Project: DELTA - Guideline Markup Tool / Version: 2.7.3.#452
 * Author: Peter Votruba
 * Date: 19.05.2003
 * Time: 16:09:33
 */
package at.ac.tuwien.asgaard.delta.gui.actions.xhtml;

import at.ac.tuwien.asgaard.delta.gui.MainController;
import at.ac.tuwien.asgaard.delta.gui.MainFrame;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.swing.StatusBar;
import at.ac.tuwien.asgaard.util.Log;

import java.awt.event.KeyEvent;

import javax.swing.*;

/**
 * Class MacroSwitchToSourceViewAction ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 */
public class XHTMLViewShowFormattedSourceAction extends BothSidesAction {
	public XHTMLViewShowFormattedSourceAction(int thisSideIndex) {
		super(thisSideIndex, "Show Formatted Source", MainImages.HTML_VIEW_ICON);

		putValue(MNEMONIC_KEY, new Integer('F'));
		putValue(LOCAL_ACCELERATOR_KEY, KeyStroke.getKeyStroke(KeyEvent.VK_F8, 0));
		putValue(SHORT_DESCRIPTION, "Show formatted source view"); // when mouse over
		putValue(StatusBar.DESCRIPTION_HOVER, "Show syntax-highlighted source view."); // when mouse over - statusbar
		putValue(StatusBar.DESCRIPTION_ACTIVE, "Showing formatted source view ...");  // when clicked
		this.enabled = false;
	}
	protected void actionPerformed() {
		final MainFrame mainFrame = MainController.mainFrame;
		mainFrame.statusBar.setActiveMessageFrom(this);
		thisSideController.aSwitchToHTMLOutput.setEnabled(true);
		thisSideController.aSwitchToHTMLOutput.setSelected(true);
		thisSideController.aGoBack.setEnabled(false);
		thisSideController.aGoForward.setEnabled(false);
		Log.trace("before displaying syntax-highlighted source code");
		thisSide.htmlOutput.setText("Showing the syntax-highlighted source of large XML/HTML files may take a while ...");
	//	thisSide.htmlOutput.setBackground(GlobalConstants.DEFAULT_BACKGROUND);
		new at.ac.tuwien.asgaard.swing.SwingWorker() {
{
ClassLoader loader = XHTMLViewShowFormattedSourceAction.this.getClass().getClassLoader();
Thread.currentThread().setContextClassLoader(loader);
}
			public Object construct() {
				thisSide.htmlOutput.setText(thisSide.deltaView.getSourceHTML()); // setText should not be in construct, because this is not the Swing-Thread, but since it may also take long ...
				return null;
			}
			public void finished() {
				Log.trace("after displaying syntax-highlighted XML source");
                if (thisSideController.isTypeXML())
                    thisSide.htmlOutput.scrollToReference(thisSide.xmlView.getSelectedTreeNode().getXPath());
                else
				    thisSide.htmlOutput.setCaretPosition(0);
				thisSideController.sourceViewNeedsUpdateXHTMLSource = false;
				thisSideController.sourceViewNeedsUpdateDTDSource = thisSideController.sourceViewNeedsUpdateDTDReport = true;
				mainFrame.statusBar.unsetActiveMessageFrom(XHTMLViewShowFormattedSourceAction.this);
			}
		}.start();
	}
}
