/*
 * Project: DELTA - Guideline Markup Tool / Version: 2.7.3.#452
 * Author: Peter Votruba
 * Date: 19.05.2003
 * Time: 16:10:30
 */
package at.ac.tuwien.asgaard.delta.gui.actions.xhtml;

import at.ac.tuwien.asgaard.delta.gui.*;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.swing.StatusBar;

import javax.swing.*;
import java.awt.event.KeyEvent;

/**
 * Class MacroSwitchToTextViewAction ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.3.0
 */
public class XHTMLViewShowPlainSourceAction extends BothSidesAction {
	public XHTMLViewShowPlainSourceAction(int thisSideIndex) {
		super(thisSideIndex, "Show Plain Source", MainImages.TEXT_VIEW_ICON);

		putValue(MNEMONIC_KEY, new Integer('S'));
		putValue(LOCAL_ACCELERATOR_KEY, KeyStroke.getKeyStroke(KeyEvent.VK_F8, KeyEvent.SHIFT_MASK));
		putValue(SHORT_DESCRIPTION, "Show plain source view"); // when mouse over
		putValue(StatusBar.DESCRIPTION_HOVER, "Show plain-text source view."); // when mouse over - statusbar
		putValue(StatusBar.DESCRIPTION_ACTIVE, "Showing plain-text source view ...");  // when clicked
		enabled = false;
	}
	protected void actionPerformed() {
		final MainFrame mainFrame = MainController.mainFrame;
		mainFrame.statusBar.setActiveMessageFrom(this);
		thisSideController.aSwitchToTextOutput.setEnabled(true);
		thisSideController.aSwitchToTextOutput.setSelected(true);
		thisSideController.aGoBack.setEnabled(false);
		thisSideController.aGoForward.setEnabled(false);
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				thisSide.textOutput.setText(thisSide.deltaView.getSourcePlain());
				thisSide.textOutput.setCaretPosition(0);
				thisSideController.textViewNeedsUpdateXHTMLSource = false;
				thisSideController.textViewNeedsUpdateDTDSource = true;
				mainFrame.statusBar.unsetActiveMessageFrom(XHTMLViewShowPlainSourceAction.this);
			}
		});
	}
}
