/*
 * Project: DELTA - Guideline Markup Tool / Version: 2.7.3.#452
 * Author: Peter Votruba
 * Date: 19.05.2003
 * Time: 16:09:33
 */
package at.ac.tuwien.asgaard.delta.gui.actions.xhtml;

import at.ac.tuwien.asgaard.delta.gui.*;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.swing.*;
import at.ac.tuwien.asgaard.swing.selectable.RadioButtonAbstractAction;

import javax.swing.event.ChangeEvent;
import javax.swing.*;
import java.awt.event.KeyEvent;

/**
 * Class MacroSwitchToSourceViewAction ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 */
public class XHTMLViewSwitchToHTMLOutputAction extends RadioButtonAbstractAction {
	protected final DeltaSideController thisSideController;
	public XHTMLViewSwitchToHTMLOutputAction(DeltaSideController thisSideController) {
		super("HTML Output", MainImages.HTML_VIEW_ICON);

		this.thisSideController = thisSideController;

		putValue(MNEMONIC_KEY, new Integer('H'));
		putValue(LOCAL_ACCELERATOR_KEY, KeyStroke.getKeyStroke(KeyEvent.VK_F6, 0));
		putValue(SHORT_DESCRIPTION, "Switch to HTML output"); // when mouse over
		putValue(StatusBar.DESCRIPTION_HOVER, "Switch to HTML output."); // when mouse over - statusbar
		this.enabled = false;
	}
	public void stateChanged(ChangeEvent evt) {
		thisSideController.thisSide.switchToSimpleHTMLView();
        if (!thisSideController.sourceViewNeedsUpdateXHTMLSource)
            if (thisSideController.isTypeXML())
                thisSideController.thisSide.htmlOutput.scrollToReference(thisSideController.thisSide.xmlView.getSelectedTreeNode().getXPath());
            else
                thisSideController.thisSide.htmlOutput.setCaretPosition(0);
		thisSideController.aGoBack.setEnabled(false);
		thisSideController.aGoForward.setEnabled(false);
	}
}
