/*
 * Project: DELTA - Guideline Markup Tool / Version: 2.7.3.#452
 * Author: Peter Votruba
 * Date: 19.05.2003
 * Time: 16:10:30
 */
package at.ac.tuwien.asgaard.delta.gui.actions.xhtml;

import at.ac.tuwien.asgaard.delta.gui.*;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.swing.StatusBar;
import at.ac.tuwien.asgaard.swing.selectable.RadioButtonAbstractAction;

import javax.swing.*;
import javax.swing.event.ChangeEvent;
import java.awt.event.KeyEvent;

/**
 * Class MacroSwitchToTextViewAction ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.3.0
 */
public class XHTMLViewSwitchToTextOutputAction extends RadioButtonAbstractAction {
	protected final DeltaSideController thisSideController;
	public XHTMLViewSwitchToTextOutputAction(DeltaSideController thisSideController) {
		super("Text Output", MainImages.TEXT_VIEW_ICON);

		this.thisSideController = thisSideController;

		putValue(MNEMONIC_KEY, new Integer('T'));
		putValue(LOCAL_ACCELERATOR_KEY, KeyStroke.getKeyStroke(KeyEvent.VK_F7, 0));
		putValue(SHORT_DESCRIPTION, "Switch to plain text view"); // when mouse over
		putValue(StatusBar.DESCRIPTION_HOVER, "Switch to plain text view."); // when mouse over - statusbar
		enabled = false;
	}
	public void stateChanged(ChangeEvent evt) {
		thisSideController.thisSide.switchToPlainSourceView();
		thisSideController.aGoBack.setEnabled(false);
		thisSideController.aGoForward.setEnabled(false);
	}
}
