/*
 * Asgaard-Project (Peter Votruba), http://www.asgaard.tuwien.ac.at/
 * Vienna University of Technology (Austria)
 * Institute of Software Technology and Interactive Systems
 * Information & Software Engineering Group
 * --------------------------------------------------------------------
 * in cooperation with the Protocure-Project, http://www.protocure.org/
 */
package at.ac.tuwien.asgaard.delta.gui.actions.xhtml.html;

import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.delta.gui.actions.xhtml.SimpleBothSidesAction;
import at.ac.tuwien.asgaard.swing.StatusBar;
import at.ac.tuwien.asgaard.util.*;

/**
 * Class XHTMLOpenHTMLSourceInBrowserAction ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.4.0
 */
public class HTMLShowInBrowserAction extends SimpleBothSidesAction {
	public HTMLShowInBrowserAction(int thisSideIndex) {
		super(thisSideIndex, "Show in Browser", MainImages.WWW_ICON);
		putValue(MNEMONIC_KEY, new Integer('B'));
		putValue(StatusBar.TOOL_TIP, "Show HTML file in browser"); // when mouse over
		putValue(StatusBar.DESCRIPTION_HOVER, "Show current HTML file in system-default browser."); // when mouse over - statusbar
		enabled = false;
	}

	protected void simpleActionPerformed() {
		BrowserControl.displayURL(thisSide.htmlView.getFilePath());
	}
}