/*
 * Asgaard-Project (Peter Votruba), http://www.asgaard.tuwien.ac.at/
 * Vienna University of Technology (Austria)
 * Institute of Software Technology and Interactive Systems
 * Information & Software Engineering Group
 * --------------------------------------------------------------------
 * in cooperation with the Protocure-Project, http://www.protocure.org/
 */
package at.ac.tuwien.asgaard.delta.gui.actions.xhtml.xml;

import at.ac.tuwien.asgaard.delta.gui.actions.xhtml.SimpleBothSidesAction;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.swing.StatusBar;

import java.awt.event.*;

import javax.swing.*;

public final class XMLAddRequiredContentAction extends SimpleBothSidesAction {
    public XMLAddRequiredContentAction(int thisSideIndex) {
        super(thisSideIndex, "Add Required Content", MainImages.XML_ADD_REQUIRED_CONTENT_ICON);

		putValue(LOCAL_ACCELERATOR_KEY, KeyStroke.getKeyStroke(KeyEvent.VK_PLUS, InputEvent.CTRL_MASK));
        putValue(MNEMONIC_KEY, new Integer('C'));
        putValue(StatusBar.TOOL_TIP, "Add Required Attributes and Children"); // when mouse over
        putValue(StatusBar.DESCRIPTION_HOVER, "Add Required Attributes and Children to currently selected EMPTY XML Element."); // when mouse over - statusbar
        enabled = false;
    }

	public void simpleActionPerformed() {
		thisSide.xmlView.addRequiredContentToCurrentNode();
		thisSide.xmlAttributesTable.refresh();
    }
}
