/*
 * Project: DELTA - Guideline Markup Tool / Version: 2.7.3.#452
 * Author: Peter Votruba
 * Date: 22.05.2003
 * Time: 14:52:05
 */
package at.ac.tuwien.asgaard.delta.gui.actions.xhtml.xml;

import at.ac.tuwien.asgaard.delta.gui.MainController;
import at.ac.tuwien.asgaard.delta.gui.MainFrame;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.delta.gui.xml.XMLView;
import at.ac.tuwien.asgaard.swing.StatusBar;
import at.ac.tuwien.asgaard.swing.selectable.CheckBoxAbstractAction;

import javax.swing.event.ChangeEvent;

/**
 * Class XMLDELTALinksVisualizationUpAction ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.3.0
 */
public class XMLDELTALinksVisualizationDownAction extends CheckBoxAbstractAction {
	public XMLDELTALinksVisualizationDownAction() {
		super("DELT/A-Links and descendants", MainImages.LINKS_VIS_DOWN_ICON);

		putValue(MNEMONIC_KEY, new Integer('D'));
		putValue(SHORT_DESCRIPTION, "Visualize DELT/A-Links"); // when mouse over
		putValue(StatusBar.DESCRIPTION_HOVER, "Visualize DELT/A-Links and its descendants."); // when mouse over - statusbar
		putValue(StatusBar.DESCRIPTION_ACTIVE, "Visualizing DELT/A-Links ...");  // when clicked
		this.enabled = false;
	}

	public void stateChanged(ChangeEvent evt) {
		MainController.mainFrame.statusBar.setActiveMessageFrom(this);
		MainFrame.DeltaSide activeSide = MainController.getActiveSide();
		activeSide.sideController.aSwitchToViewer.setSelected(true);
		if (selected) {
			activeSide.sideController.aXMLDELTALinksVisualizationUp.setSelected(false);
			activeSide.xmlView.setDELTALinksVisualization(XMLView.LINK_VISUALIZATION_DOWN);
		} else
			activeSide.xmlView.setDELTALinksVisualization(XMLView.NO_VISUALIZATION);
		MainController.mainFrame.statusBar.unsetActiveMessageFrom(this);
	}
}
