/*
 * Project: DELTA - Guideline Markup Tool / Version: 2.7.3.#452
 * Author: Peter Votruba
 * Date: 17.02.2004
 * Time: 15:14:34
 */
package at.ac.tuwien.asgaard.delta.gui.actions.xhtml.xml;

import at.ac.tuwien.asgaard.delta.gui.actions.xhtml.SimpleBothSidesAction;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.swing.StatusBar;

import javax.swing.*;
import java.awt.event.KeyEvent;
import java.awt.event.InputEvent;

/**
 * Class XMLDuplicateNodeAction ... todo
 * 
 * @author Peter Votruba
 * @version 2.7.3.#452
 * @since JDK 1.4.0
 */
public class XMLDuplicateNodeAction extends SimpleBothSidesAction {
	public XMLDuplicateNodeAction(int thisSideIndex) {
		super(thisSideIndex, "Duplicate Node", MainImages.COPY_ICON);
		putValue(MNEMONIC_KEY, new Integer('D'));
		putValue(LOCAL_ACCELERATOR_KEY, KeyStroke.getKeyStroke(KeyEvent.VK_D, InputEvent.CTRL_MASK));
		putValue(StatusBar.TOOL_TIP, "Duplicate XML Node"); // when mouse over - tool-tip
		putValue(StatusBar.DESCRIPTION_HOVER, "Duplicate selected XML Node."); // when mouse over - statusbar
		putValue(StatusBar.DESCRIPTION_ACTIVE, "Duplicating node ...");  // when clicked
		enabled = false;
	}

	public void simpleActionPerformed() {
		thisSideController.aSwitchToViewer.setSelected(true);
		thisSide.xmlView.duplicateCurrentNode();
	}
}