/*
 * Asgaard-Project (Peter Votruba), http://www.asgaard.tuwien.ac.at/
 * Vienna University of Technology (Austria)
 * Institute of Software Technology and Interactive Systems
 * Information & Software Engineering Group
 * --------------------------------------------------------------------
 * in cooperation with the Protocure-Project, http://www.protocure.org/
 */
package at.ac.tuwien.asgaard.delta.gui.actions.xhtml.xml;

import at.ac.tuwien.asgaard.delta.gui.actions.xhtml.BothSidesAction;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.swing.StatusBar;

import javax.swing.*;
import java.awt.event.InputEvent;
import java.awt.event.KeyEvent;

/**
 * Class XMLJumpToElementDefinitionInDTDReportAction ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.4.0
 */
public class XMLJumpToElementOnLineNumberAction extends BothSidesAction {
	public XMLJumpToElementOnLineNumberAction(int sideIndex) {
		super(sideIndex, "Go to Line ...", MainImages.FORWARD_ICON);

		putValue(MNEMONIC_KEY, new Integer('L'));
		putValue(LOCAL_ACCELERATOR_KEY, KeyStroke.getKeyStroke(KeyEvent.VK_G, InputEvent.CTRL_MASK));
		putValue(SHORT_DESCRIPTION, "Go to element on line"); // when mouse over
		putValue(StatusBar.DESCRIPTION_HOVER, "Go to element on specified line number."); // when mouse over - statusbar
		putValue(StatusBar.DESCRIPTION_ACTIVE, "");  // when clicked
		enabled = false;
	}

	protected void actionPerformed() {
		mainFrame.statusBar.setActiveMessageFrom(this);
		thisSideController.aSwitchToViewer.setSelected(true);
		String input = JOptionPane.showInputDialog(mainFrame, "Line number: ", "Go to Element", JOptionPane.QUESTION_MESSAGE);
		if (input != null) {
			int lineNumber;
			try {
				lineNumber = Integer.parseInt(input);
				thisSide.xmlView.jumpToLineNumber(lineNumber);
			} catch (NumberFormatException e) {
				JOptionPane.showMessageDialog(mainFrame, "No valid integer!", "Bad line number", JOptionPane.ERROR_MESSAGE);
			}
		}
	}

}
