/*
 * Project: Asgaard - Guideline Markup Tool
 * Class: XMLRemoveNodeAction
 * User: Peter
 * Date: 26.05.2003
 * Time: 03:04:38
 */

package at.ac.tuwien.asgaard.delta.gui.actions.xhtml.xml;

import at.ac.tuwien.asgaard.delta.gui.MainController;
import at.ac.tuwien.asgaard.delta.gui.actions.xhtml.SimpleBothSidesAction;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.swing.StatusBar;

import javax.swing.*;
import java.awt.event.KeyEvent;

/**
 * Class XMLRemoveNodeAction ... todo
 */
public class XMLRemoveAttributeAction extends SimpleBothSidesAction {
	public XMLRemoveAttributeAction(int thisSideIndex) {
		super(thisSideIndex, "Remove Attribute", MainImages.XML_ATTR_REMOVE_ICON);

		putValue(MNEMONIC_KEY, new Integer('R'));
		putValue(LOCAL_ACCELERATOR_KEY, KeyStroke.getKeyStroke(KeyEvent.VK_DELETE, 0));
		putValue(StatusBar.TOOL_TIP, "Remove XML attribute"); // when mouse over - tool-tip
		putValue(StatusBar.DESCRIPTION_HOVER, "Remove selected XML attribute."); // when mouse over - statusbar
		putValue(StatusBar.DESCRIPTION_ACTIVE, "Removing attribute ...");  // when clicked
		enabled = false;
	}

	public void simpleActionPerformed() {
		thisSideController.aSwitchToViewer.setSelected(true);
		int row = thisSide.xmlAttributesTable.getSelectedRow();
		if (MainController.askBeforeRemoveXMLAttributes
				&& (JOptionPane.showConfirmDialog(mainFrame, "Do you really want to remove the attribute '" + thisSide.xmlAttributesTable.getValueAt(row, 0)
															 + "' from Element '" + thisSide.xmlAttributesTable.getElementName() + "'?", "Remove Attribute",
												  JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE)
				== JOptionPane.YES_OPTION))
			thisSide.xmlAttributesTable.removeAttribute(row);
	}
}
