/*
 * Copyright (c) 2004 Asgaard. All Rights Reserved.
 */
package at.ac.tuwien.asgaard.delta.gui.actions.xhtml.xml;

import at.ac.tuwien.asgaard.swing.selectable.CheckBoxAbstractAction;
import at.ac.tuwien.asgaard.swing.StatusBar;
import at.ac.tuwien.asgaard.delta.gui.MainController;
import at.ac.tuwien.asgaard.delta.gui.MainFrame;
import at.ac.tuwien.asgaard.delta.gui.DeltaSideController;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.delta.util.Preferences;

import javax.swing.event.ChangeEvent;
import javax.swing.*;
import java.awt.event.KeyEvent;
import java.awt.event.InputEvent;

public class XMLShowAutoXPathBarAction extends CheckBoxAbstractAction {
	private final int thisSideIndex;
	public XMLShowAutoXPathBarAction(int thisSideIndex) {
		super(MainController.stateProperties.getBoolean(Preferences.KEY_XML_SHOW_AUTOXPATH_BAR[thisSideIndex]));
		this.thisSideIndex = thisSideIndex;
		putValue(Action.SMALL_ICON, MainImages.TREE_VIEW_ICON);
		putValue(Action.MNEMONIC_KEY, new Integer('A'));
		putValue(LOCAL_ACCELERATOR_KEY, KeyStroke.getKeyStroke(KeyEvent.VK_A, InputEvent.CTRL_MASK | InputEvent.SHIFT_MASK));
		putValue(Action.NAME, "Show AutoXPath-Bar");
		putValue(StatusBar.TOOL_TIP, "Show/Hide AutoXPath-Bar -- WORK IN PROGRESS"); // when mouse over
		putValue(StatusBar.DESCRIPTION_HOVER, "Show/Hide AutoXPath-Bar -- WORK IN PROGRESS."); // when mouse over - statusbar
	}

	public void stateChanged(ChangeEvent evt) {
		DeltaSideController thisSideController = MainController.deltaSideController[thisSideIndex];
		MainFrame.DeltaSide thisSide = thisSideController.thisSide;
		if (selected) {
			thisSideController.aXMLShowTreePathBar.setSelected(false);
			thisSide.showAutoXPathBar(true);
			thisSide.getAutoXPathBar().refresh(MainController.deltaSideController[thisSideIndex].currentXMLLanguage.getAutoXPathDefs(), thisSide.xmlView.getSelectedNode());
		} else
			thisSide.showAutoXPathBar(false);
	}
}