/*
 * Copyright (c) 2004 Asgaard. All Rights Reserved.
 */
package at.ac.tuwien.asgaard.delta.gui.actions.xhtml.xml;

import at.ac.tuwien.asgaard.swing.selectable.CheckBoxAbstractAction;
import at.ac.tuwien.asgaard.swing.StatusBar;
import at.ac.tuwien.asgaard.delta.gui.MainController;
import at.ac.tuwien.asgaard.delta.gui.MainFrame;
import at.ac.tuwien.asgaard.delta.gui.DeltaSideController;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.delta.util.Preferences;

import javax.swing.event.ChangeEvent;
import javax.swing.*;
import java.awt.event.KeyEvent;
import java.awt.event.InputEvent;

public class XMLShowTreePathBarAction extends CheckBoxAbstractAction {
	private final int thisSideIndex;
	public XMLShowTreePathBarAction(int thisSideIndex) {
		super(MainController.stateProperties.getBoolean(Preferences.KEY_XML_SHOW_TREEPATH_BAR[thisSideIndex]));
		this.thisSideIndex = thisSideIndex;
		putValue(Action.SMALL_ICON, MainImages.TREE_VIEW_ICON);
		putValue(Action.MNEMONIC_KEY, new Integer('T'));
		putValue(LOCAL_ACCELERATOR_KEY, KeyStroke.getKeyStroke(KeyEvent.VK_T, InputEvent.CTRL_MASK | InputEvent.SHIFT_MASK));
		putValue(Action.NAME, "Show TreePath-Bar");
		putValue(StatusBar.TOOL_TIP, "Show/Hide TreePath-Bar"); // when mouse over
		putValue(StatusBar.DESCRIPTION_HOVER, "Show/Hide TreePath-Bar."); // when mouse over - statusbar
	}

	public void stateChanged(ChangeEvent evt) {
		DeltaSideController thisSideController = MainController.deltaSideController[thisSideIndex];
		MainFrame.DeltaSide thisSide = thisSideController.thisSide;
		if (selected) {
			thisSideController.aXMLShowAutoXPathBar.setSelected(false);
			thisSide.showTreePathBar(true);
			thisSide.getTreePathBar().setTreePath(thisSide.xmlView.getSelectedTreeNode().getTreePath());
		} else
			thisSide.showTreePathBar(false);
	}
}