package at.ac.tuwien.asgaard.delta.gui.actions.xhtml.xml;

import at.ac.tuwien.asgaard.swing.selectable.CheckBoxAbstractAction;
import at.ac.tuwien.asgaard.swing.StatusBar;
import at.ac.tuwien.asgaard.delta.gui.MainController;
import at.ac.tuwien.asgaard.delta.gui.MainFrame;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.delta.util.Preferences;

import javax.swing.event.ChangeEvent;
import javax.swing.*;
import java.awt.event.KeyEvent;
import java.awt.event.InputEvent;

public class XMLShowXPathBarAction extends CheckBoxAbstractAction {
	private final int thisSideIndex;
	public XMLShowXPathBarAction(int thisSideIndex) {
		super(MainController.stateProperties.getBoolean(Preferences.KEY_XML_SHOW_XPATH_BAR[thisSideIndex]));
		this.thisSideIndex = thisSideIndex;
		putValue(Action.SMALL_ICON, MainImages.XML_ICON);
		putValue(Action.MNEMONIC_KEY, new Integer('X'));
		putValue(LOCAL_ACCELERATOR_KEY, KeyStroke.getKeyStroke(KeyEvent.VK_X, InputEvent.CTRL_MASK | InputEvent.SHIFT_MASK)); 
		putValue(Action.NAME, "Show XPath-Bar"); 
		putValue(StatusBar.TOOL_TIP, "Show/Hide XPath-Bar"); // when mouse over
		putValue(StatusBar.DESCRIPTION_HOVER, "Show/Hide XPath-Bar."); // when mouse over - statusbar
	}

	public void stateChanged(ChangeEvent evt) {
		MainFrame.DeltaSide thisSide = MainController.deltaSides[thisSideIndex];
		thisSide.showXPathBar(selected);
		if (selected)
			thisSide.setXPathText(thisSide.xmlView.getSelectedTreeNode().getXPath());
	}
}
