/**
 * Project: DELTA - Guideline Markup Tool / Version: 2.7.3.#452
 * Author: Peter Votruba
 * Date: 28.10.2003
 * Time: 17:19:34
 */
package at.ac.tuwien.asgaard.delta.gui.actions.xhtml.xml;

import at.ac.tuwien.asgaard.delta.gui.actions.xhtml.SimpleBothSidesAction;
import at.ac.tuwien.asgaard.delta.gui.misc.DeltaFileChooser;
import at.ac.tuwien.asgaard.delta.gui.misc.XSLTransformPreviewDialog;
import at.ac.tuwien.asgaard.delta.gui.misc.images.MiscImages;
import at.ac.tuwien.asgaard.swing.StatusBar;
import at.ac.tuwien.asgaard.util.xml.XMLUtils;

import java.io.File;

import javax.swing.*;
import javax.xml.transform.Transformer;
import javax.xml.transform.dom.DOMResult;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamSource;

/**
 * Class XMLTransformSubtreeAction ... todo
 * 
 * @author Peter Votruba
 * @version 2.7.3.#452
 * @since JDK 1.4
 */
public class XMLTransformSubtreeAction extends SimpleBothSidesAction {
	public XMLTransformSubtreeAction(int thisSideIndex) {
		super(thisSideIndex, "XSL Transform", MiscImages.XSL_FILE_ICON);
		putValue(MNEMONIC_KEY, new Integer('X'));
		putValue(StatusBar.TOOL_TIP, "Transform current XML node -- WORK IN PROGRESS"); // when mouse over
		putValue(StatusBar.DESCRIPTION_HOVER, "Transform current XML node and insert result into other side. -- WORK IN PROGRESS"); // when mouse over - statusbar
		enabled = false;
	}
	
	// keep disabled since it is not finished yet
	public void setEnabled(boolean newValue) { }

	private JFileChooser jFileChooser;
	private XSLTransformPreviewDialog dialog;
	public void simpleActionPerformed() {
		if (jFileChooser == null) {
			jFileChooser = new DeltaFileChooser("Select XSL-File ...");
			jFileChooser.setFileFilter(DeltaFileChooser.XSL_FILE_FILTER);
		}
		if (jFileChooser.showOpenDialog(mainFrame) == JFileChooser.APPROVE_OPTION) {
			File xslFile = jFileChooser.getSelectedFile();
			try {
				Transformer transformer = XMLUtils.getTransformerFactory().newTransformer(new StreamSource(xslFile));
				DOMResult result = new DOMResult();
				transformer.transform(new DOMSource(thisSide.xmlView.getSelectedTreeNode().getXMLNode()), result);
				// todo
				if (dialog == null) dialog = new XSLTransformPreviewDialog(mainFrame);
				dialog.setRootNode(result.getNode());
				if (dialog.showDialog())
					System.out.println("insert");
			} catch (Exception exc) {
				exc.printStackTrace();
				JOptionPane.showMessageDialog(mainFrame,
											  "Couldn't transform using XSL-File \"" + xslFile.getAbsolutePath() + "\":\n\n" + exc.getMessage(),
											  "Transform Error", JOptionPane.ERROR_MESSAGE);
			}
		}
	}
}
