/*
 * Project: Asgaard - Guideline Markup Tool
 * Class: XHTMLReloadFileAction
 * User: Peter
 * Date: 26.05.2003
 * Time: 03:26:08
 */

package at.ac.tuwien.asgaard.delta.gui.actions.xhtml.xml;

import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.delta.gui.actions.xhtml.BothSidesAction;
import at.ac.tuwien.asgaard.delta.util.Preferences;
import at.ac.tuwien.asgaard.swing.StatusBar;

import javax.swing.*;
import java.awt.event.*;
import java.util.List;

/**
 * Class XHTMLReloadFileAction ... todo
 */
public class XMLValidateSubTreeAction extends BothSidesAction {
	public XMLValidateSubTreeAction(int thisSideIndex) {
		super(thisSideIndex, "Validate", MainImages.VALIDATE_ICON);

		putValue(MNEMONIC_KEY, new Integer('V'));
		putValue(LOCAL_ACCELERATOR_KEY, KeyStroke.getKeyStroke(KeyEvent.VK_F4, 0));
		putValue(StatusBar.TOOL_TIP, "Validate sub-tree"); // when mouse over
		putValue(StatusBar.DESCRIPTION_HOVER, "Validate current sub-tree against DTD and mark all invalid nodes."); // when mouse over - statusbar
        putValue(StatusBar.DESCRIPTION_ACTIVE, "Validating current XML sub-tree ...");  // when clicked
		enabled = false;
	}

	protected void actionPerformed() {
		// validate only current subtree
        List invalidNodes = thisSideController.dtdHelper.getAllInvalidNodes(thisSide.xmlView.getSelectedTreeNode().getXMLNode()); //thisSide.xmlView.getDocNode());
        if (invalidNodes.isEmpty())
            JOptionPane.showMessageDialog(mainFrame, "Sub-Tree has been successfully validated against DTD.", "Validation", JOptionPane.INFORMATION_MESSAGE);
        else {
            thisSide.xmlView.highlightTreeNodes(thisSide.xmlView.convertXMLNodeListToTreeNodeList(invalidNodes),
					preferences.getColor(Preferences.KEY_COLOR_XML_INVALID_NODES_ON_VALIDATE));
            JOptionPane.showMessageDialog(mainFrame, "Sub-Tree is NOT valid according to DTD!\n\nInvalid Nodes - either due to missing or bad attributes\nor due to content model violation - are highlighted.",
                    "Validation", JOptionPane.ERROR_MESSAGE);
        }
	}
}
