/*
 * Project: DELTA - Guideline Markup Tool / Version: 2.7.3.#452
 * Author: Peter Votruba
 * Date: 19.05.2003
 * Time: 16:10:30
 */
package at.ac.tuwien.asgaard.delta.gui.actions.xhtml.xml;

import at.ac.tuwien.asgaard.delta.gui.MainController;
import at.ac.tuwien.asgaard.delta.gui.MainFrame;
import at.ac.tuwien.asgaard.delta.gui.actions.xhtml.BothSidesAction;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.swing.StatusBar;
import at.ac.tuwien.asgaard.util.xml.XMLUtils;

import java.awt.event.KeyEvent;
import java.net.URL;

import javax.swing.*;

/**
 * Class MacroSwitchToTextViewAction ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.3.0
 */
public class XMLViewShowFormattedDTDSourceAction extends BothSidesAction {
	public XMLViewShowFormattedDTDSourceAction(int thisSideIndex) {
		super(thisSideIndex, "DTD - Show Formatted Source", MainImages.HTML_VIEW_ICON);

		putValue(MNEMONIC_KEY, new Integer('T'));
		putValue(LOCAL_ACCELERATOR_KEY, KeyStroke.getKeyStroke(KeyEvent.VK_F9, 0));
		putValue(SHORT_DESCRIPTION, "Show formatted DTD source"); // when mouse over
		putValue(StatusBar.DESCRIPTION_HOVER, "Show syntax-highlighted DTD source."); // when mouse over - statusbar
		putValue(StatusBar.DESCRIPTION_ACTIVE, "Showing syntax-highlighted DTD source ...");  // when clicked
		enabled = false;
	}
	protected void actionPerformed() {
		if (!thisSideController.isTypeXML()) return;
		final MainFrame mainFrame = MainController.mainFrame;
		mainFrame.statusBar.setActiveMessageFrom(this);
	// thisSide.switchToSimpleHTMLView();
		thisSideController.aSwitchToHTMLOutput.setEnabled(true);
		thisSideController.aSwitchToHTMLOutput.setSelected(true);
		thisSideController.aGoBack.setEnabled(false);
		thisSideController.aGoForward.setEnabled(false);
	//	thisSide.htmlOutput.setBackground(GlobalConstants.DEFAULT_BACKGROUND);
		thisSide.htmlOutput.setText("Showing syntax-highlighted source (HTML) of large or remote DTD files may take a while ...");
		new at.ac.tuwien.asgaard.swing.SwingWorker() {
{
ClassLoader loader = XMLViewShowFormattedDTDSourceAction.this.getClass().getClassLoader();
Thread.currentThread().setContextClassLoader(loader);
}
			public Object construct() {
				URL dtdurl = thisSide.xmlView.getDTDURL();
				if (dtdurl == null) return "No or bad DTD entry in DOCTYPE statement!";
				return XMLUtils.transformDTD2Src(dtdurl);
			}
			public void finished() {
				thisSide.htmlOutput.setText((String)get());
				thisSide.htmlOutput.setCaretPosition(0);
				thisSideController.sourceViewNeedsUpdateDTDSource = false;
				thisSideController.sourceViewNeedsUpdateXHTMLSource = thisSideController.sourceViewNeedsUpdateDTDReport = true;
				mainFrame.statusBar.unsetActiveMessageFrom(XMLViewShowFormattedDTDSourceAction.this);
			}
		}.start();
	}
}
