/*
 * Project: Asgaard - Guideline Markup Tool
 * Class: XHTMLReloadFileAction
 * User: Peter
 * Date: 26.05.2003
 * Time: 03:26:08
 */

package at.ac.tuwien.asgaard.delta.gui.actions.xhtml.xml.view;

import at.ac.tuwien.asgaard.delta.gui.misc.XMLLanguageDialog;
import at.ac.tuwien.asgaard.delta.gui.actions.xhtml.SimpleBothSidesAction;
import at.ac.tuwien.asgaard.delta.xmlBeans.xmlLanguage.FoldingDef;
import at.ac.tuwien.asgaard.swing.StatusBar;
import at.ac.tuwien.asgaard.util.FileUtils;
import at.ac.tuwien.asgaard.util.xml.XMLUtils;

import javax.swing.*;
import java.net.URL;
import java.util.List;

/**
 * Class XMLTreeFoldingApplyPredefined ... todo
 */
public class XMLTreeFoldingApplyPredefined extends SimpleBothSidesAction {
	private final FoldingDef foldingDef;
	public XMLTreeFoldingApplyPredefined(int thisSideIndex, FoldingDef foldingDef, int nr) {
		super(thisSideIndex);

		this.foldingDef = foldingDef;
		String label = foldingDef.getLabel();

		putValue(NAME, ""+(nr + 1) + ' ' + label);
		putValue(StatusBar.DESCRIPTION_ACTIVE, "Applying Folding definition ...");  // when clicked

		Icon icon = XMLLanguageDialog.DEFAULT_FOLDING_ICON;
		URL url = FileUtils.toURL(foldingDef.getIconFileName(), thisSideController.currentXMLLanguage.getFile());
		if (url != null) {
			icon = new ImageIcon(url);
			if (icon.getIconWidth() < 10) icon = XMLLanguageDialog.DEFAULT_FOLDING_ICON;
		}
		foldingDef.setIcon(icon);
		putValue(Action.SMALL_ICON, icon);
		putValue(Action.MNEMONIC_KEY, new Integer('1' + nr));
		String statusBarText = "Apply Folding definition \"" + label + '\"';
		putValue(StatusBar.DESCRIPTION_HOVER, statusBarText); // when mouse over - statusbar
		String description = foldingDef.getDescription();
		if ((description == null) || (description.trim().length() == 0))
			putValue(Action.SHORT_DESCRIPTION, statusBarText);
		else
			putValue(Action.SHORT_DESCRIPTION, "<html>" +statusBarText + ":<br>&nbsp;&nbsp;" + description); // when mouse over - tool-tip
	}

	protected void simpleActionPerformed() {
		thisSideController.aSwitchToViewer.setSelected(true);
		String xPathExpression = foldingDef.getXPathExpr();
		try {
			List domNodeResultList = XMLUtils.evaluateXPath(xPathExpression, thisSide.xmlView.getSelectedTreeNode().getXMLNode()); //thisSide.xmlView.getDocumentNode()); // 
			List treeNodeResultList = thisSide.xmlView.convertXMLNodeListToTreeNodeList(domNodeResultList);
			if (treeNodeResultList.isEmpty())
				if (!domNodeResultList.isEmpty())
					JOptionPane.showMessageDialog(mainFrame, "Matching nodes for XPath-Expression \n\"" + xPathExpression
															 + "\" are currently not displayd due to active filters",
												  "No visible result", JOptionPane.INFORMATION_MESSAGE);
				else
					JOptionPane.showMessageDialog(mainFrame, "No matching nodes found for XPath-Expression \n\"" + xPathExpression + "\"",
												  "No result", JOptionPane.INFORMATION_MESSAGE);
			else
				if (foldingDef.getType().equalsIgnoreCase("expand"))
					thisSide.xmlView.expandTreeNodes(treeNodeResultList);
				else
					thisSide.xmlView.collapseTreeNodes(treeNodeResultList);
		} catch (Exception exc) {
			JOptionPane.showMessageDialog(mainFrame,
										  "Couldn't evaluate XPath-Expression:\n\n" + xPathExpression + "\n\n" + exc.getMessage(),
										  "XPath Error", JOptionPane.ERROR_MESSAGE);
		}
	}
}
