/*
 * Project: Asgaard - Guideline Markup Tool
 * Class: XMLTreeHighlightXPath
 * User: Peter
 * Date: 18.06.2003
 * Time: 16:51:53
 */

package at.ac.tuwien.asgaard.delta.gui.actions.xhtml.xml.view;

import at.ac.tuwien.asgaard.delta.gui.actions.xhtml.xml.XMLEvaluateXPathExpressionAction;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.delta.gui.misc.XMLLanguageDialog;
import at.ac.tuwien.asgaard.delta.xmlBeans.xmlLanguage.HighlightDef;
import at.ac.tuwien.asgaard.swing.StatusBar;
import at.ac.tuwien.asgaard.util.FileUtils;

import javax.swing.*;
import java.net.URL;

/**
 * Class XMLTreeHighlightXPath ... todo
 */
public class XMLTreeHighlightApplyPredefined extends XMLEvaluateXPathExpressionAction {
	private final HighlightDef highlightDef;

	public XMLTreeHighlightApplyPredefined(int thisSideIndex, HighlightDef highlightDef, int nr) {
		super(thisSideIndex, "Highlight result of XPath ...", MainImages.EDIT_ICON);

		this.highlightDef = highlightDef;

		String label = highlightDef.getLabel();

		putValue(NAME, ""+(nr + 1) + ' ' + label);

		Icon icon = XMLLanguageDialog.DEFAULT_HIGHLIGHT_ICON;
		URL url = FileUtils.toURL(highlightDef.getIconFileName(), thisSideController.currentXMLLanguage.getFile());
		if (url != null) {
			icon = new ImageIcon(url);
			if (icon.getIconWidth() < 10) icon = XMLLanguageDialog.DEFAULT_HIGHLIGHT_ICON; 
		}
		highlightDef.setIcon(icon);
		putValue(Action.SMALL_ICON, icon);
		putValue(Action.MNEMONIC_KEY, new Integer('1' + nr));
		String statusBarText = "Apply Highlight definition \"" + label + '\"';
		putValue(StatusBar.DESCRIPTION_HOVER, statusBarText); // when mouse over - statusbar
		String description = highlightDef.getDescription();
        if ((description == null) || (description.trim().length() == 0))
			putValue(Action.SHORT_DESCRIPTION, statusBarText);
		else
			putValue(Action.SHORT_DESCRIPTION, "<html>"+statusBarText + ":<br>&nbsp;&nbsp;" + description); // when mouse over - tool-tip

		putValue(StatusBar.DESCRIPTION_ACTIVE, "Highlighting result of predefined XPath-Expression...");  // when clicked
	}
	protected void simpleActionPerformed() {
		thisSideController.aSwitchToViewer.setSelected(true);
		if (!evaluateAndVisualizeXPathExpression(highlightDef.getXPathExpr()))
			thisSide.xmlView.requestFocusInWindow();
	}
}
