/*
 * Project: Asgaard - Guideline Markup Tool
 * Class: XMLTreeHighlightXPath
 * User: Peter
 * Date: 18.06.2003
 * Time: 16:51:53
 */

package at.ac.tuwien.asgaard.delta.gui.actions.xhtml.xml.view;

import at.ac.tuwien.asgaard.delta.gui.actions.xhtml.xml.XMLEvaluateXPathExpressionAction;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.delta.gui.MainController;
import at.ac.tuwien.asgaard.delta.gui.misc.XPathExpressionEditDialog;
import at.ac.tuwien.asgaard.delta.gui.xml.XMLTreeNode;
import at.ac.tuwien.asgaard.swing.StatusBar;
import at.ac.tuwien.asgaard.swing.TextEditDialog;
import at.ac.tuwien.asgaard.swing.autoComplete.AutoCompleteComboBoxEditDialog;

import javax.swing.*;
import java.awt.event.KeyEvent;
import java.awt.event.InputEvent;
import java.awt.Component;

/**
 * Class XMLTreeHighlightXPath ... todo
 */
public class XMLTreeHighlightXPath extends XMLEvaluateXPathExpressionAction {
    private AutoCompleteComboBoxEditDialog dialog;
	private XPathExpressionEditDialog xPathExpressionEditDialog;

	public XMLTreeHighlightXPath(int thisSideIndex) {
		super(thisSideIndex, "Highlight result of XPath...", MainImages.HIGHLIGHT_ICON);
        putValue(MNEMONIC_KEY, new Integer('E'));
		putValue(LOCAL_ACCELERATOR_KEY, KeyStroke.getKeyStroke(KeyEvent.VK_P, InputEvent.SHIFT_MASK | InputEvent.ALT_MASK | InputEvent.CTRL_MASK));
        putValue(StatusBar.TOOL_TIP, "Highlight result of XPath-Expression"); // when mouse over
        putValue(StatusBar.DESCRIPTION_HOVER, "Evaluate XPath-Expression and highlight resulting tree nodes."); // when mouse over - statusbar
		putValue(StatusBar.DESCRIPTION_ACTIVE, "Highlighting result of XPath-Expression...");  // when clicked
		enabled = false;
	}

	protected void simpleActionPerformed() {
		thisSideController.aSwitchToViewer.setSelected(true);
        
        if (dialog == null) {
			dialog = new AutoCompleteComboBoxEditDialog(MainController.mainFrame, "Highlight Treenodes...",
														"XPath-Expression: ", MainController.getSharedXPathList()) {
				protected TextEditDialog getTextEditDialog(Component parentComponent, String title) {
					if (xPathExpressionEditDialog == null)
						xPathExpressionEditDialog = new XPathExpressionEditDialog(parentComponent, null);
					xPathExpressionEditDialog.init(thisSideController.dtdHelper);
					return xPathExpressionEditDialog;
				}
			};
			dialog.setIgnoreCase(false);
		}
		XMLTreeNode selectedTreeNode = thisSide.xmlView.getSelectedTreeNode();
		String xPathExpression = selectedTreeNode.getSimpleXPath();
        if (xPathExpression == null) xPathExpression = "/"; // DOCUMENT_NODE and DOCUMENT_TYPE_NODE nodes return null on getSimpleXPath()
		xPathExpression = dialog.showEditDialog(xPathExpression);
		if (xPathExpression != null) {
			xPathExpression = xPathExpression.trim();
			if (xPathExpression.equals(""))
                thisSide.xmlView.removeHighlights();
            else {
				boolean result = evaluateAndVisualizeXPathExpression(xPathExpression);
				if (!result) thisSide.xmlView.requestFocusInWindow();
			}
		}
	}
}
