/*
 * Asgaard-Project (Peter Votruba), http://www.asgaard.tuwien.ac.at/
 * Vienna University of Technology (Austria)
 * Institute of Software Technology and Interactive Systems
 * Information & Software Engineering Group
 * --------------------------------------------------------------------
 * in cooperation with the Protocure-Project, http://www.protocure.org/
 */
package at.ac.tuwien.asgaard.delta.gui.actions.xhtml.xml.view;

import at.ac.tuwien.asgaard.delta.gui.actions.xhtml.BothSidesAction;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.swing.StatusBar;

import javax.swing.*;
import java.awt.event.*;

/**
 * Class XMLDELTALinksVisualizationUpAction ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.3.0
 */
public class XMLTreeSetRootTreeNodeAction extends BothSidesAction {
	public XMLTreeSetRootTreeNodeAction(int thisSideIndex) {
		super(thisSideIndex, "Set Root-Treenode", MainImages.TREE_VIEW_ICON);
		putValue(ACCELERATOR_KEY, KeyStroke.getKeyStroke(KeyEvent.VK_R, InputEvent.SHIFT_MASK | InputEvent.ALT_MASK));
		putValue(MNEMONIC_KEY, new Integer('S'));
		putValue(StatusBar.TOOL_TIP, "Set new Root-Treenode"); // when mouse over
		putValue(StatusBar.DESCRIPTION_HOVER, "Set current Treenode as new Root-Treenode."); // when mouse over - statusbar
		enabled = false;
	}

	protected void actionPerformed() {
		thisSide.xmlView.setCurrentNodeAsRootTreeNode();
		thisSideController.aXMLShowTreePathBar.setSelected(true);
	}
}
