/*
 * Project: DELTA - Guideline Markup Tool / Version: 2.7.3.#452
 * Author: Peter Votruba
 * Date: 22.05.2003
 * Time: 14:52:05
 */
package at.ac.tuwien.asgaard.delta.gui.actions.xhtml.xml.view;

import at.ac.tuwien.asgaard.delta.gui.MainController;
import at.ac.tuwien.asgaard.delta.gui.xml.images.XMLImages;
import at.ac.tuwien.asgaard.delta.util.Preferences;
import at.ac.tuwien.asgaard.swing.StatusBar;
import at.ac.tuwien.asgaard.swing.selectable.CheckBoxAbstractAction;

import javax.swing.Action;
import javax.swing.event.ChangeEvent;

/**
 * Class XMLDELTALinksVisualizationUpAction ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.3.0
 */
public class XMLTreeShowDocumentNode extends CheckBoxAbstractAction {
	public XMLTreeShowDocumentNode(int thisSide) {
		super(MainController.preferences.getBoolean(Preferences.KEY_XML_FILTER_ROOT_ELEMENT[thisSide]));
		putValue(Action.NAME, "Show document node");
		putValue(Action.SMALL_ICON, XMLImages.DOC_NODE_ICON);
		putValue(Action.MNEMONIC_KEY, new Integer('D'));
		putValue(StatusBar.TOOL_TIP, "Show/Hide document node"); // when mouse over
		putValue(StatusBar.DESCRIPTION_HOVER, "Show the document node."); // when mouse over - statusbar
		enabled = false;
	}

	public void stateChanged(ChangeEvent evt) {
		MainController.getActiveSide().xmlView.setShowDocumentNode(selected);
		// todo correct history
	}
}
