/*
 * Project: DELTA - Guideline Markup Tool / Version: 2.7.3.#452
 * Author: Peter Votruba
 * Date: 22.05.2003
 * Time: 14:52:05
 */
package at.ac.tuwien.asgaard.delta.gui.actions.xhtml.xml.view;

import at.ac.tuwien.asgaard.delta.gui.MainController;
import at.ac.tuwien.asgaard.delta.gui.DeltaSideController;
import at.ac.tuwien.asgaard.delta.gui.xml.images.XMLImages;
import at.ac.tuwien.asgaard.delta.util.Preferences;
import at.ac.tuwien.asgaard.swing.StatusBar;
import at.ac.tuwien.asgaard.swing.selectable.CheckBoxAbstractAction;

import javax.swing.Action;
import javax.swing.event.ChangeEvent;

/**
 * Class XMLDELTALinksVisualizationUpAction ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.3.0
 */
public class XMLTreeShowTextNodes extends CheckBoxAbstractAction {
	public XMLTreeShowTextNodes(int thisSide) {
		super(MainController.preferences.getBoolean(Preferences.KEY_XML_FILTER_TEXT_NODES[thisSide]));
		putValue(Action.SMALL_ICON, XMLImages.TEXT_NODE_ICON);
		putValue(Action.MNEMONIC_KEY, new Integer('T'));
		putValue(Action.NAME, "Show Text nodes");
		putValue(StatusBar.TOOL_TIP, "Show/Hide Text nodes"); // when mouse over
		putValue(StatusBar.DESCRIPTION_HOVER, "Show/Hide Text nodes."); // when mouse over - statusbar
		putValue(StatusBar.DESCRIPTION_ACTIVE, "Showing/Hiding Text nodes ...");  // when clicked
		enabled = false;
	}

	public void stateChanged(ChangeEvent evt) {
		DeltaSideController activeSideController = MainController.getActiveSideController();
		activeSideController.thisSide.xmlView.setShowTextNodes(selected);
		activeSideController.thisSide.visualizeFilterState(true, !selected);
		activeSideController.aGoBack.setEnabled(false);
		activeSideController.aGoForward.setEnabled(false);
	}
}
