/*
 * Project: DELTA - Guideline Markup Tool / Version: 2.7.3.#452
 * Author: Peter Votruba
 * Date: 26.06.2003
 * Time: 12:25:21
 */
package at.ac.tuwien.asgaard.delta.gui.actions.xhtml.xml.view;

import at.ac.tuwien.asgaard.delta.gui.actions.xhtml.BothSidesAction;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;
import at.ac.tuwien.asgaard.delta.gui.misc.DeltaFileChooser;
import at.ac.tuwien.asgaard.swing.StatusBar;

import javax.swing.*;
import java.io.File;
import java.io.IOException;

/**
 * Class XMLTreeSummarizeApplyXSL provides ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.3.0
 */
public class XMLTreeSummarizeApplyXSL extends BothSidesAction {

	public XMLTreeSummarizeApplyXSL(int thisSideIndex) {
        super(thisSideIndex, "Apply XSL-File ...", MainImages.EDIT_ICON);
        putValue(MNEMONIC_KEY, new Integer('A'));
        putValue(StatusBar.TOOL_TIP, "Apply summarize XSL-File"); // when mouse over
        putValue(StatusBar.DESCRIPTION_HOVER, "Apply summarize XSL-File."); // when mouse over - statusbar
        enabled = false;
    }

    private JFileChooser jFileChooser;
	protected void actionPerformed() {
        if (jFileChooser == null) {
            jFileChooser = new DeltaFileChooser("Select XSL-File ...");
            jFileChooser.setFileFilter(DeltaFileChooser.XSL_FILE_FILTER);
        }
        if (jFileChooser.showOpenDialog(mainFrame) == JFileChooser.APPROVE_OPTION) {
            File xslFile = jFileChooser.getSelectedFile();
            try {
                thisSide.xmlView.applySummarizeXSLFile(xslFile);
				thisSideController.summarizeDefListButtonGroup.unSelect();
				thisSideController.summarizeDefListPopupButtonGroup.unSelect();
            } catch (IOException exc) {
                exc.printStackTrace();
                JOptionPane.showMessageDialog(mainFrame,
                        "Couldn't load XSL-File \"" + xslFile.getAbsolutePath() + "\":\n\n" + exc.getMessage(),
                        "IO Error", JOptionPane.ERROR_MESSAGE);
            }
        }
    }
}
