package at.ac.tuwien.asgaard.delta.gui.misc;

import javax.swing.event.HyperlinkEvent;
import java.util.SortedSet;
import java.awt.*;

public final class DeltaHyperlinkEvent extends HyperlinkEvent {
	// don't need getter methods in this event class - public final fields are enough
	public final int deltaLinkID;
	public final int gmtLinkPrefix;
	public final SortedSet<Integer> deltaLinkIDs;
	public final Point clickedLocation;

	public DeltaHyperlinkEvent(Object source,
							 HyperlinkEvent.EventType type,
							 SortedSet<Integer> deltaLinkIDs, Point clickedLocation) {
		super(source, type, null);
		this.deltaLinkIDs = deltaLinkIDs;
		this.clickedLocation = clickedLocation;
		deltaLinkID = -1;
		this.gmtLinkPrefix = 0;
	}
	public DeltaHyperlinkEvent(Object source,
							 HyperlinkEvent.EventType type,
							 int deltaLinkID) {
		super(source, type, null);
		this.deltaLinkID = deltaLinkID;
		deltaLinkIDs = null;
		clickedLocation = null;
		this.gmtLinkPrefix = 0;
	}
	public DeltaHyperlinkEvent(Object source,
							 HyperlinkEvent.EventType type,
							 int deltaLinkID, int deltaLinkPrefix) {
		super(source, type, null);
		this.deltaLinkID = deltaLinkID;
		this.gmtLinkPrefix = deltaLinkPrefix;
		deltaLinkIDs = null;
		clickedLocation = null;
	}

	public String toString() {
		return ((deltaLinkID == -1) ? ("deltaLinkIDs: " + deltaLinkIDs) : ("deltaLinkID: " + deltaLinkID)) + " type: " + getEventType() + " desc: " + this.getDescription();
	}
}
