/*
 * Project: DELTA - Guideline Markup Tool / Version: 2.7.3.#452
 * Author: Peter Votruba
 * Date: 28.07.2003
 * Time: 10:52:16
 */
package at.ac.tuwien.asgaard.delta.gui.misc;

import at.ac.tuwien.asgaard.swing.AbstractInputDialog;
import info.clearthought.layout.TableLayout;
import info.clearthought.layout.TableLayoutConstants;
import info.clearthought.layout.TableLayoutConstraints;

import javax.swing.*;
import java.awt.*;

/**
 * Class FindAllDialog ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 */
public class FindAllDialog extends AbstractInputDialog {
	private JTextField keywordTextField;

	public FindAllDialog(Frame parent) {
		super(parent, "Find All", false, true, 500, 275, 200, 150, 0, 0);

		helpAction.putValue(HELP_LINK_KEY, "FindAllDialog");
	}

	protected Component createMainComponent() {
		JPanel mainPanel = new JPanel(new TableLayout(new double[][] {{TableLayoutConstants.PREFERRED, TableLayoutConstants.FILL}, {TableLayoutConstants.PREFERRED, TableLayoutConstants.PREFERRED, TableLayoutConstants.PREFERRED}}));
		JLabel label = new JLabel("Keyword: ");
		label.setDisplayedMnemonic('K');
		keywordTextField = new JTextField();
		label.setLabelFor(keywordTextField);
		mainPanel.add(label, new TableLayoutConstraints());
		mainPanel.add(keywordTextField, new TableLayoutConstraints(1, 0));
		mainPanel.add(new JLabel(" -- WORK IN PROGRESS -- "), new TableLayoutConstraints(0, 2));
		return mainPanel;
	}

	protected boolean onOK() {
		return !keywordTextField.getText().trim().equals("");
	}

	public String getKeyword() {
		return keywordTextField.getText().trim();
	}
}
