/*
 * Project: DELTA - Guideline Markup Tool / Version: 2.7.3.#452
 * Author: Peter Votruba
 * Date: 03.09.2003
 * Time: 12:17:42
 */
package at.ac.tuwien.asgaard.delta.gui.misc.undo;

import at.ac.tuwien.asgaard.delta.gui.*;

import javax.swing.undo.AbstractUndoableEdit;
import javax.swing.undo.CannotUndoException;
import javax.swing.undo.CannotRedoException;

/**
 * Class SideAbstractUndoableEdit ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.3.0
 */
public abstract class SideAbstractUndoableEdit extends AbstractUndoableEdit implements SideUndoableEdit {
    protected int originSideIndex;
	protected final boolean affectsBothSides;
	protected String undoPresentationName = "UNDO", redoPresentationName = "REDO"; // to overwrite in subclass

	protected SideAbstractUndoableEdit(boolean affectsBothSides) {
		this.affectsBothSides = affectsBothSides;
	}

	public int getOriginSideIndex() {
        return originSideIndex;
    }

    public void setOriginSideIndex(int sideIndex) {
        this.originSideIndex = sideIndex;
    }

	public boolean affectsBothSides() {
		return affectsBothSides;
	}

	public boolean sideAffected(int sideIndex) {
		return affectsBothSides || (this.originSideIndex == sideIndex);
	}

	public void undo() throws CannotUndoException {
        MainController.setActiveSideIndex(originSideIndex);
        super.undo();
    }

    public void redo() throws CannotRedoException {
        MainController.setActiveSideIndex(originSideIndex);
        super.redo();
    }

	public String getUndoPresentationName() {
		return undoPresentationName +  " (" + GUIConstants.SIDE_NAMES[originSideIndex] + ")";
	}

	public String getRedoPresentationName() {
		return redoPresentationName + " (" + GUIConstants.SIDE_NAMES[originSideIndex] + ")";
	}
}
