package at.ac.tuwien.asgaard.delta.gui.xml;

import javax.swing.*;
import java.util.Map;
import java.util.HashMap;
import java.io.File;

/**
 * Created by IntelliJ IDEA.
 * User: peter
 * Date: 23.06.2003
 * Time: 13:19:59
 * To change this template use Options | File Templates.
 */
public class ElementIconMap {
    private Map map;
    private File iconBaseDir, currentIconDir;

    public ElementIconMap() {
        map = new HashMap();
    }

    public void setIconBaseDir(String baseDir) {
        if (baseDir == null) {
            currentIconDir = iconBaseDir = null;
            map.clear();
        } else {
            iconBaseDir = new File(baseDir, "icons");
            if (!iconBaseDir.exists()) iconBaseDir.mkdir();
            if (!iconBaseDir.equals(currentIconDir)) map.clear();
            currentIconDir = iconBaseDir;
        }
    }

    public File getIconBaseDir() { return iconBaseDir; }

    /*public void setIconSet(String iconSetName) {
        if (iconSetName == null) currentIconDir = iconBaseDir;
        else setIconSet(new File(iconBaseDir, iconSetName));
    }*/
    public void setIconSet(File iconSetDir) {
        if (iconSetDir == null) iconSetDir = iconBaseDir;
        if (!iconSetDir.equals(currentIconDir)) map.clear();
        currentIconDir = iconSetDir;
        if (!currentIconDir.exists()) currentIconDir.mkdir();
    }

    public Icon getIcon(String elementName, boolean expanded, boolean leaf) {
        if (currentIconDir == null) return null;
        ImageIcon icon = (ImageIcon) map.get(elementName);
        if (icon != null)
            return icon;
        File iconFile = new File(currentIconDir, elementName + ".gif");
        if (!iconFile.exists() || !iconFile.isFile() || !iconFile.canRead()) return null;
        icon = new ImageIcon(iconFile.getAbsolutePath());
        if (icon.getImage() == null) return null;
        map.put(elementName, icon);
        return icon;
    }
}
