package at.ac.tuwien.asgaard.delta.util;

import at.ac.tuwien.asgaard.delta.gui.html.images.HTMLImages;
import at.ac.tuwien.asgaard.delta.gui.images.MainImages;

import java.awt.*;

import javax.swing.border.*;

/**
 * Class GlobalObjects - todo javadoc.
 *
 * @author Peter Votruba
 * @version 2.5.3
 */
public class GlobalObjects {
	public static final Color DEFAULT_BACKGROUND = new Color(246, 246, 246); //UIManager.getColor("Label.background"); //new Color(200, 200, 200); //SystemColor.control; //
	public static final Color INACTIVE_SIDE_BACKGROUND = DEFAULT_BACKGROUND; // todo get from prefs
	public static final Cursor DELTA_LINK_CURSOR;
	public static final Cursor XML_LINK_ERROR_CURSOR;
	public static final Cursor LINK_ERROR_CURSOR;
	public static final Rectangle TOP_RECT = new Rectangle();
	public static final Point TOP_POINT = new Point();
	public static final Dimension ZERO_SIZE = new Dimension(0, 0);
	public static final Insets INSETS_ZERO = new Insets(0, 0, 0, 0);
	public static final Insets BUTTON_MARGIN = new Insets(2, 2, 2, 2);
	public static final Border EMPTY_BORDER_0 = new EmptyBorder(0, 0, 0, 0);
	public static final Border EMPTY_BORDER_2 = new EmptyBorder(2, 2, 2, 2);
	public static final Border EMPTY_BORDER_5 = new EmptyBorder(5, 5, 5, 5);
	public static final Color TRANSPARENT = new Color(0, 0, 0, 0);
	public static final int DEFAULT_FONT_SIZE = Integer.parseInt(System.getProperty("fontSize", "12"));
	public static final Font DEFAULT_FONT = new Font("Dialog", Font.PLAIN, DEFAULT_FONT_SIZE);
	public static final Font BOLD_FONT = DEFAULT_FONT.deriveFont(Font.BOLD);
	public static final Border CELLEDITOR_BORDER = new LineBorder(Color.DARK_GRAY);
	public static final Font PLAIN_FIXED_FONT = new Font("Monospaced", Font.PLAIN, DEFAULT_FONT_SIZE);
	public static final Font BOLD_FIXED_FONT = PLAIN_FIXED_FONT.deriveFont(Font.BOLD);
	public static final Font ITALIC_FIXED_FONT = PLAIN_FIXED_FONT.deriveFont(Font.ITALIC);
	public static final Font BOLD_ITALIC_FIXED_FONT = ITALIC_FIXED_FONT.deriveFont(Font.BOLD | Font.ITALIC);

	static {
		Dimension cursorSize = Toolkit.getDefaultToolkit().getBestCursorSize(32, 32);
		if ((cursorSize.width == 32) && (cursorSize.height == 32)) {   // we have only cursor images for 32x32
			DELTA_LINK_CURSOR = Toolkit.getDefaultToolkit().createCustomCursor(
					Toolkit.getDefaultToolkit().getImage(MainImages.class.getResource("cursorXMLLink.gif")), new Point(5, 0), "XML");
			XML_LINK_ERROR_CURSOR = Toolkit.getDefaultToolkit().createCustomCursor(
					Toolkit.getDefaultToolkit().getImage(MainImages.class.getResource("cursorXMLLinkError.gif")), new Point(5, 0),
					"XMLError");
			LINK_ERROR_CURSOR = Toolkit.getDefaultToolkit().createCustomCursor(HTMLImages.LINK_ERROR_CURSOR, new Point(5, 0), "LinkError");
		} else {  // some Linux'es have other cursor sizes
			System.out.println("System's cursor size (" + cursorSize + ") not compatible - use default cursors.");
			DELTA_LINK_CURSOR = Cursor.getPredefinedCursor(Cursor.HAND_CURSOR);
			XML_LINK_ERROR_CURSOR = Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR);
			LINK_ERROR_CURSOR = Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR);
		}
	}

	private GlobalObjects() { } // this class should not be instantiated
}
