/*
 * Project: GMT - Guideline Markup Tool / Version: 2.7.3.#452
 * Author: Peter Votruba
 * Date: 02.07.2003
 * Time: 16:33:58
 */
package at.ac.tuwien.asgaard.swing;

import javax.swing.*;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.*;

/**
 * Class ButtonPopupMenuHandler ... todo
 * reacts on left mouse button
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 */
public class ButtonPopupMenuHandler extends MouseAdapter {
	private final Component invoker;
	private final JPopupMenu popupMenu;

	public ButtonPopupMenuHandler(Component invoker, JPopupMenu popupMenu) {
		this.invoker = invoker;
		this.popupMenu = popupMenu;
	}
	public void mouseReleased(MouseEvent evt) {
		if (SwingUtilities.isLeftMouseButton(evt) &&  invoker.isEnabled())
			if (popupMenu.isVisible())
				popupMenu.setVisible(false);
			else {
				Point p = PopupMenuHandler.getSuitableLocation(evt.getPoint(), popupMenu.getPreferredSize(), invoker);
				popupMenu.show(invoker, p.x, p.y);
			}
	}
}
