/*
 * Project: GMT - Guideline Markup Tool / Version: 2.7.3.#452
 * User: peter
 * Date: 25.04.2003
 * Time: 16:14:41
 */
package at.ac.tuwien.asgaard.swing;

import javax.swing.*;
import javax.swing.event.EventListenerList;
import javax.swing.event.ChangeListener;
import java.util.ArrayList;
import java.awt.*;
import java.awt.event.ItemListener;
import java.awt.event.ItemEvent;

/**
 * Class RadioButtonsPanel ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.3.0
 */
public final class RadioButtonsPanel extends JPanel {
	private final ArrayList buttons;
	private final EventListenerList listenerList;
    private ButtonGroup buttonGroup;
	private int selected;

	public RadioButtonsPanel() {
		super(new FlowLayout(FlowLayout.RIGHT, 0, 0));
		buttons = new ArrayList();
		selected = -1;
        buttonGroup = new ButtonGroup();
		listenerList = new EventListenerList();
	}

	public JRadioButton add(String label) {
		JRadioButton radioButton = new JRadioButton(label);
		add(radioButton);
        final int nr = buttons.size();
		buttons.add(radioButton);
        buttonGroup.add(radioButton);
		radioButton.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent evt) {
                if (evt.getStateChange() == ItemEvent.SELECTED) {
                    selected = nr;
				    SwingUtils.fireChangeEvent(listenerList, RadioButtonsPanel.this);
                }
			}
		});
		return radioButton;
	}

	public JRadioButton add(String label, int mnemonic) {
		JRadioButton radioButton = add(label);
		radioButton.setMnemonic(mnemonic);
		return radioButton;
	}

	public JRadioButton add(String label, char mnemonic) {
		JRadioButton radioButton = add(label);
		radioButton.setMnemonic(mnemonic);
		return radioButton;
	}

	public void setSelected(int nr) {
		if (selected != -1)
			((AbstractButton) buttons.get(selected)).setSelected(false);
		selected = nr;
		((AbstractButton) buttons.get(selected)).setSelected(true);
	}

	public int getSelected() {
		return selected;
	}

	public void addChangeListener(ChangeListener listener) {
		listenerList.add(ChangeListener.class, listener);
	}
}
