/*
 * Project: GMT - Guideline Markup Tool / Version: 2.7.3.#452
 * User: peter
 * Date: 09.05.2003
 * Time: 16:53:35
 */
package at.ac.tuwien.asgaard.swing;

import at.ac.tuwien.asgaard.delta.util.GlobalObjects;

import java.awt.*;

import javax.swing.*;
import javax.swing.border.*;

/**
 * Class SimpleListCellRenderer ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.3.0
 * @see javax.swing.DefaultListCellRenderer
 */
public class SimpleListCellRenderer extends JLabel implements ListCellRenderer {
	private static final Border NO_FOCUS_BORDER = new EmptyBorder(1, 1, 1, 1),
						FOCUS_BORDER = new LineBorder(Color.BLACK, 1); //UIManager.getBorder("List.focusCellHighlightBorder");

	protected String text;
	private static final Dimension preferredSize = new Dimension(60,18);

	public SimpleListCellRenderer() {
		super();
		setOpaque(true);
	}

	public Component getListCellRendererComponent(JList list, Object value, int index,
												  boolean isSelected, boolean cellHasFocus) {
		text = getLabel(index, value);

		if (isSelected) {
			setBackground(list.getSelectionBackground());
			setForeground(list.getSelectionForeground());
			setFont(GlobalObjects.BOLD_FONT);
		} else {
			setBackground(list.getBackground());
			setForeground(list.getForeground());
			setFont(GlobalObjects.DEFAULT_FONT);
		}
		setText(text);
		setBorder(cellHasFocus ? FOCUS_BORDER : NO_FOCUS_BORDER);

		return this;
	}

	protected String getLabel(final int index, Object value) {
		return value.toString();
	}

	public final Dimension getPreferredSize() {
		if (text != null) // should not happen, but already happened
			preferredSize.width = getFontMetrics(GlobalObjects.BOLD_FONT).stringWidth(text) + 23; // icon-width (16) + iconTextGap (4) + text + insets (2)
		return preferredSize;
	}

	public final void validate() { }

	public final void revalidate() { }

	public final void repaint(long tm, int x, int y, int width, int height) { }

	public final void repaint(Rectangle r) { }

	protected final void firePropertyChange(String propertyName, Object oldValue, Object newValue) {
		// Strings get interned...
		if (propertyName == "text") super.firePropertyChange(propertyName, oldValue, newValue);
	}

	public final void firePropertyChange(String propertyName, byte oldValue, byte newValue) { }

	public final void firePropertyChange(String propertyName, char oldValue, char newValue) { }

	public final void firePropertyChange(String propertyName, short oldValue, short newValue) { }

	public final void firePropertyChange(String propertyName, int oldValue, int newValue) { }

	public final void firePropertyChange(String propertyName, long oldValue, long newValue) { }

	public final void firePropertyChange(String propertyName, float oldValue, float newValue) { }

	public final void firePropertyChange(String propertyName, double oldValue, double newValue) { }

	public final void firePropertyChange(String propertyName, boolean oldValue, boolean newValue) { }
}
