package at.ac.tuwien.asgaard.swing;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 * Class StringEditDialog. ... todo
 *
 * @version 2.7.3
 * @author Peter Votruba
 */
public class TextEditDialog extends AbstractInputDialog {
	protected JTextArea textField;

	public TextEditDialog(Component parentComponent) {
		this(parentComponent, null);
	}

	public TextEditDialog(Component parentComponent, String title) {
		this(parentComponent, (title == null) ? "Edit text value ..." : title, false, false, 250, 200, 200, 150, 0, 0);
	}
	public TextEditDialog(Component parentComponent, String title,
						  boolean useHelpButton, boolean useApplyButton, final int INIT_WIDTH, final int INIT_HEIGHT,
						  int minWidth, int minHeight, int maxWidth, int maxHeight) {
		super(parentComponent, title, useApplyButton, useHelpButton, INIT_WIDTH, INIT_HEIGHT, minWidth, minHeight, maxWidth, maxHeight);

		textField.setLineWrap(true);
		textField.setWrapStyleWord(true);
		textField.getKeymap().addActionForKeyStroke(KeyStroke.getKeyStroke(KeyEvent.VK_ENTER, 0), okAction);

		addWindowListener(new WindowAdapter() {
			public void windowActivated(WindowEvent e) {
				textField.requestFocusInWindow();
			}
		});
	}

	protected Component createMainComponent() {
		textField = new JTextArea();
		return new JScrollPane(textField);
	}

	public String getText() {
		return textField.getText();
	}

	public String showEditDialog() {
	    return showEditDialog("");
	}
	public String showEditDialog(String initialValue) {
		textField.setText(initialValue);
		return (showDialog() ? textField.getText() : null);
	}
	public String showEditDialog(String initialValue, String newTitle) {
		setTitle(newTitle);
		return showEditDialog(initialValue);
	}

	public static String showEditDialog(Component parentComponent) {
		return new TextEditDialog(parentComponent).showEditDialog();
	}
}
