package at.ac.tuwien.asgaard.swing.autoComplete;

import java.awt.event.*;
import java.io.Serializable;

import javax.swing.*;
import javax.swing.table.*;

public class AutoCompleteComboBoxCellEditor extends AbstractCellEditor
		implements ActionListener, TableCellEditor, Serializable/*, ItemListener*/ {
    protected AutoCompleteComboBox comboBox;

	public AutoCompleteComboBoxCellEditor() {
		this(new AutoCompleteComboBox());
	}

    public AutoCompleteComboBoxCellEditor(AutoCompleteComboBox comboBox) {
        this.comboBox = comboBox;
        this.comboBox.putClientProperty("JComboBox.isTableCellEditor", Boolean.TRUE);
        // hitting enter in the combo box should stop cellediting (see below)
        this.comboBox.addActionListener(this);
   //     this.comboBox.addItemListener(this);
        // remove the editor's border - the cell itself already has one
        ((JComponent) comboBox.getEditor().getEditorComponent()).setBorder(null);
    }
    
    private void setValue(Object value) {
        comboBox.setSelectedItem(value);
    }
    
    // Implementing ActionListener
    public void actionPerformed(java.awt.event.ActionEvent e) {
		// Selecting an item results in an actioncommand "comboBoxChanged".
		// We should ignore these ones.

		// Hitting enter results in an actioncommand "comboBoxEdited"
        if(e.getActionCommand().equals("comboBoxEdited"))
            stopCellEditing();
    }

//    public void itemStateChanged(ItemEvent e) {
//        stopCellEditing();
//    }

    // Implementing CellEditor
    public Object getCellEditorValue() {
        return comboBox.getSelectedItem();
    }
    
    public boolean stopCellEditing() {
        if (comboBox.isEditable())
            // Notify the combo box that editing has stopped (e.g. User pressed F2)
            comboBox.actionPerformed(new ActionEvent(this, 0, ""));
        fireEditingStopped();
        return true;
    }
    
    // Implementing TableCellEditor
    public java.awt.Component getTableCellEditorComponent(javax.swing.JTable table, Object value, boolean isSelected, int row, int column) {
        setValue(value);
        comboBox.repaint();
        return comboBox;
    }

	// delegate methods to AutoCompleteComboBox
	public void setRestrictValues(boolean restrictValues) {
		comboBox.setRestrictValues(restrictValues);
	}
	public void init(Object[] items, Object selectedItem) {
		comboBox.init(items, selectedItem);
	}
}