/*
 * Created by Peter for Project GMT.
 * Date: Nov 9, 2002
 * Time: 11:50:29 AM
 */
package at.ac.tuwien.asgaard.swing.models;

import javax.swing.*;
import java.util.Collection;

/**
 * Class FixedComboBoxModel. ... todo
 *
 * @version 2.7.3
 * @author Peter Votruba
 * @since JDK 1.3.1
 */
public class FixedComboBoxModel extends AbstractListModel implements ComboBoxModel {
	private Object[] data;
	private Object selectedObject;

	public FixedComboBoxModel() {
		this(new Object[0]);
	}
	public FixedComboBoxModel(Object[] data) {
		this(data, true);
	}
	public FixedComboBoxModel(Object[] data, boolean selectFirstItem) {
		this.data = data;
		if ((getSize() > 0) && selectFirstItem)
			selectedObject = data[0];
	}
	public FixedComboBoxModel(Object[] data, Object selection) {
		this.data = data;
		selectedObject = selection;
	}

	public void init(Object[] data) {
		init(data, false);
	}
	public void init(Object[] data, boolean selectFirstItem) {
		this.data = data;
		selectedObject = ((getSize() > 0) && selectFirstItem) ? data[0] : null;
		fireContentsChanged(this, -1, -1);
	//	fireContentsChanged(this, 0, getSize() - 1);
	}
	public void init(Object[] data, Object selection) {
		this.data = data;
		selectedObject = selection;
		fireContentsChanged(this, -1, -1);
      //  fireContentsChanged(this, 0, getSize()-1);
	}

	public void init(Collection data) {
		init(data.toArray());
	}
	public void init(Collection data, boolean selectFirstItem) {
		init(data.toArray(), selectFirstItem);
	}
	public void init(Collection data, Object selection) {
		init(data.toArray(), selection);
	}

	public void setSelectedItem(Object anObject) {
		if (((selectedObject != null) && (selectedObject != anObject)) ||
		        ((selectedObject == null) && (anObject != null))) {
			selectedObject = anObject;
			fireContentsChanged(this, -1, -1);
		}
	}

	public Object getSelectedItem() {
		return selectedObject;
	}

	public int getSize() {
		if (data == null)
			return 0;
		return data.length;
	}

	public Object getElementAt(int index) {
		if (data == null)
			return null;
		return data[index];
	}
}
