/*
 * Project "Guideline Markup Tool"
 * Author: Peter
 * Date: Sep 27, 2002
 * Time: 12:38:05 AM
 */
package at.ac.tuwien.asgaard.swing.models;

import javax.swing.text.*;
import java.awt.*;

/**
 * Class NumberDocument. ... todo
 *
 * @version 2.7.3
 * @author Peter Votruba
 * @since JDK 1.3.1
 */
public class FixedLengthDocument extends AbstractDocument {
	private final int maxLength;

	private final BranchElement defaultRoot ;
	public FixedLengthDocument(int maxLength) {
		super(new GapContent(), StyleContext.getDefaultStyleContext());
		defaultRoot = (BranchElement)createBranchElement(null, null);
		defaultRoot.replace(0, 0, new Element[]{new LeafElement(defaultRoot, null, 0, 1)});

		this.maxLength = maxLength;
	}

	public Element getDefaultRootElement() {
		return defaultRoot;
	}
	public Element getParagraphElement(int pos) {
		Element lineMap = getDefaultRootElement();
		return lineMap.getElement(lineMap.getElementIndex(pos));
	}

	public void insertString(int offset, String text, AttributeSet attrs)
			throws BadLocationException {
		if ((text == null) || (text.length() == 0))
			return;

		if (text.length() + getLength() <= maxLength) 
			super.insertString(offset, text, attrs);
		else
			Toolkit.getDefaultToolkit().beep();
	}
}
