/*
 * Project: GMT - Guideline Markup Tool / Version: 2.7.3.#452
 * Author: Peter Votruba
 * Date: 27.06.2003
 * Time: 17:42:26
 */
package at.ac.tuwien.asgaard.swing.models;

import javax.swing.AbstractListModel;

/**
 * Class FixedListModel ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.3.0
 */
public class FixedListModel extends AbstractListModel {
	private Object[] data;

	public FixedListModel() { }

	public FixedListModel(Object[] data) {
		this.data = data;
	}

	public Object[] getData() {
		return data;
	}
	public void init(Object[] data) {
		if (data != null) {
			this.data = data;
			fireContentsChanged(this, 0, data.length - 1);
		} else {
			int oldSize = getSize();
			this.data = data;
			fireIntervalRemoved(this, 0, oldSize - 1);
		}
	}

	public Object getElementAt(int index) {
		return data[index];
	}

	public int getSize() {
		return (data == null) ? 0 : data.length;
	}
}
