/*
 * Project "Guideline Markup Tool"
 * Author: Peter
 * Date: Sep 27, 2002
 * Time: 12:38:05 AM
 */
package at.ac.tuwien.asgaard.swing.models;

import javax.swing.text.*;
import java.awt.*;

/**
 * Class NumberDocument. ... todo
 *
 * @version 2.7.3
 * @author Peter Votruba
 * @since JDK 1.3.1
 */
public class NumberDocument extends AbstractDocument {
	private final BranchElement defaultRoot ;
	public NumberDocument() {
		super(new GapContent(), StyleContext.getDefaultStyleContext());
		defaultRoot = (BranchElement)createBranchElement(null, null);
		defaultRoot.replace(0, 0, new Element[]{new LeafElement(defaultRoot, null, 0, 1)});
	}

	public Element getDefaultRootElement() {
		return defaultRoot;
	}
	public Element getParagraphElement(int pos) {
		Element lineMap = getDefaultRootElement();
		return lineMap.getElement(lineMap.getElementIndex(pos));
	}

	public void insertString(int offset, String text, AttributeSet attrs)
			throws BadLocationException {
		if ((text == null) || (text.length() == 0)) 
			return;

		char[] source = text.toCharArray();
		char[] result = new char[source.length];
		int j = 0;

		for (int i = 0; i < result.length; i++)
			if (Character.isDigit(source[i]))
				result[j++] = source[i];
		if (j == 0)
			Toolkit.getDefaultToolkit().beep();
		else
			super.insertString(offset, new String(result, 0, j), attrs);
	}
}
