/*
 * Project: GMT - Guideline Markup Tool / Version: 2.7.3.#452
 * Author: Peter Votruba
 * Date: 10.02.2004
 * Time: 17:09:04
 */
package at.ac.tuwien.asgaard.swing.models;

import javax.swing.*;
import javax.swing.event.ListDataListener;

/**
 * Class ProxyComboBoxModel ... todo
 * 
 * @author Peter Votruba
 * @version 2.7.3.#452
 * @since JDK 1.4.0
 */
public class ProxyComboBoxModel implements ComboBoxModel, ListModel {
	private final ComboBoxModel delegate;

	public ProxyComboBoxModel(ComboBoxModel delegate) {
		this.delegate = delegate;
	}

	public int getSize() {
		return delegate.getSize();
	}

	public Object getElementAt(int index) {
		return delegate.getElementAt(index);
	}

	public void setSelectedItem(Object anItem) {
		delegate.setSelectedItem(anItem);
	}

	public Object getSelectedItem() {
		return delegate.getSelectedItem();
	}

	public void addListDataListener(ListDataListener l) {
		delegate.addListDataListener(l);
	}

	public void removeListDataListener(ListDataListener l) {
		delegate.removeListDataListener(l);  
	}
}