/*
 * Project: GMT - Guideline Markup Tool / Version: 2.7.3.#452
 * User: peter
 * Date: 08.05.2003
 * Time: 18:08:28
 */
package at.ac.tuwien.asgaard.swing.models;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import javax.swing.*;

/**
 * Class SimpleListModel ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.3.0
 */
public final class SimpleListModel extends AbstractListModel {
	private List list;

	public SimpleListModel() {
		list = new ArrayList();
	}

	public SimpleListModel(Collection listData) {
		this.list = new ArrayList(listData);
	}

	public void init(Collection listData) {
		if (getSize() > 0)
			fireIntervalRemoved(this, 0, getSize() - 1);
		this.list = new ArrayList(listData);
		if (getSize() > 0)
			fireIntervalAdded(this, 0, getSize() - 1);
	}
	public List getList() {
		return new ArrayList(list);
	}

	public Object getElementAt(int index) {
		return list.get(index);
	}

	public int getSize() {
		return (list == null) ? 0 : list.size();
	}

	public void add(Object element) {
		if (list == null) list = new ArrayList();
		list.add(element);
		fireIntervalAdded(this, getSize() - 1, getSize() - 1);
	}
	public void add(int index, Object element) {
		if (list == null) list = new ArrayList();
		list.add(index, element);
		fireIntervalAdded(this, index, index);
	}

	public boolean isEmpty() {
		return (getSize() == 0);
	}

	public void remove(int index) {
		list.remove(index);
		fireIntervalRemoved(this, index, index);
	}

	public void clear() {
		int size = getSize();
		if (size > 0) {
			list.clear();
			fireIntervalRemoved(this, 0, size - 1);
		}
	}

	public int indexOf(Object value) {
		if (isEmpty()) return -1;
		return list.indexOf(value);
	}
}
