/*
 * Project: GMT - Guideline Markup Tool / Version: 2.7.3.#452
 * Author: Peter Votruba
 * Date: 11.08.2003
 * Time: 14:55:51
 */
package at.ac.tuwien.asgaard.swing.plaf;

import at.ac.tuwien.asgaard.swing.plaf.LocalAcceleratorMenuItemUI;

import javax.swing.plaf.basic.*;
import javax.swing.plaf.ComponentUI;
import javax.swing.*;
import java.awt.*;

/**
 * Class LocalAcceleratorMenuItemUI ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.3.0
 */
public class LocalAcceleratorRadioButtonMenuItemUI extends BasicRadioButtonMenuItemUI {
	public static ComponentUI createUI(JComponent c) {
		return new LocalAcceleratorRadioButtonMenuItemUI();
	}

	public void paint(Graphics g, JComponent c) {
		JMenuItem menuItem = (JMenuItem) c;
		Action action = menuItem.getAction();
		KeyStroke keyStroke = (KeyStroke) action.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY);
		if (keyStroke == null)
			paintMenuItem(g, c, checkIcon, arrowIcon,
						  selectionBackground, selectionForeground,
						  defaultTextIconGap);
		else {
			menuItem.setAccelerator(keyStroke);
			paintMenuItem(g, c, checkIcon, arrowIcon,
						  selectionBackground, selectionForeground,
						  defaultTextIconGap);
			menuItem.setAccelerator(null);
		}
	}

	public Dimension getPreferredSize(JComponent c) {
		JMenuItem menuItem = (JMenuItem) c;
		Action action = menuItem.getAction();
		KeyStroke keyStroke = (KeyStroke) action.getValue(LocalAcceleratorMenuItemUI.LOCAL_ACCELERATOR_KEY);
		if (keyStroke == null)
			return getPreferredMenuItemSize(c, checkIcon, arrowIcon, defaultTextIconGap);
		else {
			menuItem.setAccelerator(keyStroke);
			Dimension preferredMenuItemSize = getPreferredMenuItemSize(c, checkIcon, arrowIcon, defaultTextIconGap);
			menuItem.setAccelerator(null);
			return preferredMenuItemSize;
		}
	}
}
