/*
 * Project: GMT - Guideline Markup Tool / Version: 2.7.3.#452
 * User: peter
 * Date: 13.05.2003
 * Time: 10:53:26
 */
package at.ac.tuwien.asgaard.swing.selectable;

import java.awt.event.ActionEvent;
import java.awt.event.InputEvent;

import javax.swing.*;
import javax.swing.event.ChangeEvent;

/**
 * Class RadioButtonAbstractAction ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.3.0
 */
public abstract class CheckBoxAbstractAction extends AbstractAction implements SelectableAction {
	/**
	 * Specifies whether this action is selected; the default is false.
	 */
	protected boolean selected = false;

	protected CheckBoxAbstractAction() { }

	protected CheckBoxAbstractAction(String name) {
		super(name);
	}

	protected CheckBoxAbstractAction(String name, Icon icon) {
		super(name, icon);
	}

	protected CheckBoxAbstractAction(boolean selected) {
		this.selected = selected;
	}

	protected CheckBoxAbstractAction(String name, boolean selected) {
		super(name);
		this.selected = selected;
	}

	protected CheckBoxAbstractAction(String name, Icon icon, boolean selected) {
		super(name, icon);
		this.selected = selected;
	}

	public final boolean isSelected() {
		return selected;
	}

	public final void setSelected(boolean newValue) {
		boolean oldValue = selected;
		if (oldValue != newValue) {
			selected = newValue;
			firePropertyChange(SelectableAction.SELECTED_KEY, Boolean.valueOf(oldValue), Boolean.valueOf(newValue));
            stateChanged(new ChangeEvent(this));
		}
	}

    public final void setSelectedState(boolean newValue) {
        boolean oldValue = selected;
        if (oldValue != newValue) {
            selected = newValue;
            firePropertyChange(SelectableAction.SELECTED_KEY, Boolean.valueOf(oldValue), Boolean.valueOf(newValue));
        }
    }

	public final void actionPerformed(ActionEvent evt) {
		if ((evt.getModifiers() != InputEvent.BUTTON1_MASK) && (evt.getModifiers() != 0))
			setSelected(!selected);
	}
}
