/*
 * Project: GMT - Guideline Markup Tool / Version: 2.7.3.#452
 * User: peter
 * Date: 13.05.2003
 * Time: 11:03:40
 */
package at.ac.tuwien.asgaard.swing.selectable;

import javax.swing.*;
import java.beans.*;
import java.awt.event.*;

/**
 * Class SelectableCheckBoxMenuItem ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.3.0
 */
public final class SelectableCheckBoxMenuItem extends JCheckBoxMenuItem {
	private boolean externalChange;

	public SelectableCheckBoxMenuItem(final SelectableAction action) {
		super(null, null, action.isSelected());

		externalChange = true;

		setAction(action);

		action.addPropertyChangeListener(new PropertyChangeListener() {
			public void propertyChange(PropertyChangeEvent evt) {
				if (externalChange && (evt.getPropertyName() == SelectableAction.SELECTED_KEY)) {
					externalChange = false;
					setSelected(((Boolean)evt.getNewValue()).booleanValue());
					externalChange = true;
				}
			}
		});

		addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent evt) {
				if (externalChange) {
					externalChange = false;
					try {
						action.setSelected(isSelected());
					} finally {
						externalChange = true;
					}
				}
			}
		});
	}
}