/*
 * Project: GMT - Guideline Markup Tool / Version: 2.7.3.#452
 * User: peter
 * Date: 13.05.2003
 * Time: 12:06:03
 */
package at.ac.tuwien.asgaard.swing.selectable;

import javax.swing.*;
import java.beans.*;
import java.awt.event.*;

/**
 * Class SelectableRadioButtonMenuItem ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.3.0
 */
public final class SelectableRadioButtonMenuItem extends JRadioButtonMenuItem {
	private boolean externalChange;

	public SelectableRadioButtonMenuItem(final SelectableAction action) {
		super(null, null, action.isSelected());

		externalChange = true;

		setAction(action);

		action.addPropertyChangeListener(new PropertyChangeListener() {
			public void propertyChange(PropertyChangeEvent evt) {
				if (externalChange && evt.getPropertyName().equals(SelectableAction.SELECTED_KEY)) {
					externalChange = false;
					setSelected(((Boolean)evt.getNewValue()).booleanValue());
					externalChange = true;
				}
			}
		});

		addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent evt) {
				if (externalChange) {
					externalChange = false;
					action.setSelected(isSelected());
					externalChange = true;
				}
			}
		});
	}
}