/*
 * Project: Asgaard - Guideline Markup Tool
 * Class: DefaultFileFilter
 * User: Peter
 * Date: 18.06.2003
 * Time: 00:23:50
 */

package at.ac.tuwien.asgaard.util;

import java.io.File;

import javax.swing.filechooser.*;

/**
 * Class DefaultFileFilter ... todo
 */
public class DefaultFileFilter extends FileFilter {
	protected String extension, description;

	public DefaultFileFilter(String extension) {
		this(extension, extension);
	}
	public DefaultFileFilter(String extension, String name) {
        if (extension.charAt(0) != '.') extension = "." + extension;
        this.extension = extension.trim();
        description = name.trim() + " Files (*" + this.extension + ")";
	}

	public String getDescription() {
		return description;
	}

	public boolean accept(File file) {
		return (file.isDirectory() || file.getPath().endsWith(extension));
	}

    public String getExtension() {
        return extension;
    }
}
