/*
 * Project: GMT - Guideline Markup Tool / Version: 2.7.3.#452
 * Author: Peter Votruba
 * Date: 04.09.2003
 * Time: 17:46:29
 */
package at.ac.tuwien.asgaard.util;

import java.util.*;

/**
 * Class ListMap ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since Java 1.5
 */
public class ListMap<K,V> extends HashMap<K,List<V>> {
//    public void add(int key, Object value) {
//        add(new Integer(key), value);
//    }

    public void add(K key, V value) {
/*  if (value instanceof Element) {
			Element elem = (Element) value;
			int startPos = elem.getStartOffset();
			int endPos = elem.getEndOffset();
			try {
				System.out.println("kit.map.add linkID: " + key + " elem: " + Integer.toHexString(elem.hashCode()) + " startPos: " + startPos + ", endPos: " + endPos + " - <" + elem.getDocument().getText(startPos, endPos - startPos) + ">");
			} catch (BadLocationException e) { }
		} else
			System.out.println("kit.map.add linkID: " + key + " node: " + Integer.toHexString(value.hashCode()));*/

        List<V> list = get(key);
        if (list == null) {
            list = createNewList();
            list.add(value);
            put(key, list);
        } else
            list.add(value);
    }

	protected List<V> createNewList() {
		return new ArrayList<V>();
	}

//    public void addAll(int key, List newValues) {
//        addAll(new Integer(key), newValues);
//    }

    public void addAll(K key, List<V> newValues) {
        List<V> list = get(key);
        if (list == null)
            put(key, newValues);
        else
            list.addAll(newValues);
    }

	public List<V> getAll() {
		List<V> result = new ArrayList<V>(size() + 2);
	// Collection<List<V>> values = values();
		for (Iterator<List<V>> iter = values().iterator(); iter.hasNext();) {
			List<V> list = iter.next();
			result.addAll(list);
		}
		return result;
	}

//    public List getList(int key) {
//        return (List)get(new Integer(key));
//    }

    public List<V> getList(K key) {
        return get(key);
    }

//    public int getListSize(int xmlLinkID) {
//        List list = (List)get(new Integer(xmlLinkID));
//        return ((list == null) ? 0 : list.size());
//    }

    public int getListSize(K xmlLinkID) {
        List<V> list = get(xmlLinkID);
        return ((list == null) ? 0 : list.size());
    }

//    public boolean containsKey(int key) {
//        return containsKey(new Integer(key));
//    }

//    public boolean remove(int key, Object value) {
//        return remove(new Integer(key), value);
//    }

    /**
	 * Removes value from the list associated with key in this map.
	 * @param key of the list that contains value
	 * @param value to be removed
	 * @return if there is no value left
	 */
    public boolean remove(K key, V value) {
        List<V> list = get(key);
        if (list != null) {
            list.remove(value);
            if (list.isEmpty()) {
                remove(key);
                return true;
            }
        }
        return false;
    }

// public void removeAll(int key, List values) {
//  removeAll(new Integer(key), values);
// }

	public void removeAll(K key, List values) {
		List<V> list = get(key);
		if (list != null) {
			list.removeAll(values);
			if (list.isEmpty())
				remove(key);
		}
	}

//    public Object remove(int key) {
//        return remove(new Integer(key));
//    }

//    public void changeKey(int oldKey, int newKey, Object value) {
//        remove(new Integer(oldKey), value);
//        add(new Integer(newKey), value);
//    }

    public void changeKey(K oldKey, K newKey, V value) {
        remove(oldKey, value);
        add(newKey, value);
    }
}
