/*
 * Created by Peter for Project "Guideline Markup Tool".
 * Date: Dec 9, 2002
 * Time: 1:13:40 PM
 */
package at.ac.tuwien.asgaard.util;

import java.util.*;

/** 
 * Class SortedListMap. ... todo
 *
 * @version 2.7.3
 * @author Peter Votruba
 * @since JDK 1.3.0
 */
public final class SortedListMap<K,V> extends ListMap<K, V> {
	protected final Comparator<V> comp;

	public SortedListMap() {
		comp = new Comparator<V>() {
			public int compare(V o1, V o2) {
				return ((Comparable)o1).compareTo(o2);
			}
		};
	}

	public SortedListMap(Comparator<V> comp) {
		this.comp = comp;
	}

	protected List<V> createNewList() {
		return new SortedList<V>(comp);
	}
	
	public List<V> getAll() {
		List<V> result = new ArrayList<V>(size() + 2);
		Object keys[] = keySet().toArray();
		Arrays.sort(keys);
		for (int i = 0; i < keys.length; i++) {
			List<V> list = (List<V>) get(keys[i]);
			result.addAll(list);
		}
		return result;
	}
}
