package at.ac.tuwien.asgaard.util.xml;

import at.ac.tuwien.asgaard.delta.xmlBeans.xmlLanguage.XmlLanguage;
import at.ac.tuwien.asgaard.util.DefaultFileFilter;
import at.ac.tuwien.asgaard.util.FileUtils;
import net.socialchange.doctype.Doctype;
import net.socialchange.doctype.DoctypeParser;

import java.io.File;
import java.io.IOException;

public class DocTypeFileFilter extends DefaultFileFilter {
	private final XmlLanguage xmlLanguage;

	public DocTypeFileFilter(XmlLanguage xmlLanguage) {
		super(xmlLanguage.getExt(), xmlLanguage.getName());
		this.xmlLanguage = xmlLanguage;
	}

	public XmlLanguage getXmlLanguage() {
		return xmlLanguage;
	}

	public boolean accept(File file) {
		if (file.isDirectory()) return true;
		if (!file.getPath().endsWith(extension)) return false;
		try {
			Doctype dt = DoctypeParser.parse(file);
			if (dt == null) return false;
			if (xmlLanguage.getDtd().getRootElement().equals(dt.getRootElement())) {
				String systemId = FileUtils.getFileNameExt(dt.getSystemId());
				if (systemId.equalsIgnoreCase(FileUtils.getFileNameExt(xmlLanguage.getDtd().getNewFileName()))
						|| (systemId.equalsIgnoreCase(FileUtils.getFileNameExt(xmlLanguage.getDtd().getOldFileName()))))
					return true;
			}
			return false;
		} catch (IOException exc) {
			return false;
		}
	}
}
