<?xml version="1.0"?>
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:file="java:java.io.File">
	<xsl:output method="html"/>
	<xsl:strip-space elements="*"/>
	<xsl:variable name="filename" select="file:getName(file:new(string(/dtd/@sysid)))"/>
	<xsl:template match="dtd">
		<html>
			<head>
				<title>HTML source of "<xsl:value-of select='$filename'/>"
				</title>
				<style type="text/css">
                    .element_def { color:purple }
                    .element_name { color:purple; font-weight:bold }
                    .element_model { color:maroon; font-style:italic }
                    .attr_def { color:navy }
                    .attr_name { color:navy; font-weight:bold }
                    .attr_def_type { color:green }
                    .attr_val_type { color:olive }
                    .comment { color:#808080 }
                    .symbol { color:blue }
				</style>
			</head>
			<body> <!--bgcolor="#F0F0F0"-->
				<h2>HTML source of "<i><xsl:value-of select='$filename'/></i>"</h2>
				<xsl:text> </xsl:text>
				<hr size="5"/>
				<xsl:text> </xsl:text>
				<xsl:apply-templates/>
			</body>
		</html>
	</xsl:template>

	<xsl:template match="comment">
		<xsl:if test="(position()!=1) and (name(./following-sibling::*[1])='contentModel')">
			<br/>
			<xsl:text> </xsl:text>
		</xsl:if>
		<font class="comment">&lt;!--
			<xsl:value-of select="."/>--&gt;
		</font>
		<xsl:text> </xsl:text>
		<br/>
		<xsl:text> </xsl:text>
	</xsl:template>

	<xsl:template match="contentModel[name(./preceding-sibling::*[1])!='comment']">
		<br/>
		<xsl:text> </xsl:text>
	</xsl:template>

	<xsl:template match="elementDecl">
		<a name="{@ename}"/>
		<font class="symbol">&lt;!</font>
		<font class="element_def">ELEMENT</font>
		<xsl:text> </xsl:text>
		<font class="element_name">
			<xsl:value-of select="@ename"/>
		</font>
		<xsl:text> </xsl:text>
		<font class="element_model">
			<xsl:value-of select="replace(replace(./@model,'\|',' | '),',',', ')"/>
		</font>
		<font class="symbol">&gt;</font>
		<xsl:text> </xsl:text>
		<br/>
		<xsl:text> </xsl:text>
	</xsl:template>

	<xsl:template match="attributeDecl">
		<font class="symbol">&lt;!</font>
		<font class="attr_def">ATTLIST </font>
		<xsl:text> </xsl:text>
		<font class="element_name">
			<xsl:value-of select="@ename"/>
		</font>
		<xsl:text> </xsl:text>
		<font class="attr_name">
			<xsl:value-of select="@aname"/>
		</font>
		<xsl:text> </xsl:text>
		<font class="attr_val_type">
			<xsl:value-of select="@atype"/>
		</font>
		<xsl:text> </xsl:text>
		<xsl:value-of select="@default"/>
		<xsl:choose>
			<xsl:when test="@required">
				<xsl:text> </xsl:text>
				<font class="attr_def_type">REQUIRED</font>
			</xsl:when>
			<xsl:when test="@fixed">
				<xsl:text> </xsl:text>
				<font class="attr_def_type">FIXED</font>
			</xsl:when>
			<xsl:otherwise>
				<xsl:if test="not(@default)">
					<xsl:text> </xsl:text>
					<font class="attr_def_type">IMPLIED</font>
				</xsl:if>
			</xsl:otherwise>
		</xsl:choose>
		<font class="symbol">&gt;</font>
		<br/>
		<xsl:text> </xsl:text>
	</xsl:template>
</xsl:stylesheet>