/*
 * Project: GMT - Guideline Markup Tool / Version: 2.7.3.#452
 * Author: Peter Votruba
 * Date: 27.08.2003
 * Time: 13:39:10
 */
package at.ac.tuwien.asgaard.util.xml.xerces;

import org.w3c.dom.Node;
import org.xml.sax.SAXParseException;
import at.ac.tuwien.asgaard.util.MiscUtils;

/**
 * Class ErrorWrapper ... todo
 *
 * @version 2.7.3.#452
 * @author Peter Votruba
 * @since JDK 1.3.0
 */
public final class ErrorWrapper {
	public final boolean error;
	public final String message;  // will be shown as ToolTip

	ErrorWrapper(boolean error, Node node, SAXParseException exc) {
        // warning (!error) is very rare, happens only if "http://apache.org/xml/features/warn-on-duplicate-entitydef"
        // property is set and Xerces' XMLEntityManager recognizes duplicate Entities OR at duplicate Attribute definition  
		this.error = error;
		message = "<html>XML-Parser reports " + (error ? "Error" : "Warning") + " at Element \"<b>" + node.getNodeName() + "\"</b> (line "
				  + exc.getLineNumber() + "/ col. " + exc.getColumnNumber()
				  + ")<br>&nbsp;&nbsp;&nbsp;<i>" + MiscUtils.wrapString(exc.getMessage(), "<br>&nbsp;&nbsp;&nbsp;", 100, 5);
	}
}
